package cn.iocoder.yudao.module.product.vo.product;

import lombok.*;
import java.util.*;
import io.swagger.annotations.*;
import com.alibaba.excel.annotation.ExcelProperty;
import org.springframework.format.annotation.DateTimeFormat;

import static cn.iocoder.yudao.framework.common.util.date.DateUtils.FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND;

/**
* 产品清关费阶梯价格 Response VO
* @author yanghao
*/
@Data
@ApiModel("管理后台 - 产品清关费阶梯价格 Response VO")
public class ProductPriceStepClearanceBackVO {

    @ExcelProperty("")
    @ApiModelProperty(value = "", required = true)
    private Long id;

    @ExcelProperty("产品价格ID")
    @ApiModelProperty(value = "产品价格ID", required = true)
    private Long productId;

    @ExcelProperty("起始数量")
    @ApiModelProperty(value = "起始数量", required = true)
    private java.math.BigDecimal startNum;

    @ExcelProperty("结束数量")
    @ApiModelProperty(value = "结束数量")
    private java.math.BigDecimal endNum;

    @ExcelProperty("数量单位")
    @ApiModelProperty(value = "数量单位")
    private Long weightUnit;

    @ExcelProperty("清关费用")
    @ApiModelProperty(value = "清关费用")
    private java.math.BigDecimal clearancePrice;

    @ExcelProperty("清关金额单位")
    @ApiModelProperty(value = "清关金额单位")
    private Long clearancePriceUnit;

    @ExcelProperty("清关体积单位")
    @ApiModelProperty(value = "清关体积单位")
    private Long clearanceVolumeUnit;

    @ExcelProperty("创建时间")
    @DateTimeFormat(pattern = FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND)
    @ApiModelProperty(value = "创建时间", required = true)
    private Date createTime;

}
