package cn.iocoder.yudao.module.product.convert.product;

import java.util.*;
import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.module.product.dal.dataobject.product.ProductBatchLogDO;
import cn.iocoder.yudao.module.product.vo.product.ProductBatchLogBackVO;
import cn.iocoder.yudao.module.product.vo.product.ProductBatchLogCreateReqVO;
import cn.iocoder.yudao.module.product.vo.product.ProductBatchLogUpdateReqVO;
import org.mapstruct.Mapper;
import org.mapstruct.factory.Mappers;

/**
 * 产品批量操作日志 Convert
 * @author wlh
 */
@Mapper
public interface ProductBatchLogConvert {
    /*****转换MapStruct*****/
    ProductBatchLogConvert INSTANCE = Mappers.getMapper(ProductBatchLogConvert.class);

    /***
     * 创建VO转实体
     * @param bean
     * @return
     */
    ProductBatchLogDO convert(ProductBatchLogCreateReqVO bean);

    /***
     * 修改VO转实体
     * @param bean
     * @return
     */
    ProductBatchLogDO convert(ProductBatchLogUpdateReqVO bean);

    /***
     * 实体转返回VO
     * @param bean
     * @return
    */
    ProductBatchLogBackVO convert(ProductBatchLogDO bean);

    /***
     * 实体列表转返回VO列表
     * @param list
     * @return
     */
    List<ProductBatchLogBackVO> convertList(List<ProductBatchLogDO> list);

    /***
     * 实体分页转返回分页
     * @param page
     * @return
     */
    PageResult<ProductBatchLogBackVO> convertPage(PageResult<ProductBatchLogDO> page);
}
