package cn.iocoder.yudao.module.product.convert.productPriceSnapshot;

import java.util.*;
import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.module.product.dal.dataobject.productPriceSnapshot.ProductPriceSnapshotDO;
import cn.iocoder.yudao.module.product.vo.productPriceSnapshot.ProductPriceSnapshotBackVO;
import cn.iocoder.yudao.module.product.vo.productPriceSnapshot.ProductPriceSnapshotCreateReqVO;
import cn.iocoder.yudao.module.product.vo.productPriceSnapshot.ProductPriceSnapshotUpdateReqVO;
import org.mapstruct.Mapper;
import org.mapstruct.factory.Mappers;

/**
 * 路线价格修改历史 Convert
 * @author wlh
 */
@Mapper
public interface ProductPriceSnapshotConvert {
    /*****转换MapStruct*****/
    ProductPriceSnapshotConvert INSTANCE = Mappers.getMapper(ProductPriceSnapshotConvert.class);

    /***
     * 创建VO转实体
     * @param bean
     * @return
     */
    ProductPriceSnapshotDO convert(ProductPriceSnapshotCreateReqVO bean);

    /***
     * 修改VO转实体
     * @param bean
     * @return
     */
    ProductPriceSnapshotDO convert(ProductPriceSnapshotUpdateReqVO bean);

    /***
     * 实体转返回VO
     * @param bean
     * @return
    */
    ProductPriceSnapshotBackVO convert(ProductPriceSnapshotDO bean);

    /***
     * 实体列表转返回VO列表
     * @param list
     * @return
     */
    List<ProductPriceSnapshotBackVO> convertList(List<ProductPriceSnapshotDO> list);

    /***
     * 实体分页转返回分页
     * @param page
     * @return
     */
    PageResult<ProductPriceSnapshotBackVO> convertPage(PageResult<ProductPriceSnapshotDO> page);
}
