package cn.iocoder.yudao.module.product.dal.dataobject.coupon;

import com.alibaba.excel.annotation.ExcelProperty;
import io.swagger.annotations.ApiModelProperty;
import lombok.*;

import java.math.BigDecimal;
import java.util.*;
import com.baomidou.mybatisplus.annotation.*;

/**
 * 优惠券使用记录 DO
 *
 * @author 系统管理员
 */
@TableName("ecw_coupon_use_record")
@Data
@ToString(callSuper = true)
@Builder
@NoArgsConstructor
@AllArgsConstructor
public class CouponUseRecordDO{

    /**
     * 优惠券使用记录id
     */
    @TableId
    private Long couponUseRecordId;
    /**
     * 客户优惠券id
     */
    private Long couponCustomerId;
    /**
     * 用户ID
     */
    @ApiModelProperty("用户id")
    private Long userId;
    /**
     * 客户id
     */
    @ApiModelProperty("客户id")
    private Long customerId;
    /**
     * 订单流水号
     */
    @ApiModelProperty("订单编号")
    private String orderNumber;
    /**
     * 金额
     */
    @ApiModelProperty("优惠金额")
    private BigDecimal amount;
    /**
     * 使用时间
     */
    @ApiModelProperty("使用时间")
    private Date useTime;
    /**
     * 使用状态(1:冻结 2:已使用)
     */
    @ApiModelProperty("使用状态(1:冻结 2:已使用)")
    private Integer status;

}
