package cn.iocoder.yudao.module.product.dal.dataobject.product;

import cn.iocoder.yudao.framework.mybatis.core.dataobject.BaseDO;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import lombok.*;

import javax.persistence.Column;
import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Date;

/**
 * 产品价格 DO
 *
 * @author wlh
 */
@TableName("ecw_product_price")
@Data
@EqualsAndHashCode(callSuper = true)
@ToString(callSuper = true)
@Builder
@NoArgsConstructor
@AllArgsConstructor
public class ProductPriceDO extends BasePrice implements Serializable {
    /**
     *
     */
    @TableId
    private Long id;
    /**
     * 产品ID
     */
    private Long productId;
    /**
     * 线路ID
     */
    private Long warehouseLineId;

    /**
     * 出货渠道ID
     */
    private Long shippingChannelId;

    /**
     * 是否需要预约入仓，0-否，1-是
     */
    private Integer needBook;


    /**
     * 是否需要单询 0-否，1-是
     */
    private Integer needOrderInquiry;

    /**
     * 每日入仓上限
     */
    private BigDecimal dayLimit;

    /**
     * 默认货柜位置，字典container_location
     */
    private String containerLocation;

    /**
     * 默认方数
     */
    private BigDecimal square;

    /**
     * 黑名单，0-否，1-是
     */
    private Integer blacklist;

    /**
     * 审核状态，0-已审核，1-未审核
     */
    private Integer auditStatus;

    /**
     * 代收货款，0-不支持，1-支持
     */
    private Integer payDelivery;

    /**
     * 是否需要预付，0-不需要，1-需要
     */
    private Integer needPay;

    /**
     * 是否阶梯定价，0-不是，1-是
     */
    private Integer stepPrice;

    /**
     * 最小计费重量
     */
    private BigDecimal minWeight;

    /**
     * 最小计费重量单位
     */
    private Long minWeightUnit;


    /**
     * 单价模式，0-运费+清关费，1-全包价
     */
    private Integer priceType;


    /**
     * 是否展示 默认为展示
     */
    private Integer status;


    /**
     * 有效开始时间
     */
    private Date validateStartDate;

    /**
     * 重量上限
     */
    private BigDecimal weightLimit;

    /**
     * 有效结束时间
     */
    private Date validateEndDate;

    @TableField(exist = false)
    private Long oldId;

    @TableField(exist = false)
    private Long originId;

}
