package cn.iocoder.yudao.module.product.dal.dataobject.product;

import cn.iocoder.yudao.framework.mybatis.core.dataobject.BaseDO;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import lombok.*;

/**
 * 产品阶梯价格 DO
 *
 * @author jiuping
 */
@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
@TableName("ecw_product_price_step_clearance")
@EqualsAndHashCode
@ToString
public class ProductPriceStepClearanceDO extends BaseDO {

    /**
     *
     */
    @TableId
    private Long id;

    /**
     * 产品ID
     */
    private Long productId;


    /**
     * 起始数量
     */
    private java.math.BigDecimal startNum;
    /**
     * 结束数量
     */
    private java.math.BigDecimal endNum;
    /**
     * 数量单位
     */
    private Long weightUnit;


    /**
     * 清关费用
     */
    private java.math.BigDecimal clearancePrice;
    /**
     * 清关金额单位
     */
    private Long clearancePriceUnit;
    /**
     * 清关体积单位
     */
    private Long clearanceVolumeUnit;


}
