package cn.iocoder.yudao.module.product.dal.dataobject.product;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import lombok.*;

import java.util.List;

/**
 * 产品阶梯价格 DO
 *
 * @author jiuping
 */
@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
@TableName("ecw_product_price_step")
@EqualsAndHashCode(callSuper = true)
@ToString(callSuper = true)
public class ProductPriceStepDO extends BasePrice {

    /**
     *
     */
    @TableId
    private Long id;

    /**
     * 产品价格ID
     */
    private Long productPriceId;


    /**
     * 起始数量
     */
    private java.math.BigDecimal startNum;
    /**
     * 结束数量
     */
    private java.math.BigDecimal endNum;
    /**
     * 数量单位
     */
    private Long weightUnit;

    /**
     * 价格类型，0-运费，1-全包价,2-清关费
     */
    private Integer priceType;

    /**
     * 阶梯排序
     */
    private Integer rankNum;

    //阶梯价格的特需
    @TableField(exist = false)
    private List<ProductPriceStepSpecialDO> specialList;

    //阶梯价格的包装单位价格
    @TableField(exist = false)
    private List<ProductPriceStepPackagingDO> packagingList;

}
