package cn.iocoder.yudao.module.product.dal.dataobject.productBrandUnauthEmpower;

import lombok.*;
import java.util.*;
import com.baomidou.mybatisplus.annotation.*;
import cn.iocoder.yudao.framework.mybatis.core.dataobject.BaseDO;

/**
 * 商品品牌-未授权客户-指定收费标准 DO
 *
 * @author 江楠
 */
@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
@TableName("ecw_product_brand_unauth_empower")
@EqualsAndHashCode(callSuper = true)
@ToString(callSuper = true)
public class ProductBrandUnauthEmpowerDO extends BaseDO {

    /**
     * 主键
     */
    @TableId
    private Long id;
    /**
     * 商品品牌id
     */
    private Long productBrandId;
    /**
     * 客户id
     */
    private Long customerId;
    /**
     * 客户联系人id
     */
    private Long customerContactsId;
    /**
     * 收费标准 0为无牌收费 1为有牌收费
     *
     * 枚举 {@link TODO customer_charging_model 对应的类}
     */
    private Integer feeScale;
    /**
     * 创建人id
     */
    private Long createUserId;
    /**
     * 创建人用户名
     */
    private String createUsername;

}
