package cn.iocoder.yudao.module.product.dal.dataobject.productbrandempower;

import lombok.*;
import java.util.*;
import com.baomidou.mybatisplus.annotation.*;
import cn.iocoder.yudao.framework.mybatis.core.dataobject.BaseDO;

/**
 * 商品品牌授权 DO
 *
 * @author 江楠
 */
@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
@TableName("ecw_product_brand_empower")
@EqualsAndHashCode(callSuper = true)
@ToString(callSuper = true)
public class ProductBrandEmpowerDO extends BaseDO {

    /**
     * 主键
     */
    @TableId
    private Long id;
    /**
     * 商品品牌id
     */
    private Long productBrandId;
    /**
     * 客户id
     */
    private Long customerId;
    /**
     * 客户联系人id
     */
    private Long customerContactsId;
    /**
     * 授权开始时间
     */
    private Date startTime;
    /**
     * 授权结束时间
     */
    private Date endTime;
    /**
     * 授权文件URL
     */
    private String fileUrl;
    /**
     * 收费标准 0为无牌收费 1为有牌收费
     *
     * 枚举 {@link TODO customer_charging_model 对应的类}
     */
    private Integer feeScale;
    /**
     * 授权状态 1为未授权 0为已授权
     *
     * 枚举 {@link TODO common_status 对应的类}
     */
    private Integer status;
    /**
     * 创建人id
     */
    private Long createUserId;
    /**
     * 创建人用户名
     */
    private String createUsername;
    /**
     * 授权类型
     */
    private Integer authType;

//    /**
//     * 授权人
//     */
//    private String grantName;

}
