package cn.iocoder.yudao.module.product.dal.dataobject.productbrank;

import cn.iocoder.yudao.framework.mybatis.core.dataobject.BaseDO;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import lombok.*;
import org.springframework.format.annotation.DateTimeFormat;

import static cn.iocoder.yudao.framework.common.util.date.DateUtils.FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND;

/**
 * 品牌 DO
 *
 * @author 江楠
 */
@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
@TableName("ecw_product_brank")
@EqualsAndHashCode(callSuper = true)
@ToString(callSuper = true)
public class ProductBrankDO extends BaseDO {

    /**
     * 主键ID
     */
    @TableId
    private Long id;
    /**
     * 品牌中文标题
     */
    private String titleZh;
    /**
     * 品牌英文标题
     */
    private String titleEn;
    /**
     * 品牌法文标题
     */
    private String titleFr;
    /**
     * 排序
     */
    private Integer aorder;
    /**
     * 是否备案，字典
     * <p>
     * 枚举 {@link TODO brand_registry_type 对应的类}
     */
    private String filing;

    /**
     * 未授权客户收费类型：：0统一模式 1单独设置
     */
    private String unauthChargingModel;

    /**
     * 未授权客户默认收费标准
     */
    private String unauthDefaultFeeType;

    @DateTimeFormat(pattern = FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND)
    private java.util.Date createTime;
    private String creator;

    private String creatorName;

    private String updater;

    private String updaterName;

    @DateTimeFormat(pattern = FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND)
    private java.util.Date updateTime;
}
