package cn.iocoder.yudao.module.product.dal.mysql.coupon;

import java.util.*;

import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.framework.mybatis.core.query.LambdaQueryWrapperX;
import cn.iocoder.yudao.framework.mybatis.core.mapper.BaseMapperX;
import cn.iocoder.yudao.module.product.vo.coupon.content.CouponContentExportReqVO;
import cn.iocoder.yudao.module.product.vo.coupon.content.CouponContentPageReqVO;
import cn.iocoder.yudao.module.product.dal.dataobject.coupon.CouponContentDO;
import org.apache.ibatis.annotations.Mapper;

/**
 * 优惠券站内信息关联信息 Mapper
 *
 * @author 系统管理员
 */
@Mapper
public interface CouponContentMapper extends BaseMapperX<CouponContentDO> {

    default PageResult<CouponContentDO> selectPage(CouponContentPageReqVO reqVO) {
        return selectPage(reqVO, new LambdaQueryWrapperX<CouponContentDO>()
                .eqIfPresent(CouponContentDO::getCouponId, reqVO.getCouponId())
                .eqIfPresent(CouponContentDO::getContentZh, reqVO.getContentZh())
                .eqIfPresent(CouponContentDO::getContentEn, reqVO.getContentEn())
                .orderByDesc(CouponContentDO::getCouponContentId));
    }

    default List<CouponContentDO> selectList(CouponContentExportReqVO reqVO) {
        return selectList(new LambdaQueryWrapperX<CouponContentDO>()
                .eqIfPresent(CouponContentDO::getCouponId, reqVO.getCouponId())
                .eqIfPresent(CouponContentDO::getContentZh, reqVO.getContentZh())
                .eqIfPresent(CouponContentDO::getContentEn, reqVO.getContentEn())
                .orderByDesc(CouponContentDO::getCouponContentId));
    }

}
