package cn.iocoder.yudao.module.product.dal.mysql.coupon;

import java.util.*;

import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.framework.mybatis.core.query.LambdaQueryWrapperX;
import cn.iocoder.yudao.framework.mybatis.core.mapper.BaseMapperX;
import cn.iocoder.yudao.module.product.vo.coupon.line.CouponLineExportReqVO;
import cn.iocoder.yudao.module.product.vo.coupon.line.CouponLinePageReqVO;
import cn.iocoder.yudao.module.product.dal.dataobject.coupon.CouponLineDO;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.ResultType;
import org.apache.ibatis.annotations.Select;

/**
 * 优惠券线路关联信息 Mapper
 *
 * @author 系统管理员
 */
@Mapper
public interface CouponLineMapper extends BaseMapperX<CouponLineDO> {

    default PageResult<CouponLineDO> selectPage(CouponLinePageReqVO reqVO) {
        return selectPage(reqVO, new LambdaQueryWrapperX<CouponLineDO>()
                .eqIfPresent(CouponLineDO::getCouponId, reqVO.getCouponId())
                .eqIfPresent(CouponLineDO::getLineId, reqVO.getLineId())
                .eqIfPresent(CouponLineDO::getChannelId, reqVO.getChannelId())
                .orderByDesc(CouponLineDO::getCouponLineId));
    }

    default List<CouponLineDO> selectList(CouponLineExportReqVO reqVO) {
        return selectList(new LambdaQueryWrapperX<CouponLineDO>()
                .eqIfPresent(CouponLineDO::getCouponId, reqVO.getCouponId())
                .eqIfPresent(CouponLineDO::getLineId, reqVO.getLineId())
                .eqIfPresent(CouponLineDO::getChannelId, reqVO.getChannelId())
                .orderByDesc(CouponLineDO::getCouponLineId));
    }

    @ResultType(Long.class)
    @Select("SELECT * FROM ecw_coupon_line WHERE coupon_id = #{couponId}")
    List<CouponLineDO> getLineIdsByCouponId(@Param("couponId") Long couponId);
}
