package cn.iocoder.yudao.module.product.dal.mysql.coupon;

import java.util.*;

import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.framework.mybatis.core.query.LambdaQueryWrapperX;
import cn.iocoder.yudao.framework.mybatis.core.mapper.BaseMapperX;
import cn.iocoder.yudao.module.product.dal.dataobject.product.ProductDO;
import cn.iocoder.yudao.module.product.dal.dataobject.coupon.CouponDO;
import cn.iocoder.yudao.module.product.dto.CouponAvailableDto;
import cn.iocoder.yudao.module.product.dto.CouponUserAvailableDto;
import cn.iocoder.yudao.module.product.param.ProdConditionParam;
import cn.iocoder.yudao.module.product.vo.coupon.CouponExportReqVO;
import cn.iocoder.yudao.module.product.vo.coupon.CouponPageReqVO;
import com.baomidou.mybatisplus.core.metadata.IPage;
import org.apache.ibatis.annotations.*;

/**
 * 优惠券信息 Mapper
 *
 * @author 系统管理员
 */
@Mapper
public interface CouponMapper extends BaseMapperX<CouponDO> {

    default PageResult<CouponDO> selectPage(CouponPageReqVO reqVO) {
        return selectPage(reqVO, new LambdaQueryWrapperX<CouponDO>()
                .eqIfPresent(CouponDO::getTitleZh, reqVO.getTitleZh())
                .eqIfPresent(CouponDO::getTitleEn, reqVO.getTitleEn())
                .eqIfPresent(CouponDO::getType, reqVO.getType())
                .eqIfPresent(CouponDO::getCashCondition, reqVO.getCashCondition())
                .eqIfPresent(CouponDO::getReduceAmount, reqVO.getReduceAmount())
                .eqIfPresent(CouponDO::getConditionCurrencyId, reqVO.getConditionCurrencyId())
                .betweenIfPresent(CouponDO::getStartTime, reqVO.getBeginStartTime(), reqVO.getEndStartTime())
                .eqIfPresent(CouponDO::getReduceCurrencyId, reqVO.getReduceCurrencyId())
                .betweenIfPresent(CouponDO::getEndTime, reqVO.getBeginEndTime(), reqVO.getEndEndTime())
                .eqIfPresent(CouponDO::getAfterReceiveDays, reqVO.getAfterReceiveDays())
                .eqIfPresent(CouponDO::getValidDays, reqVO.getValidDays())
                .eqIfPresent(CouponDO::getCostType, reqVO.getCostType())
                .eqIfPresent(CouponDO::getDiscountDetailed, reqVO.getDiscountDetailed())
                .eqIfPresent(CouponDO::getIsSimilarSuperposition, reqVO.getIsSimilarSuperposition())
                .eqIfPresent(CouponDO::getCouponIds, reqVO.getCouponIds())
                .eqIfPresent(CouponDO::getSuitableUserType, reqVO.getSuitableUserType())
                .eqIfPresent(CouponDO::getSuitableLineType, reqVO.getSuitableLineType())
                .eqIfPresent(CouponDO::getSuitableProdType, reqVO.getSuitableProdType())
                .eqIfPresent(CouponDO::getLimitNum, reqVO.getLimitNum())
                .eqIfPresent(CouponDO::getOverdueStatus, reqVO.getOverdueStatus())
                .eqIfPresent(CouponDO::getPutonStatus, reqVO.getPutonStatus())
                .eqIfPresent(CouponDO::getGetWay, reqVO.getGetWay())
                .eqIfPresent(CouponDO::getOrderAttr, reqVO.getOrderAttr())
                .eqIfPresent(CouponDO::getIsSiteContent, reqVO.getIsSiteContent())
                .eqIfPresent(CouponDO::getBrand, reqVO.getBrand())
                .eqIfPresent(CouponDO::getIsCargoControl, reqVO.getIsCargoControl())
                .eqIfPresent(CouponDO::getDocumentDeclaration, reqVO.getDocumentDeclaration())
                .eqIfPresent(CouponDO::getStatus, reqVO.getStatus())
                .betweenIfPresent(CouponDO::getCreateTime, reqVO.getBeginCreateTime(), reqVO.getEndCreateTime())
                .orderByDesc(CouponDO::getCouponId));
    }

    default List<CouponDO> selectList(CouponExportReqVO reqVO) {
        return selectList(new LambdaQueryWrapperX<CouponDO>()
                .eqIfPresent(CouponDO::getTitleZh, reqVO.getTitleZh())
                .eqIfPresent(CouponDO::getTitleEn, reqVO.getTitleEn())
                .eqIfPresent(CouponDO::getType, reqVO.getType())
                .eqIfPresent(CouponDO::getCashCondition, reqVO.getCashCondition())
                .eqIfPresent(CouponDO::getReduceAmount, reqVO.getReduceAmount())
                .eqIfPresent(CouponDO::getConditionCurrencyId, reqVO.getConditionCurrencyId())
                .betweenIfPresent(CouponDO::getStartTime, reqVO.getBeginStartTime(), reqVO.getEndStartTime())
                .eqIfPresent(CouponDO::getReduceCurrencyId, reqVO.getReduceCurrencyId())
                .betweenIfPresent(CouponDO::getEndTime, reqVO.getBeginEndTime(), reqVO.getEndEndTime())
                .eqIfPresent(CouponDO::getAfterReceiveDays, reqVO.getAfterReceiveDays())
                .eqIfPresent(CouponDO::getValidDays, reqVO.getValidDays())
                .eqIfPresent(CouponDO::getCostType, reqVO.getCostType())
                .eqIfPresent(CouponDO::getDiscountDetailed, reqVO.getDiscountDetailed())
                .eqIfPresent(CouponDO::getIsSimilarSuperposition, reqVO.getIsSimilarSuperposition())
                .eqIfPresent(CouponDO::getCouponIds, reqVO.getCouponIds())
                .eqIfPresent(CouponDO::getSuitableUserType, reqVO.getSuitableUserType())
                .eqIfPresent(CouponDO::getSuitableLineType, reqVO.getSuitableLineType())
                .eqIfPresent(CouponDO::getSuitableProdType, reqVO.getSuitableProdType())
                .eqIfPresent(CouponDO::getLimitNum, reqVO.getLimitNum())
                .eqIfPresent(CouponDO::getOverdueStatus, reqVO.getOverdueStatus())
                .eqIfPresent(CouponDO::getPutonStatus, reqVO.getPutonStatus())
                .eqIfPresent(CouponDO::getGetWay, reqVO.getGetWay())
                .eqIfPresent(CouponDO::getOrderAttr, reqVO.getOrderAttr())
                .eqIfPresent(CouponDO::getIsSiteContent, reqVO.getIsSiteContent())
                .eqIfPresent(CouponDO::getBrand, reqVO.getBrand())
                .eqIfPresent(CouponDO::getIsCargoControl, reqVO.getIsCargoControl())
                .eqIfPresent(CouponDO::getDocumentDeclaration, reqVO.getDocumentDeclaration())
                .eqIfPresent(CouponDO::getStatus, reqVO.getStatus())
                .betweenIfPresent(CouponDO::getCreateTime, reqVO.getBeginCreateTime(), reqVO.getEndCreateTime())
                .orderByDesc(CouponDO::getCouponId));
    }

    default PageResult<CouponDO> selectPageSelect(CouponPageReqVO reqVO) {
        return selectPage(reqVO, new LambdaQueryWrapperX<CouponDO>()
                .eqIfPresent(CouponDO::getTitleZh, reqVO.getTitleZh())
                .eqIfPresent(CouponDO::getTitleEn, reqVO.getTitleEn())
                .eqIfPresent(CouponDO::getType, reqVO.getType())
                .eqIfPresent(CouponDO::getCashCondition, reqVO.getCashCondition())
                .eqIfPresent(CouponDO::getReduceAmount, reqVO.getReduceAmount())
                .eqIfPresent(CouponDO::getConditionCurrencyId, reqVO.getConditionCurrencyId())
                .betweenIfPresent(CouponDO::getStartTime, reqVO.getBeginStartTime(), reqVO.getEndStartTime())
                .eqIfPresent(CouponDO::getReduceCurrencyId, reqVO.getReduceCurrencyId())
                .betweenIfPresent(CouponDO::getEndTime, reqVO.getBeginEndTime(), reqVO.getEndEndTime())
                .eqIfPresent(CouponDO::getAfterReceiveDays, reqVO.getAfterReceiveDays())
                .eqIfPresent(CouponDO::getValidDays, reqVO.getValidDays())
                .eqIfPresent(CouponDO::getCostType, reqVO.getCostType())
                .eqIfPresent(CouponDO::getDiscountDetailed, reqVO.getDiscountDetailed())
                .notInIfPresent(null != reqVO.getIsSimilarSuperposition() && !reqVO.getIsSimilarSuperposition(), CouponDO::getType, reqVO.getType())
                .eqIfPresent(CouponDO::getCouponIds, reqVO.getCouponIds())
                .eqIfPresent(CouponDO::getSuitableUserType, reqVO.getSuitableUserType())
                .eqIfPresent(CouponDO::getSuitableLineType, reqVO.getSuitableLineType())
                .eqIfPresent(CouponDO::getSuitableProdType, reqVO.getSuitableProdType())
                .eqIfPresent(CouponDO::getLimitNum, reqVO.getLimitNum())
                .eqIfPresent(CouponDO::getOverdueStatus, reqVO.getOverdueStatus())
                .eqIfPresent(CouponDO::getPutonStatus, reqVO.getPutonStatus())
                .eqIfPresent(CouponDO::getGetWay, reqVO.getGetWay())
                .eqIfPresent(CouponDO::getOrderAttr, reqVO.getOrderAttr())
                .eqIfPresent(CouponDO::getIsSiteContent, reqVO.getIsSiteContent())
                .eqIfPresent(CouponDO::getBrand, reqVO.getBrand())
                .eqIfPresent(CouponDO::getIsCargoControl, reqVO.getIsCargoControl())
                .eqIfPresent(CouponDO::getDocumentDeclaration, reqVO.getDocumentDeclaration())
                .eqIfPresent(CouponDO::getStatus, reqVO.getStatus())
                .betweenIfPresent(CouponDO::getCreateTime, reqVO.getBeginCreateTime(), reqVO.getEndCreateTime())
                .orderByDesc(CouponDO::getCouponId));
    }

    @ResultType(CouponUserAvailableDto.class)
    @Select({
            "<script>",
            "select c.*, ",
            "c.coupon_id,",
            "cc.status as use_status",
            "from ecw_coupon c ",
            "left join ecw_coupon_customer cc on c.coupon_id = cc.coupon_id ",
//            "left join ecw_coupon_line l on c.coupon_id = l.coupon_id  ",
//            "left join ecw_coupon_prod p on c.coupon_id = p.coupon_id  ",
            "where c.deleted = 0",
            "AND c.status = 1",
            "AND c.overdue_status = 1",
            "AND c.puton_status = 1",
            "AND c.type != 1",
            "AND (c.suitable_user_type = 0 ",
            "<when test = 'userId != null and userId > 0'>",
            "or (c.suitable_user_type = 1 and cc.user_id = #{userId}) ",
            "</when>",
            "<when test = 'consignorCustomerContactsId != null'>",
            "or (c.suitable_user_type = 1 and cc.customer_id = #{consignorCustomerContactsId})",
            "</when>",
            "<when test = 'consigneeCustomerContactsId != null'>",
            "or (c.suitable_user_type = 1 and cc.customer_id = #{consigneeCustomerContactsId})",
            "</when>",
            "<when test = 'userId != null and userId > 0'>",
            "or (c.suitable_user_type = 2 and cc.user_id != #{userId}) ",
            "</when>",
            "<when test = 'consignorCustomerContactsId != null'>",
            "or (c.suitable_user_type = 2 and cc.customer_id != #{consignorCustomerContactsId})",
            "</when>",
            "<when test = 'consigneeCustomerContactsId != null'>",
            "or (c.suitable_user_type = 2 and cc.customer_id != #{consigneeCustomerContactsId})",
            "</when>",
            ")",
            "AND (c.suitable_line_type = 0 ",
            "<choose>",
            "<when test = 'channelId != null and channelId > 0'>",
            "or (c.suitable_line_type = 1 and c.coupon_id in(select l.coupon_id from ecw_coupon_line l where l.line_id =  #{lineId} and l.channel_id = #{channelId}))",
            "</when>",
            "<otherwise>",
            "or (c.suitable_line_type = 1 and c.coupon_id in(select l.coupon_id from ecw_coupon_line l where l.line_id =  #{lineId})) ",
            "</otherwise>",
            "</choose>",
            "<choose>",
            "<when test = 'channelId != null and channelId > 0'>",
            "or (c.suitable_line_type = 2 and c.coupon_id not in(select l.coupon_id from ecw_coupon_line l where l.line_id =  #{lineId} and l.channel_id != #{channelId}))",
            "</when>",
            "<otherwise>",
            "or (c.suitable_line_type = 2 and c.coupon_id not in(select l.coupon_id from ecw_coupon_line l where l.line_id =  #{lineId}))",
            "</otherwise>",
            "</choose>",
            ")",
            "AND (c.suitable_prod_type = 0 " ,
            "or " ,
            "(c.suitable_prod_type = 1 " ,
             "and c.coupon_id in(select p.coupon_id from ecw_coupon_prod p where p.prod_id in",
            "<foreach item='param' index='index' collection='prodConditionParamList' open='(' separator=',' close=')'>",
            "#{param.prodId}",
            "</foreach>)",
            ")",
            "or ",
            "(c.suitable_prod_type = 2",
            "and c.coupon_id not in(select p.coupon_id from ecw_coupon_prod p where p.prod_id in",
            "<foreach item='param' index='index' collection='prodConditionParamList' open='(' separator=',' close=')'>",
            "#{param.prodId}",
            "</foreach>)",
            "))",
            "AND #{now} between c.start_time and IFNULL(c.end_time,date_add(now(), INTERVAL 1 day)) ",
            "AND FIND_IN_SET(#{isControl},c.is_cargo_control) ",
            "<when test = 'orderType != null'>",
            "AND FIND_IN_SET(#{orderType},c.order_attr) ",
            "</when>",
            "AND FIND_IN_SET(#{customsType},c.document_declaration) ",
            " order by c.coupon_id DESC ",
            "</script>"
    })
    @Results({
            @Result(property = "couponId", column = "coupon_id"),
            @Result(property = "prodList", column = "coupon_id",
                    many = @Many(select = "cn.iocoder.yudao.module.product.dal.mysql.coupon.CouponMapper.getProductListByCouponId"))
    })
    List<CouponAvailableDto> getActivityCouponAvailableDto(@Param("orderType") Integer orderType, @Param("customsType") Integer customsType,
                                                           @Param("isControl") Integer isControl, @Param("userId") Long userId,
                                                           @Param("consignorCustomerContactsId") Long consignorCustomerContactsId,
                                                           @Param("consigneeCustomerContactsId") Long consigneeCustomerContactsId,
                                                           @Param("prodConditionParamList") List<ProdConditionParam> prodConditionParamList,
                                                           @Param("lineId") Long lineId, @Param("channelId") Long channelId, @Param("now") Date now);

    @ResultType(ProductDO.class)
    @Select({
            "<script>",
            "select p.* ",
            "from ecw_product p ",
            "left join ecw_coupon_prod cp on cp.prod_id = p.id ",
            "where cp.coupon_id = #{couponId}",
            "and p.deleted = 0",
            "and p.status = 0",
            "order by p.id DESC ",
            "</script>"
    })
    List<ProductDO> getProductListByCouponId(@Param("couponId") Long couponId);

    @ResultType(CouponUserAvailableDto.class)
    @Select({
            "<script>",
            "select c.*, ",
            "c.coupon_id,",
            "cc.status as use_status",
            "from ecw_coupon c ",
            "left join ecw_coupon_customer cc on c.coupon_id = cc.coupon_id ",
            "where c.deleted = 0",
            "AND c.status = 1",
            "AND c.overdue_status = 1",
            "AND c.puton_status = 1",
            "AND c.type = 1",
            "AND (c.suitable_user_type = 0 ",
            "<when test = 'userId != null'>",
            "or cc.user_id = #{userId} ",
            "</when>",
            "<when test = 'consignorCustomerContactsId != null'>",
            "or cc.customer_id = #{consignorCustomerContactsId}",
            "</when>",
            ")",
            "AND now() between c.start_time and IFNULL(DATE_FORMAT(c.end_time,'%Y-%m-%d 23:59:59'),date_add(now(), INTERVAL 1 day)) ",
            " order by c.coupon_id DESC ",
            "</script>"
    })
    List<CouponAvailableDto> getCouponAvailableDto(@Param("userId") Long userId,
                                                   @Param("consignorCustomerContactsId") Long consignorCustomerContactsId);

    @Update("update ecw_coupon set overdue_status = 0 where status = 1 and end_time is not null and DATE_FORMAT(end_time,'%Y-%m-%d 23:59:59') < #{date}")
    long couponExpire(@Param("date") Date date);

    @ResultType(CouponDO.class)
    @Select({
            "<script>",
            "select c.*, ",
            "c.coupon_id,",
            "cr.nickname as creator_name, ",
            "up.nickname as updater_name",
            "from ecw_coupon c ",
            "left join system_user cr on cr.id = c.creator ",
            "left join system_user up on up.id = c.updater ",
            "where c.deleted = 0",
            "AND c.status = 1",
            "AND c.overdue_status = 1",
            "AND c.puton_status = 1",
            "<when test = 'reqVO.type != null'>",
            "AND c.type = #{reqVO.type}",
            "</when>",
            "<when test = 'reqVO.costType != null'>",
            "AND c.cost_type = #{reqVO.costType}",
            "</when>",
            "<when test = 'reqVO.titleZh != null and reqVO.titleZh != \"\"'>",
            "and c.title_zh like CONCAT('%',#{reqVO.titleZh},'%')",
            "</when>",
            "<when test = 'reqVO.titleEn != null  and reqVO.titleEn != \"\"'>",
            "and c.title_en like CONCAT('%',#{reqVO.titleEn},'%')",
            "</when>",
            "AND now() between c.start_time and IFNULL(DATE_FORMAT(c.end_time,'%Y-%m-%d 23:59:59'),date_add(now(), INTERVAL 1 day)) ",
            " order by c.coupon_id DESC ",
            "</script>"
    })
    List<CouponDO> getCouponSelect(@Param("reqVO") CouponPageReqVO pageReqVO, @Param("size") Integer pageSize);


    @ResultType(CouponDO.class)
    @Select({
            "<script>",
                "select c.*, ",
                "c.coupon_id,",
                "cr.nickname as creator_name, ",
                "up.nickname as updater_name",
            "from ecw_coupon c ",
                "left join system_user cr on cr.id = c.creator ",
                "left join system_user up on up.id = c.updater ",
            "where c.deleted = 0",
            "<when test = 'reqVO.status != null'>",
                "AND c.status = #{reqVO.status}",
            "</when>",
            "<when test='reqVO.statusList != null and reqVO.statusList.size()>0 ' >",
                "AND ( 1 != 1",
                    "<foreach item='status' index='index' collection='reqVO.statusList'>",
                        "<choose>",
                            "<when test=' status == 0'>",
                            "   or c.`status` = #{status}",
                            "</when>",
                            "<when test=' status == 1'>",
                            "   or c.`status` = #{status}",
                            "</when>",
                            "<when test=' status == 2'>",
                            "   or (c.`status` = 1 and (c.`puton_status` = 0 or c.`puton_status` = -1))",
                            "</when>",
                            "<when test=' status == 3'>",
                            "   or (c.`status` = 1 and c.`puton_status` = 1)",
                            "</when>",
                            "<when test=' status == 4'>",
                            "   or c.`overdue_status` = 0",
                            "</when>",
                        "</choose>",
                    "</foreach>",
                " )",
            "</when>",
            "<when test = 'reqVO.overdueStatus != null '>",
            "AND c.overdue_status = #{reqVO.overdueStatus} and c.`puton_status` = 1",
            "</when>",
            "<when test = 'reqVO.putonStatus != null'>",
            "AND c.puton_status = #{reqVO.putonStatus}",
            "</when>",
            "<when test = 'reqVO.type != null'>",
            "AND c.type = #{reqVO.type}",
            "</when>",

            "<when test = 'reqVO.validDays != null'>",
            "AND c.valid_days = #{reqVO.validDays}",
            "</when>",

            "<when test=\"reqVO.types != null and reqVO.types.size()>0\">" +
                    "            <when test=\"reqVO.types != null   and reqVO.types.size()==1 \">" +
                    "                AND c.`type` =\n" +
                    "                <foreach item='typeId' index='index' collection='reqVO.types' >\n" +
                    "                    #{typeId}" +
                    "                </foreach>" +
                    "            </when>" +
                    "            <when test=\"reqVO.types != null   and reqVO.types.size()>1 \">" +
                    "                AND c.`type` in " +
                    "                <foreach item='typeId' index='index' collection='reqVO.types' open='(' separator=',' close=')'>" +
                    "                    #{typeId}" +
                    "                </foreach>" +
                    "            </when>" +
                    "</when>",

            "<when test = 'reqVO.costType != null'>",
                "AND c.cost_type = #{reqVO.costType}",
            "</when>",
            "<when test = 'reqVO.searchKey != null and reqVO.searchKey != \"\"'>",
                "and (c.title_zh like CONCAT('%',#{reqVO.searchKey},'%') or c.title_en like CONCAT('%',#{reqVO.searchKey},'%'))",
            "</when>",
            "<when test = 'reqVO.titleZh != null and reqVO.titleZh != \"\"'>",
                "and c.title_zh like CONCAT('%',#{reqVO.titleZh},'%')",
            "</when>",
            "<when test = 'reqVO.titleEn != null  and reqVO.titleEn != \"\"'>",
                "and c.title_en like CONCAT('%',#{reqVO.titleEn},'%')",
            "</when>",
            "<when test = 'reqVO.beginStartTime != null  and reqVO.endStartTime != null'>",
                "AND c.start_time between #{reqVO.beginStartTime} and #{reqVO.endStartTime} ",
            "</when>",
            "<when test = 'reqVO.beginEndTime != null  and reqVO.endEndTime != null'>",
                "AND <![CDATA[ ( (DATE_FORMAT(c.end_time,'%Y-%m-%d 23:59:59') between #{reqVO.beginEndTime} and #{reqVO.endEndTime})  or (now() <= #{reqVO.endEndTime} and c.end_time is null)   )  ]]> ",
            "</when>",

            " <when test='reqVO.beginCreateTime != null' >",
            "AND <![CDATA[  c.create_time >= #{reqVO.beginCreateTime}  ]]> ",
            "</when>",
            " <when test='reqVO.endCreateTime != null' >",
            "AND <![CDATA[  c.create_time <= #{reqVO.endCreateTime}  ]]> ",
            "</when>",

            "<when test=\"reqVO.creator != null and reqVO.creator != ''  \">" +
                    "AND cr.`nickname` like concat('%',concat(#{reqVO.creator},'%'))",
            "</when>",

            " order by c.coupon_id desc",
            "</script>"
    })
    IPage<CouponDO> getCouponPage(@Param("mpPage") IPage<CouponDO> mpPage, @Param("reqVO") CouponPageReqVO reqVO);

    @ResultType(CouponDO.class)
    @Select({
            "select c.*, ",
            "c.coupon_id,",
            "cr.nickname as creator_name, ",
            "up.nickname as updater_name",
            "from ecw_coupon c ",
            "left join system_user cr on cr.id = c.creator ",
            "left join system_user up on up.id = c.updater ",
            "where c.deleted = 0",
            "AND c.status = 1",
            "AND c.overdue_status = 1",
            "AND c.puton_status = 1",
            " order by c.coupon_id DESC ",
    })
    List<CouponDO> getNewProdCouponList();
}
