package cn.iocoder.yudao.module.product.dal.mysql.coupon;

import java.util.*;

import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.framework.mybatis.core.query.LambdaQueryWrapperX;
import cn.iocoder.yudao.framework.mybatis.core.mapper.BaseMapperX;
import cn.iocoder.yudao.module.product.vo.coupon.prod.CouponProdExportReqVO;
import cn.iocoder.yudao.module.product.vo.coupon.prod.CouponProdPageReqVO;
import cn.iocoder.yudao.module.product.dal.dataobject.coupon.CouponProdDO;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.ResultType;
import org.apache.ibatis.annotations.Select;

/**
 * 优惠券商品关联信息 Mapper
 *
 * @author 系统管理员
 */
@Mapper
public interface CouponProdMapper extends BaseMapperX<CouponProdDO> {

    default PageResult<CouponProdDO> selectPage(CouponProdPageReqVO reqVO) {
        return selectPage(reqVO, new LambdaQueryWrapperX<CouponProdDO>()
                .eqIfPresent(CouponProdDO::getCouponId, reqVO.getCouponId())
                .eqIfPresent(CouponProdDO::getProdId, reqVO.getProdId())
                .orderByDesc(CouponProdDO::getCouponProdId));
    }

    default List<CouponProdDO> selectList(CouponProdExportReqVO reqVO) {
        return selectList(new LambdaQueryWrapperX<CouponProdDO>()
                .eqIfPresent(CouponProdDO::getCouponId, reqVO.getCouponId())
                .eqIfPresent(CouponProdDO::getProdId, reqVO.getProdId())
                .orderByDesc(CouponProdDO::getCouponProdId));
    }

    @ResultType(Long.class)
    @Select({"SELECT prod_id FROM ecw_coupon_prod WHERE coupon_id = #{couponId}"})
    List<Long> getProdIdsByCouponId(@Param("couponId") Long couponId);
}
