package cn.iocoder.yudao.module.product.dal.mysql.coupon;

import java.util.*;

import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.framework.mybatis.core.query.LambdaQueryWrapperX;
import cn.iocoder.yudao.framework.mybatis.core.mapper.BaseMapperX;
import cn.iocoder.yudao.module.product.vo.coupon.record.CouponUseRecordExportReqVO;
import cn.iocoder.yudao.module.product.vo.coupon.record.CouponUseRecordPageReqVO;
import cn.iocoder.yudao.module.product.dal.dataobject.coupon.CouponUseRecordDO;
import cn.iocoder.yudao.module.product.vo.coupon.record.CouponUseRecordRespVO;
import com.baomidou.mybatisplus.core.metadata.IPage;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.ResultType;
import org.apache.ibatis.annotations.Select;

/**
 * 优惠券使用记录 Mapper
 *
 * @author 系统管理员
 */
@Mapper
public interface CouponUseRecordMapper extends BaseMapperX<CouponUseRecordDO> {

    default PageResult<CouponUseRecordDO> selectPage(CouponUseRecordPageReqVO reqVO) {
        return selectPage(reqVO, new LambdaQueryWrapperX<CouponUseRecordDO>()
                .eqIfPresent(CouponUseRecordDO::getCouponCustomerId, reqVO.getCouponCustomerId())
                .eqIfPresent(CouponUseRecordDO::getUserId, reqVO.getUserId())
                .eqIfPresent(CouponUseRecordDO::getCustomerId, reqVO.getCustomerId())
                .eqIfPresent(CouponUseRecordDO::getOrderNumber, reqVO.getOrderNumber())
                .eqIfPresent(CouponUseRecordDO::getAmount, reqVO.getAmount())
                .betweenIfPresent(CouponUseRecordDO::getUseTime, reqVO.getBeginUseTime(), reqVO.getEndUseTime())
                .eqIfPresent(CouponUseRecordDO::getStatus, reqVO.getStatus())
                .orderByDesc(CouponUseRecordDO::getCouponUseRecordId));
    }

    default List<CouponUseRecordDO> selectList(CouponUseRecordExportReqVO reqVO) {
        return selectList(new LambdaQueryWrapperX<CouponUseRecordDO>()
                .eqIfPresent(CouponUseRecordDO::getCouponCustomerId, reqVO.getCouponCustomerId())
                .eqIfPresent(CouponUseRecordDO::getUserId, reqVO.getUserId())
                .eqIfPresent(CouponUseRecordDO::getCustomerId, reqVO.getCustomerId())
                .eqIfPresent(CouponUseRecordDO::getOrderNumber, reqVO.getOrderNumber())
                .eqIfPresent(CouponUseRecordDO::getAmount, reqVO.getAmount())
                .betweenIfPresent(CouponUseRecordDO::getUseTime, reqVO.getBeginUseTime(), reqVO.getEndUseTime())
                .eqIfPresent(CouponUseRecordDO::getStatus, reqVO.getStatus())
                .orderByDesc(CouponUseRecordDO::getCouponUseRecordId));
    }

    @ResultType(CouponUseRecordDO.class)
    @Select("select r.*, c.* from ecw_coupon_use_record r left join ecw_coupon c on r.coupon_id = c.coupon_id where r.coupon_use_record_id = #{id}")
    CouponUseRecordDO info(@Param("id") Long id);


    @ResultType(CouponUseRecordDO.class)
    @Select("select r.*, c.* from ecw_coupon_use_record r left join ecw_coupon c on r.coupon_id = c.coupon_id where c.type = 1 and r.user_id = #{reqVo.userId}")
    IPage<CouponUseRecordRespVO> couponUseRecordPage(IPage<CouponUseRecordRespVO> mpPage, CouponUseRecordPageReqVO reqVO);
}
