package cn.iocoder.yudao.module.product.dal.mysql.product;

import java.util.*;
import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.framework.mybatis.core.query.LambdaQuery;
import cn.iocoder.yudao.framework.mybatis.core.mapper.AbstractMapper;
import cn.iocoder.yudao.framework.mybatis.core.vo.PageVO;
import cn.iocoder.yudao.module.product.dal.dataobject.product.ProductBatchLogDO;
import cn.iocoder.yudao.module.product.vo.product.ProductBatchLogQueryVO;
import org.apache.ibatis.annotations.Mapper;

/**
 * 产品批量操作日志 Mapper
 * @author wlh
 */
@Mapper
public interface ProductBatchLogMapper extends AbstractMapper<ProductBatchLogDO> {
    @Override
    default PageResult<ProductBatchLogDO> selectPage(PageVO page, Object object) {
        if (object instanceof ProductBatchLogQueryVO) {
            ProductBatchLogQueryVO vo = (ProductBatchLogQueryVO)object;
            return selectPage(page, new LambdaQuery<ProductBatchLogDO>()
                .eqIfPresent(ProductBatchLogDO::getJson, vo.getJson())
                .eqIfPresent(ProductBatchLogDO::getStatus, vo.getStatus())
                .betweenIfPresent(ProductBatchLogDO::getCreateTime, vo.getBeginCreateTime(), vo.getEndCreateTime())
                    .orderByDesc(ProductBatchLogDO::getId));
        }

        return null;
    }

    @Override
    default List<ProductBatchLogDO> selectList(Object object) {
        if (object instanceof ProductBatchLogQueryVO) {
            ProductBatchLogQueryVO vo = (ProductBatchLogQueryVO)object;
            return selectList(new LambdaQuery<ProductBatchLogDO>()
                .eqIfPresent(ProductBatchLogDO::getJson, vo.getJson())
                .eqIfPresent(ProductBatchLogDO::getStatus, vo.getStatus())
                .betweenIfPresent(ProductBatchLogDO::getCreateTime, vo.getBeginCreateTime(), vo.getEndCreateTime())
                    .orderByDesc(ProductBatchLogDO::getId));
        }

        return null;
    }
}
