package cn.iocoder.yudao.module.product.dal.mysql.product;

import cn.iocoder.yudao.framework.mybatis.core.mapper.BaseMapperX;
import cn.iocoder.yudao.framework.mybatis.core.query.LambdaQueryWrapperX;
import cn.iocoder.yudao.module.product.dal.dataobject.product.ProductDO;
import cn.iocoder.yudao.module.product.dto.ProductReqDTO;
import cn.iocoder.yudao.module.product.vo.product.ProductExportReqVO;
import cn.iocoder.yudao.module.product.vo.product.ProductPageReqVO;
import cn.iocoder.yudao.module.product.vo.product.ProductRespVO;
import cn.iocoder.yudao.module.product.vo.product.ProductTypeNumVO;
import com.baomidou.mybatisplus.core.metadata.IPage;
import jodd.util.StringUtil;
import org.apache.commons.lang3.StringUtils;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.ResultType;
import org.apache.ibatis.annotations.Select;

import java.util.Arrays;
import java.util.List;
import java.util.stream.Collectors;

/**
 * 产品 Mapper
 *
 * @author wlh
 */
@Mapper
public interface ProductMapper extends BaseMapperX<ProductDO> {

    // default PageResult<ProductDO> selectPage(ProductPageReqVO reqVO) {
    //     return selectPage(reqVO, new LambdaQueryWrapperX<ProductDO>()
    //             .likeIfPresent(ProductDO::getProductCode, reqVO.getProductCode())
    //             .likeIfPresent(ProductDO::getCustomsCode, reqVO.getCustomsCode())
    //             .eqIfPresent(ProductDO::getTypeId, reqVO.getTypeId())
    //             .eqIfPresent(ProductDO::getStatus, reqVO.getStatus())
    //             .eqIfPresent(ProductDO::getAuditStatus, reqVO.getAuditStatus())
    //             .eqIfPresent(ProductDO::getStatus, reqVO.getStatus())
    //             .and(StringUtil.isNotEmpty(reqVO.getTitleZh()),
    //                     i -> i.like(ProductDO::getTitleZh, reqVO.getTitleZh())
    //                             .or()
    //                             .like(ProductDO::getTitleEn, reqVO.getTitleZh())
    //             )
    //             .apply(StringUtils.isNotEmpty(reqVO.getAttrId()), "FIND_IN_SET({0}, attr_id)", reqVO.getAttrId())
    //             .orderByDesc(ProductDO::getId));
    // }

    @ResultType(ProductDO.class)
    @Select({
            "<script>",
            "select t.*, c.nickname as creator_name, u.nickname as updater_name ",
            // ",(",
            // "SELECT count(0) FROM (select * from ecw_product_price where deleted = 0 and product_id = t.id) epp, ecw_warehouse_line ewl, ecw_warehouse ew_start, ecw_warehouse ew_dest ",
            // "WHERE epp.warehouse_line_id = ewl.id AND ewl.start_warehouse_id = ew_start.id AND ewl.dest_warehouse_id = ew_dest.id ",
            // "AND epp.deleted = 0 AND ewl.deleted = 0 AND FIND_IN_SET(ewl.transport_type, ew_start.freight)>0 ",
            // "AND FIND_IN_SET(ewl.transport_type, ew_dest.freight)>0 ",
            // "<when test = 'query.enableTransportTypeList != null and query.enableTransportTypeList.size() != 0'>",
            //     "AND ewl.`transport_type` in ",
            //     "<foreach item='transportType' collection='query.enableTransportTypeList' open='(' separator=',' close=')'>#{transportType}</foreach> ",
            // "</when>",
            // ") as price_line_count ",
            "from ecw_product t ",
            "left join system_user c on t.creator = c.id ",
            "left join system_user u on t.updater = u.id ",

            "where t.deleted = 0 ",

            "<when test = 'query.productCode != null and query.productCode != \"\"'>",
                "AND t.`product_code` like concat('%',concat(#{query.productCode},'%'))",
            "</when>",

            "<when test = 'query.customsCode != null and query.customsCode != \"\"'>",
                "AND t.`customs_code` like concat('%',concat(#{query.customsCode},'%'))",
            "</when>",

            "<when test = 'query.typeId != null'>",
                "AND t.`type_id` = #{query.typeId}",
            "</when>",

            "<when test = 'query.status != null'>",
                "AND t.`status` = #{query.status}",
            "</when>",

            "<when test = 'query.auditStatus != null'>",
                "AND t.`audit_status` = #{query.auditStatus}",
            "</when>",

            "<when test = 'query.titleZh != null and query.titleZh != \"\"'>",
                "AND (t.`title_zh` like concat('%',concat(#{query.titleZh},'%')) or t.`title_en` like concat('%',concat(#{query.titleZh},'%')))",
            "</when>",

            "<when test = 'query.attrId != null and query.attrId != \"\" '>",
                "AND FIND_IN_SET(t.`attr_id`, #{query.attrId})",
            "</when>",

            "order by t.id desc",

            "</script>"
    })
    IPage<ProductDO> selectPage2(IPage<ProductDO> mpPage, @Param("query") ProductPageReqVO query);


    @ResultType(ProductDO.class)
    @Select({
            "<script>",
            "select t.*, c.nickname as creator_name, u.nickname as updater_name ",
            "from ecw_product t ",
            "left join system_user c on t.creator = c.id ",
            "left join system_user u on t.updater = u.id ",

            "where t.deleted = 0 ",

            "<when test = 'query.productCode != null and query.productCode != \"\"'>",
            "AND t.`product_code` like concat('%',concat(#{query.productCode},'%'))",
            "</when>",

            "<when test = 'query.customsCode != null and query.customsCode != \"\"'>",
            "AND t.`customs_code` like concat('%',concat(#{query.customsCode},'%'))",
            "</when>",

           /* "<when test = 'query.typeId != null'>",
            "AND t.`type_id` = #{query.typeId}",
            "</when>",*/

            "<when test='query.typeId != null and query.typeId.size()>0'>",
                " <when test=' query.typeId.size()==1 '>",
                    "  AND t.`type_id` = ",
                    "  <foreach item='typeId' index='index' collection='query.typeId' >",
                    "  #{typeId}",
                    "  </foreach>" ,
                " </when>",
                " <when test=' query.typeId.size()>1 '>",
                    "  AND t.`type_id` in ",
                    "  <foreach item='typeId' index='index' collection='query.typeId' open='(' separator=',' close=')'>" ,
                    "  #{typeId}" ,
                    "  </foreach>" ,
                "  </when>" ,
            "</when>",

            "<when test = 'query.status != null'>",
            "AND t.`status` = #{query.status}",
            "</when>",

            "<when test = 'query.auditStatus != null'>",
                "AND t.`audit_status` = #{query.auditStatus}",
            "</when>",
            "<when test='query.auditStatusList != null and query.auditStatusList.size()>0 '>" ,
                "<when test='query.auditStatusList.size()==1 '>",
                    "<foreach item='auditStatus' index='index' collection='query.auditStatusList' >",
                    "AND t.`audit_status` = #{auditStatus}",
                    "</foreach>",
                "</when>",
                "<when test='query.auditStatusList.size()>1 '>",
                    " AND t.`audit_status` in ",
                    " <foreach item='auditStatus' index='index' collection='query.auditStatusList' open='(' separator=',' close=')'>",
                    "#{auditStatus}",
                    "</foreach>" ,
                "</when>" ,
            "</when>",
            "<when test = 'query.packaging != null'>",
                "AND t.`packaging` = #{query.packaging}",
            "</when>",

            "<when test = 'query.titleZh != null and query.titleZh != \"\"'>",
                "AND (t.`title_zh` like concat('%',concat(#{query.titleZh},'%')) or t.`title_en` like concat('%',concat(#{query.titleZh},'%')))",
            "</when>",

            "<when test='query.attrId != null and query.attrId.size()>0'>" ,
                    "<when test='query.attrId.size()==1 '>" ,
                    "<foreach item='attrId' index='index' collection='query.attrId' >" ,
                    "AND t.`attr_id` = #{attrId}" ,
                    "</foreach>",
                    "</when>",
                    "<when test='query.attrId.size()>1 '>" ,
                    "AND (1!=1 " ,
                    " <foreach item='attrId' index='index' collection='query.attrId'>" ,
                    " OR FIND_IN_SET(t.`attr_id`, #{attrId})",
                    "</foreach>" ,
                    " )" ,
                    "</when>",
            "</when>",

            "<when test='query.materialTypes != null and query.materialTypes.size()>0'>" ,
                "<when test= 'query.materialTypes != null  and query.materialTypes.size()==1 '>" ,
                    "<foreach item='materialType' index=\"index\" collection='query.materialTypes' >" ,
                    "AND t.`material_type` = #{materialType}" ,
                    "</foreach>" ,
                "</when>",
                "<when test= 'query.materialTypes != null and query.materialTypes.size()>1 '>",
                    " AND t.`material_type` in " ,
                    "<foreach item='materialType' index='index' collection='query.materialTypes' open='(' separator=',' close=')'>",
                    " #{materialType}" ,
                    " </foreach>" ,
                 "</when>" ,
            "</when>",

            " <when test='query.beginCreateTime != null' >",
                "AND <![CDATA[  t.create_time >= #{query.beginCreateTime}  ]]> ",
            "</when>",
            " <when test='query.endCreateTime != null' >",
                "AND <![CDATA[  t.create_time <= #{query.endCreateTime}  ]]> ",
            "</when>",

            "<when test='query.creator != null and query.creator != \"\" '>" +
                "AND c.`nickname` like concat('%',concat(#{query.creator},'%'))",
            "</when>",

            "<when test='query.titleZhKey != null and query.titleZhKey != \"\"  '>" +
                    "AND t.`title_zh` like concat('%',concat(#{query.titleZhKey},'%'))",
            "</when>",

            "<when test='query.notTitleZhKey != null and query.notTitleZhKey != \"\"  '>" +
                    "AND t.`title_zh` not like concat('%',concat(#{query.notTitleZhKey},'%'))",
            "</when>",

            "<when test='query.eqTitleZhKey != null and query.eqTitleZhKey != \"\"  '>" +
                    "AND t.`title_zh` =  #{query.eqTitleZhKey} ",
            "</when>",

            "<when test='query.notEqTitleZhKey != null and query.notEqTitleZhKey != \"\"  '>" +
                    "AND t.`title_zh` !=  #{query.notEqTitleZhKey} ",
            "</when>",

            "order by t.id desc",

            "</script>"
    })
    IPage<ProductDO> selectPageResp(IPage<ProductDO> mpPage, @Param("query") ProductReqDTO query);

    default List<ProductDO> selectList(ProductPageReqVO reqVO) {
        return selectList(new LambdaQueryWrapperX<ProductDO>()
                .likeIfPresent(ProductDO::getProductCode, reqVO.getProductCode())
                .likeIfPresent(ProductDO::getCustomsCode, reqVO.getCustomsCode())
                .eqIfPresent(ProductDO::getTypeId, reqVO.getTypeId())
                .eqIfPresent(ProductDO::getStatus, reqVO.getStatus())
                .eqIfPresent(ProductDO::getAuditStatus, reqVO.getAuditStatus())
                .eqIfPresent(ProductDO::getStatus, reqVO.getStatus())
                .and(StringUtil.isNotEmpty(reqVO.getTitleZh()),
                        i -> i.like(ProductDO::getTitleZh, reqVO.getTitleZh())
                                .or()
                                .like(ProductDO::getTitleEn, reqVO.getTitleZh())
                )
                .apply(StringUtils.isNotEmpty(reqVO.getAttrId()), "FIND_IN_SET({0}, attr_id)", reqVO.getAttrId())
                .select(ProductDO::getId,ProductDO::getTypeId, ProductDO::getTitleZh,
                        ProductDO::getTitleEn, ProductDO::getStatus,
                        ProductDO::getMaterialType,
                        ProductDO::getAuditStatus,
                        ProductDO::getAttrId)
                .orderByDesc(ProductDO::getId))
                ;
    }

    @ResultType(ProductDO.class)
    @Select({
            "<script>",
            "select t.*, c.nickname as creator_name, u.nickname as updater_name ",
            "from ecw_product t ",
            "left join system_user c on t.creator = c.id ",
            "left join system_user u on t.updater = u.id ",

            "where t.deleted = 0 ",

            "<when test = 'query.productCode != null and query.productCode != \"\"'>",
            "AND t.`product_code` like concat('%',concat(#{query.productCode},'%'))",
            "</when>",

            "<when test = 'query.customsCode != null and query.customsCode != \"\"'>",
            "AND t.`customs_code` like concat('%',concat(#{query.customsCode},'%'))",
            "</when>",

           /* "<when test = 'query.typeId != null'>",
            "AND t.`type_id` = #{query.typeId}",
            "</when>",*/

            "<when test=\"query.typeId != null and query.typeId.size()>0\">" +
                    "            <when test=\"query.typeId != null and query.typeId != '' and query.typeId.size()==1 \">" +
                    "                AND t.`type_id` =\n" +
                    "                <foreach item='typeId' index='index' collection='query.typeId' >\n" +
                    "                    #{typeId}" +
                    "                </foreach>" +
                    "            </when>" +
                    "            <when test=\"query.typeId != null and query.typeId != '' and query.typeId.size()>1 \">" +
                    "                AND t.`type_id` in " +
                    "                <foreach item='typeId' index='index' collection='query.typeId' open='(' separator=',' close=')'>" +
                    "                    #{typeId}" +
                    "                </foreach>" +
                    "            </when>" +
                    "</when>",

            "<when test = 'query.status != null'>",
            "AND t.`status` = #{query.status}",
            "</when>",

            "<when test = 'query.auditStatus != null'>",
            "AND t.`audit_status` = #{query.auditStatus}",
            "</when>",

            "<when test = 'query.titleZh != null and query.titleZh != \"\"'>",
            "AND (t.`title_zh` like concat('%',concat(#{query.titleZh},'%')) or t.`title_en` like concat('%',concat(#{query.titleZh},'%')))",
            "</when>",

//            "<when test = 'query.attrId != null and query.attrId != \"\" '>",
            "<when test=\"query.attrId != null and query.attrId.size()>0\">" ,

            "<when test=\"query.attrId != null and query.attrId != '' and query.attrId.size()==1 \">" +
                    "<foreach item='attrId' index=\"index\" collection='query.attrId' >" +
                    "AND t.`attr_id` = #{attrId}" +
                    "</foreach>" +
                    "</when>",
            "<when test=\"query.attrId != null and query.attrId != '' and query.attrId.size()>1 \">" +
                    "AND (1!=1 " +
                    " <foreach item='attrId' index='index' collection='query.attrId'>" +
                    " OR FIND_IN_SET(t.`attr_id`, #{attrId})"+
                    "</foreach>" +
                    " )" +
                    "</when>",
//            "AND FIND_IN_SET(t.`attr_id`, #{query.attrId})",
            "</when>",

            "order by t.id desc",

            "</script>"
    })
     List<ProductDO> selectListReq(@Param("query") ProductReqDTO reqVO)  ;

    default List<ProductDO> selectIdList(ProductPageReqVO reqVO) {
        return selectList(new LambdaQueryWrapperX<ProductDO>()
                .likeIfPresent(ProductDO::getProductCode, reqVO.getProductCode())
                .likeIfPresent(ProductDO::getCustomsCode, reqVO.getCustomsCode())
                .eqIfPresent(ProductDO::getTypeId, reqVO.getTypeId())
                .eqIfPresent(ProductDO::getStatus, reqVO.getStatus())
                .eqIfPresent(ProductDO::getAuditStatus, reqVO.getAuditStatus())
                .eqIfPresent(ProductDO::getStatus, reqVO.getStatus())
                .and(StringUtil.isNotEmpty(reqVO.getTitleZh()),
                        i -> i.like(ProductDO::getTitleZh, reqVO.getTitleZh())
                                .or()
                                .like(ProductDO::getTitleEn, reqVO.getTitleZh())
                )
                .apply(StringUtils.isNotEmpty(reqVO.getAttrId()), "FIND_IN_SET({0}, attr_id)", reqVO.getAttrId())
                .select(ProductDO::getId)
                .orderByDesc(ProductDO::getId));
    }

    default List<ProductDO> selectList(ProductExportReqVO reqVO) {
        reqVO.setStatus(0);
        String ids = reqVO.getIds();
        List<Long> idList = null;
        if (StringUtils.isNotEmpty(ids)) {
            String[] idArray = ids.split(",");
            idList = Arrays.asList(idArray).stream()
                    .map(Long::valueOf)
                    .collect(Collectors.toList());
        }
        return selectList(new LambdaQueryWrapperX<ProductDO>()
                .likeIfPresent(ProductDO::getProductCode, reqVO.getProductCode())
                .likeIfPresent(ProductDO::getCustomsCode, reqVO.getCustomsCode())
                .eqIfPresent(ProductDO::getTypeId, reqVO.getTypeId())
                .inIfPresent(ProductDO::getTypeId, reqVO.getTypeIds())
                .eqIfPresent(ProductDO::getAuditStatus, reqVO.getAuditStatus())
                .eqIfPresent(ProductDO::getStatus, reqVO.getStatus())
                .inIfPresent(ProductDO::getId, idList)
                .likeIfPresent(ProductDO::getTitleZh, reqVO.getTitleZh())
                .likeIfPresent(ProductDO::getTitleEn, reqVO.getTitleEn())
                .likeIfPresent(ProductDO::getTitleFr, reqVO.getTitleFr())
                .apply(StringUtils.isNotEmpty(reqVO.getAttrId()), "FIND_IN_SET({0}, attr_id)", reqVO.getAttrId())
                .orderByDesc(ProductDO::getId));
    }



    List<ProductTypeNumVO> getProductTypeNumList(List<Long> list);


    @Select({
            "select * from ecw_product where audit_status = 2 and deleted = 0 ORDER BY RAND() LIMIT #{num};"
    })
    List<ProductDO> randomTemplateProdData(@Param("num") Integer num);

    List<ProductRespVO> getProductList(@Param("reqVO") ProductExportReqVO reqVO);
}
