package cn.iocoder.yudao.module.product.dal.mysql.product;

import java.util.*;

import cn.iocoder.yudao.framework.mybatis.core.query.LambdaQueryWrapperX;
import cn.iocoder.yudao.framework.mybatis.core.mapper.BaseMapperX;
import cn.iocoder.yudao.module.product.dal.dataobject.product.ProductDO;
import cn.iocoder.yudao.module.product.dto.ProductPriceExcelData;
import cn.iocoder.yudao.module.product.vo.productPrice.ProductPriceExportReqVO;
import cn.iocoder.yudao.module.product.vo.productPrice.ProductPricePageReqVO;
import cn.iocoder.yudao.module.product.dal.dataobject.product.ProductPriceDO;
import com.baomidou.mybatisplus.core.metadata.IPage;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

/**
 * 产品价格 Mapper
 *
 * @author wlh
 */
@Mapper
public interface ProductPriceMapper extends BaseMapperX<ProductPriceDO> {

    default List<ProductPriceDO> selectList(ProductPriceExportReqVO reqVO) {
        return selectList(new LambdaQueryWrapperX<ProductPriceDO>()
                .eqIfPresent(ProductPriceDO::getProductId, reqVO.getProductId())
                .eqIfPresent(ProductPriceDO::getWarehouseLineId, reqVO.getWarehouseLineId())
                .eqIfPresent(ProductPriceDO::getTransportPrice, reqVO.getTransportPrice())
                .eqIfPresent(ProductPriceDO::getTransportPriceUnit, reqVO.getTransportPriceUnit())
                .eqIfPresent(ProductPriceDO::getTransportVolumeUnit, reqVO.getTransportVolumeUnit())
                .eqIfPresent(ProductPriceDO::getClearancePrice, reqVO.getClearancePrice())
                .eqIfPresent(ProductPriceDO::getClearancePriceUnit, reqVO.getClearancePriceUnit())
                .eqIfPresent(ProductPriceDO::getClearanceVolumeUnit, reqVO.getClearanceVolumeUnit())
                .eqIfPresent(ProductPriceDO::getStatus, reqVO.getStatus())
                .betweenIfPresent(ProductPriceDO::getCreateTime, reqVO.getBeginCreateTime(), reqVO.getEndCreateTime())
                .orderByDesc(ProductPriceDO::getId));
    }

    IPage<ProductPriceDO> getPage(IPage page, @Param("params") ProductPricePageReqVO params);

    Long countByProductIdAndTransportType(@Param("productId") Long productId, @Param("transportTypeList") List<String> transportTypeList);

    List<ProductPriceExcelData> getExcelList(@Param("pageSize")int pageSize, @Param("maxId") Long maxId, @Param("params") ProductPricePageReqVO params);

    Long getExcelListCount(@Param("params") ProductPricePageReqVO params);

    List<ProductDO> getProductList();

    Integer insertBatchSomeColumn(Collection<ProductPriceDO> entityList);

    int updateBatch(@Param("list") List<ProductPriceDO> list);
}
