package cn.iocoder.yudao.module.product.dal.mysql.product;

import java.util.*;

import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.framework.mybatis.core.query.LambdaQueryWrapperX;
import cn.iocoder.yudao.framework.mybatis.core.mapper.BaseMapperX;
import cn.iocoder.yudao.module.product.vo.productType.ProductTypeExportReqVO;
import cn.iocoder.yudao.module.product.vo.productType.ProductTypePageReqVO;
import cn.iocoder.yudao.module.product.dal.dataobject.product.ProductTypeDO;
import org.apache.commons.lang3.StringUtils;
import org.apache.ibatis.annotations.Mapper;

/**
 * 产品类型 Mapper
 *
 * @author wlh
 */
@Mapper
public interface ProductTypeMapper extends BaseMapperX<ProductTypeDO> {

    default PageResult<ProductTypeDO> selectPage(ProductTypePageReqVO reqVO) {
        String keywords = reqVO.getTitleZh();
        boolean hasKeywords = StringUtils.isNotEmpty(keywords);
        return selectPage(reqVO, new LambdaQueryWrapperX<ProductTypeDO>()
                .like(hasKeywords, ProductTypeDO::getTitleZh, keywords)
                .or()
                .like(hasKeywords, ProductTypeDO::getTitleEn, keywords)
                .orderByAsc(ProductTypeDO::getSort));
    }

    default List<ProductTypeDO> selectList(ProductTypeExportReqVO reqVO) {
        String keywords = reqVO.getTitleZh();
        boolean hasKeywords = StringUtils.isNotEmpty(keywords);
        return selectList(new LambdaQueryWrapperX<ProductTypeDO>()
                .like(hasKeywords, ProductTypeDO::getTitleZh, keywords)
                .or()
                .like(hasKeywords, ProductTypeDO::getTitleEn, keywords)
                .orderByAsc(ProductTypeDO::getSort));
    }

}
