package cn.iocoder.yudao.module.product.dal.mysql.productBrandTrademarkCateogryRel;

import java.util.*;
import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.framework.mybatis.core.query.LambdaQuery;
import cn.iocoder.yudao.framework.mybatis.core.mapper.AbstractMapper;
import cn.iocoder.yudao.module.product.dal.dataobject.productBrandTrademarkCateogryRel.ProductBrandTrademarkCateogryRelDO;
import cn.iocoder.yudao.framework.mybatis.core.vo.PageVO;
import cn.iocoder.yudao.module.product.vo.productBrandTrademarkCateogryRel.ProductBrandTrademarkCateogryRelPageReqVO;
import org.apache.ibatis.annotations.Mapper;
import cn.iocoder.yudao.module.product.vo.productBrandTrademarkCateogryRel.*;

/**
 * 商标与商品分类关联 Mapper
 * @author 江楠
 */
@Mapper
public interface ProductBrandTrademarkCateogryRelMapper extends AbstractMapper<ProductBrandTrademarkCateogryRelDO> {
    @Override
    default PageResult<ProductBrandTrademarkCateogryRelDO> selectPage(PageVO page, Object object) {
        if (object instanceof ProductBrandTrademarkCateogryRelPageReqVO) {
            ProductBrandTrademarkCateogryRelPageReqVO reqVO = (ProductBrandTrademarkCateogryRelPageReqVO)object;
            return selectPage(page, new LambdaQuery<ProductBrandTrademarkCateogryRelDO>()
                .eqIfPresent(ProductBrandTrademarkCateogryRelDO::getTrademarkId, reqVO.getTrademarkId())
                .eqIfPresent(ProductBrandTrademarkCateogryRelDO::getProductCategoryId, reqVO.getProductCategoryId())
                .eqIfPresent(ProductBrandTrademarkCateogryRelDO::getProductId, reqVO.getProductId())
                    .orderByDesc(ProductBrandTrademarkCateogryRelDO::getId));
        }

        return null;
    }

    @Override
    default List<ProductBrandTrademarkCateogryRelDO> selectList(Object object) {
        if (object instanceof ProductBrandTrademarkCateogryRelPageReqVO) {
            ProductBrandTrademarkCateogryRelPageReqVO reqVO = (ProductBrandTrademarkCateogryRelPageReqVO)object;
            return selectList(new LambdaQuery<ProductBrandTrademarkCateogryRelDO>()
                .eqIfPresent(ProductBrandTrademarkCateogryRelDO::getTrademarkId, reqVO.getTrademarkId())
                .eqIfPresent(ProductBrandTrademarkCateogryRelDO::getProductCategoryId, reqVO.getProductCategoryId())
                .eqIfPresent(ProductBrandTrademarkCateogryRelDO::getProductId, reqVO.getProductId())
                    .orderByDesc(ProductBrandTrademarkCateogryRelDO::getId));
        }

        return null;
    }

    default PageResult<ProductBrandTrademarkCateogryRelDO> selectPage(ProductBrandTrademarkCateogryRelPageReqVO reqVO) {
        return selectPage(reqVO, new LambdaQuery<ProductBrandTrademarkCateogryRelDO>()
                .eqIfPresent(ProductBrandTrademarkCateogryRelDO::getTrademarkId, reqVO.getTrademarkId())
                .eqIfPresent(ProductBrandTrademarkCateogryRelDO::getProductCategoryId, reqVO.getProductCategoryId())
                .eqIfPresent(ProductBrandTrademarkCateogryRelDO::getProductId, reqVO.getProductId())
                .orderByDesc(ProductBrandTrademarkCateogryRelDO::getId));
    }
}
