package cn.iocoder.yudao.module.product.dal.mysql.productBrandTrademarkRel;

import java.util.*;
import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.framework.mybatis.core.query.LambdaQuery;
import cn.iocoder.yudao.framework.mybatis.core.mapper.AbstractMapper;
import cn.iocoder.yudao.module.product.dal.dataobject.productBrandTrademarkRel.ProductBrandTrademarkRelDO;
import cn.iocoder.yudao.framework.mybatis.core.vo.PageVO;
import cn.iocoder.yudao.module.product.vo.productBrandTrademarkRel.ProductBrandTrademarkRelPageReqVO;
import org.apache.ibatis.annotations.Mapper;
import cn.iocoder.yudao.module.product.vo.productBrandTrademarkRel.*;

/**
 * 商品品牌与商标关联 Mapper
 * @author 江楠
 */
@Mapper
public interface ProductBrandTrademarkRelMapper extends AbstractMapper<ProductBrandTrademarkRelDO> {
    @Override
    default PageResult<ProductBrandTrademarkRelDO> selectPage(PageVO page, Object object) {
        if (object instanceof ProductBrandTrademarkRelPageReqVO) {
            ProductBrandTrademarkRelPageReqVO reqVO = (ProductBrandTrademarkRelPageReqVO)object;
            return selectPage(page, new LambdaQuery<ProductBrandTrademarkRelDO>()
                .eqIfPresent(ProductBrandTrademarkRelDO::getProductBrandId, reqVO.getProductBrandId())
                .likeIfPresent(ProductBrandTrademarkRelDO::getBrandName, reqVO.getBrandName())
                    .orderByDesc(ProductBrandTrademarkRelDO::getId));
        }

        return null;
    }

    @Override
    default List<ProductBrandTrademarkRelDO> selectList(Object object) {
        if (object instanceof ProductBrandTrademarkRelPageReqVO) {
            ProductBrandTrademarkRelPageReqVO reqVO = (ProductBrandTrademarkRelPageReqVO)object;
            return selectList(new LambdaQuery<ProductBrandTrademarkRelDO>()
                .eqIfPresent(ProductBrandTrademarkRelDO::getProductBrandId, reqVO.getProductBrandId())
                .likeIfPresent(ProductBrandTrademarkRelDO::getBrandName, reqVO.getBrandName())
                    .orderByDesc(ProductBrandTrademarkRelDO::getId));
        }else if(object instanceof  ProductBrandTrademarkRelDO){
            ProductBrandTrademarkRelDO reqVO = (ProductBrandTrademarkRelDO)object;
            return selectList(new LambdaQuery<ProductBrandTrademarkRelDO>()
                    .eqIfPresent(ProductBrandTrademarkRelDO::getProductBrandId, reqVO.getProductBrandId())
                    .likeIfPresent(ProductBrandTrademarkRelDO::getBrandName, reqVO.getBrandName())
                    .orderByDesc(ProductBrandTrademarkRelDO::getId));
        }

        return null;
    }

    default PageResult<ProductBrandTrademarkRelDO> selectPage(ProductBrandTrademarkRelPageReqVO reqVO) {
        return selectPage(reqVO, new LambdaQuery<ProductBrandTrademarkRelDO>()
                .eqIfPresent(ProductBrandTrademarkRelDO::getProductBrandId, reqVO.getProductBrandId())
                .likeIfPresent(ProductBrandTrademarkRelDO::getBrandName, reqVO.getBrandName())
                .orderByAsc(ProductBrandTrademarkRelDO::getId));
    }
}
