package cn.iocoder.yudao.module.product.dal.mysql.productBrandUnauthEmpower;

import java.util.*;
import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.framework.mybatis.core.query.LambdaQuery;
import cn.iocoder.yudao.framework.mybatis.core.mapper.AbstractMapper;
import cn.iocoder.yudao.module.product.dal.dataobject.productBrandUnauthEmpower.ProductBrandUnauthEmpowerDO;
import cn.iocoder.yudao.framework.mybatis.core.vo.PageVO;
import cn.iocoder.yudao.module.product.vo.productBrandUnauthEmpower.ProductBrandUnauthEmpowerQueryVO;
import cn.iocoder.yudao.module.product.vo.productBrandUnauthEmpower.ProductBrandUnauthEmpowerUpdateReqVO;
import org.apache.ibatis.annotations.Mapper;

/**
 * 商品品牌-未授权客户-指定收费标准 Mapper
 * @author 江楠
 */
@Mapper
public interface ProductBrandUnauthEmpowerMapper extends AbstractMapper<ProductBrandUnauthEmpowerDO> {
    @Override
    default PageResult<ProductBrandUnauthEmpowerDO> selectPage(PageVO page, Object object) {
        if (object instanceof ProductBrandUnauthEmpowerQueryVO) {
            ProductBrandUnauthEmpowerQueryVO vo = (ProductBrandUnauthEmpowerQueryVO)object;
            return selectPage(page, new LambdaQuery<ProductBrandUnauthEmpowerDO>()
                .eqIfPresent(ProductBrandUnauthEmpowerDO::getProductBrandId, vo.getProductBrandId())
                .eqIfPresent(ProductBrandUnauthEmpowerDO::getCustomerId, vo.getCustomerId())
                // .eqIfPresent(ProductBrandUnauthEmpowerDO::getCustomerContactsId, vo.getCustomerContactsId())
                .eqIfPresent(ProductBrandUnauthEmpowerDO::getFeeScale, vo.getFeeScale())
                .eqIfPresent(ProductBrandUnauthEmpowerDO::getCreateUserId, vo.getCreateUserId())
                .likeIfPresent(ProductBrandUnauthEmpowerDO::getCreateUsername, vo.getCreateUsername())
                .betweenIfPresent(ProductBrandUnauthEmpowerDO::getCreateTime, vo.getBeginCreateTime(), vo.getEndCreateTime())
                    .orderByDesc(ProductBrandUnauthEmpowerDO::getId));
        }

        return null;
    }

    @Override
    default List<ProductBrandUnauthEmpowerDO> selectList(Object object) {
        if (object instanceof ProductBrandUnauthEmpowerQueryVO) {
            ProductBrandUnauthEmpowerQueryVO vo = (ProductBrandUnauthEmpowerQueryVO)object;
            return selectList(new LambdaQuery<ProductBrandUnauthEmpowerDO>()
                .eqIfPresent(ProductBrandUnauthEmpowerDO::getProductBrandId, vo.getProductBrandId())
                .eqIfPresent(ProductBrandUnauthEmpowerDO::getCustomerId, vo.getCustomerId())
                // .eqIfPresent(ProductBrandUnauthEmpowerDO::getCustomerContactsId, vo.getCustomerContactsId())
                .eqIfPresent(ProductBrandUnauthEmpowerDO::getFeeScale, vo.getFeeScale())
                .eqIfPresent(ProductBrandUnauthEmpowerDO::getCreateUserId, vo.getCreateUserId())
                .likeIfPresent(ProductBrandUnauthEmpowerDO::getCreateUsername, vo.getCreateUsername())
                .betweenIfPresent(ProductBrandUnauthEmpowerDO::getCreateTime, vo.getBeginCreateTime(), vo.getEndCreateTime())
                    .orderByDesc(ProductBrandUnauthEmpowerDO::getId));
        }else if (object instanceof ProductBrandUnauthEmpowerDO) {
            ProductBrandUnauthEmpowerDO vo = (ProductBrandUnauthEmpowerDO)object;
            return selectList(new LambdaQuery<ProductBrandUnauthEmpowerDO>()
                    .eqIfPresent(ProductBrandUnauthEmpowerDO::getProductBrandId, vo.getProductBrandId())
                    // .eqIfPresent(ProductBrandUnauthEmpowerDO::getCustomerContactsId, vo.getCustomerContactsId())
                    .eqIfPresent(ProductBrandUnauthEmpowerDO::getCustomerId, vo.getCustomerId())
//                    .eqIfPresent(ProductBrandUnauthEmpowerDO::getFeeScale, vo.getFeeScale())
                    .orderByDesc(ProductBrandUnauthEmpowerDO::getId));
        }

        return null;
    }
}
