package cn.iocoder.yudao.module.product.dal.mysql.productPriceSnapshot;

import java.util.*;
import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.framework.mybatis.core.query.LambdaQuery;
import cn.iocoder.yudao.framework.mybatis.core.mapper.AbstractMapper;
import cn.iocoder.yudao.framework.mybatis.core.vo.PageVO;
import cn.iocoder.yudao.module.product.dal.dataobject.productPriceSnapshot.ProductPriceSnapshotDO;
import cn.iocoder.yudao.module.product.vo.productPriceSnapshot.ProductPriceSnapshotQueryVO;
import org.apache.ibatis.annotations.Mapper;

/**
 * 路线价格修改历史 Mapper
 * @author wlh
 */
@Mapper
public interface ProductPriceSnapshotMapper extends AbstractMapper<ProductPriceSnapshotDO> {
    @Override
    default PageResult<ProductPriceSnapshotDO> selectPage(PageVO page, Object object) {
        if (object instanceof ProductPriceSnapshotQueryVO) {
            ProductPriceSnapshotQueryVO vo = (ProductPriceSnapshotQueryVO)object;
            return selectPage(page, new LambdaQuery<ProductPriceSnapshotDO>()
                .eqIfPresent(ProductPriceSnapshotDO::getProductId, vo.getProductId())
                .eqIfPresent(ProductPriceSnapshotDO::getWarehouseLineId, vo.getWarehouseLineId())
                .eqIfPresent(ProductPriceSnapshotDO::getShippingChannelId, vo.getShippingChannelId())
                .eqIfPresent(ProductPriceSnapshotDO::getContent, vo.getContent())
                .betweenIfPresent(ProductPriceSnapshotDO::getCreateTime, vo.getBeginCreateTime(), vo.getEndCreateTime())
                    .orderByDesc(ProductPriceSnapshotDO::getId));
        }

        return null;
    }

    @Override
    default List<ProductPriceSnapshotDO> selectList(Object object) {
        if (object instanceof ProductPriceSnapshotQueryVO) {
            ProductPriceSnapshotQueryVO vo = (ProductPriceSnapshotQueryVO)object;
            return selectList(new LambdaQuery<ProductPriceSnapshotDO>()
                .eqIfPresent(ProductPriceSnapshotDO::getProductId, vo.getProductId())
                .eqIfPresent(ProductPriceSnapshotDO::getWarehouseLineId, vo.getWarehouseLineId())
                .eqIfPresent(ProductPriceSnapshotDO::getShippingChannelId, vo.getShippingChannelId())
                .eqIfPresent(ProductPriceSnapshotDO::getContent, vo.getContent())
                .betweenIfPresent(ProductPriceSnapshotDO::getCreateTime, vo.getBeginCreateTime(), vo.getEndCreateTime())
                    .orderByDesc(ProductPriceSnapshotDO::getId));
        }

        return null;
    }

    Integer insertBatchSomeColumn(Collection<ProductPriceSnapshotDO> entityList);
}
