package cn.iocoder.yudao.module.product.dal.mysql.productbrandempower;

import java.util.*;

import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.framework.mybatis.core.query.LambdaQuery;
import cn.iocoder.yudao.framework.mybatis.core.mapper.AbstractMapper;
import cn.iocoder.yudao.module.product.dal.dataobject.productbrandempower.ProductBrandEmpowerDO;
import cn.iocoder.yudao.framework.mybatis.core.vo.PageVO;
import cn.iocoder.yudao.module.product.dal.dataobject.productbrank.ProductBrankDO;
import cn.iocoder.yudao.module.product.vo.productbrandempower.ProductBrandEmpowerBaseVO;
import cn.iocoder.yudao.module.product.vo.productbrandempower.ProductBrandEmpowerPageReqVO;
import cn.iocoder.yudao.module.product.vo.productbrandempower.ProductBrandEmpowerRespVO;
import cn.iocoder.yudao.module.product.vo.productbrank.ProductBrandMyEmpowerRespVO;
import cn.iocoder.yudao.module.product.vo.productbrank.ProductBrankByCustomerPageReqVO;
import org.apache.ibatis.annotations.Mapper;
import cn.iocoder.yudao.module.product.vo.productbrandempower.*;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.ResultType;
import org.apache.ibatis.annotations.Select;

/**
 * 商品品牌授权 Mapper
 *
 * @author 江楠
 */
@Mapper
public interface ProductBrandEmpowerMapper extends AbstractMapper<ProductBrandEmpowerDO> {
    @Override
    default PageResult<ProductBrandEmpowerDO> selectPage(PageVO page, Object object) {
        if (object instanceof ProductBrandEmpowerPageReqVO) {
            ProductBrandEmpowerPageReqVO reqVO = (ProductBrandEmpowerPageReqVO) object;
            return selectPage(page, new LambdaQuery<ProductBrandEmpowerDO>()
                    .eqIfPresent(ProductBrandEmpowerDO::getProductBrandId, reqVO.getProductBrandId())
                    .eqIfPresent(ProductBrandEmpowerDO::getCustomerId, reqVO.getCustomerId())
//                    .eqIfPresent(ProductBrandEmpowerDO::getCustomerContactsId, reqVO.getCustomerContactsId())
//                    .betweenIfPresent(ProductBrandEmpowerDO::getStartTime, reqVO.getBeginStartTime(), reqVO.getEndStartTime())
//                    .betweenIfPresent(ProductBrandEmpowerDO::getEndTime, reqVO.getBeginEndTime(), reqVO.getEndEndTime())
//                    .eqIfPresent(ProductBrandEmpowerDO::getFileUrl, reqVO.getFileUrl())
                    .eqIfPresent(ProductBrandEmpowerDO::getFeeScale, reqVO.getFeeScale())
                    .eqIfPresent(ProductBrandEmpowerDO::getStatus, reqVO.getStatus())
//                    .eqIfPresent(ProductBrandEmpowerDO::getCreateUserId, reqVO.getCreateUserId())
//                    .likeIfPresent(ProductBrandEmpowerDO::getCreateUsername, reqVO.getCreateUsername())
//                    .betweenIfPresent(ProductBrandEmpowerDO::getCreateTime, reqVO.getBeginCreateTime(), reqVO.getEndCreateTime())
                    .orderByDesc(ProductBrandEmpowerDO::getId));
        }

        return null;
    }

    @Override
    default List<ProductBrandEmpowerDO> selectList(Object object) {
        if (object instanceof ProductBrandEmpowerPageReqVO) {
            ProductBrandEmpowerPageReqVO reqVO = (ProductBrandEmpowerPageReqVO) object;
            return selectList(new LambdaQuery<ProductBrandEmpowerDO>()
                    .eqIfPresent(ProductBrandEmpowerDO::getProductBrandId, reqVO.getProductBrandId())
                    .eqIfPresent(ProductBrandEmpowerDO::getCustomerId, reqVO.getCustomerId())
//                    .eqIfPresent(ProductBrandEmpowerDO::getCustomerContactsId, reqVO.getCustomerContactsId())
//                    .betweenIfPresent(ProductBrandEmpowerDO::getStartTime, reqVO.getBeginStartTime(), reqVO.getEndStartTime())
//                    .betweenIfPresent(ProductBrandEmpowerDO::getEndTime, reqVO.getBeginEndTime(), reqVO.getEndEndTime())
//                    .eqIfPresent(ProductBrandEmpowerDO::getFileUrl, reqVO.getFileUrl())
                    .eqIfPresent(ProductBrandEmpowerDO::getFeeScale, reqVO.getFeeScale())
                    .eqIfPresent(ProductBrandEmpowerDO::getStatus, reqVO.getStatus())
//                    .eqIfPresent(ProductBrandEmpowerDO::getCreateUserId, reqVO.getCreateUserId())
//                    .likeIfPresent(ProductBrandEmpowerDO::getCreateUsername, reqVO.getCreateUsername())
//                    .betweenIfPresent(ProductBrandEmpowerDO::getCreateTime, reqVO.getBeginCreateTime(), reqVO.getEndCreateTime())
                    .orderByDesc(ProductBrandEmpowerDO::getId));
        }else  if (object instanceof ProductBrandEmpowerBaseVO) {
            ProductBrandEmpowerBaseVO reqVO = (ProductBrandEmpowerBaseVO) object;
            return selectList(new LambdaQuery<ProductBrandEmpowerDO>()
                    .eqIfPresent(ProductBrandEmpowerDO::getProductBrandId, reqVO.getProductBrandId())
                    .eqIfPresent(ProductBrandEmpowerDO::getCustomerId, reqVO.getCustomerId())
//                    .eqIfPresent(ProductBrandEmpowerDO::getCustomerContactsId, reqVO.getCustomerContactsId())
//                    .betweenIfPresent(ProductBrandEmpowerDO::getStartTime, reqVO.getBeginStartTime(), reqVO.getEndStartTime())
//                    .betweenIfPresent(ProductBrandEmpowerDO::getEndTime, reqVO.getBeginEndTime(), reqVO.getEndEndTime())
//                    .eqIfPresent(ProductBrandEmpowerDO::getFileUrl, reqVO.getFileUrl())
                    .eqIfPresent(ProductBrandEmpowerDO::getFeeScale, reqVO.getFeeScale())
                    .eqIfPresent(ProductBrandEmpowerDO::getStatus, reqVO.getStatus())
//                    .eqIfPresent(ProductBrandEmpowerDO::getCreateUserId, reqVO.getCreateUserId())
//                    .likeIfPresent(ProductBrandEmpowerDO::getCreateUsername, reqVO.getCreateUsername())
//                    .betweenIfPresent(ProductBrandEmpowerDO::getCreateTime, reqVO.getBeginCreateTime(), reqVO.getEndCreateTime())
                    .orderByDesc(ProductBrandEmpowerDO::getId));
        }

        return null;
    }

    default PageResult<ProductBrandEmpowerDO> selectPage(ProductBrandEmpowerPageReqVO reqVO) {
        return selectPage(reqVO, new LambdaQuery<ProductBrandEmpowerDO>()
                .eqIfPresent(ProductBrandEmpowerDO::getProductBrandId, reqVO.getProductBrandId())
                .eqIfPresent(ProductBrandEmpowerDO::getCustomerId, reqVO.getCustomerId())
//                .eqIfPresent(ProductBrandEmpowerDO::getCustomerContactsId, reqVO.getCustomerContactsId())
//                .betweenIfPresent(ProductBrandEmpowerDO::getStartTime, reqVO.getBeginStartTime(), reqVO.getEndStartTime())
//                .betweenIfPresent(ProductBrandEmpowerDO::getEndTime, reqVO.getBeginEndTime(), reqVO.getEndEndTime())
//                .eqIfPresent(ProductBrandEmpowerDO::getFileUrl, reqVO.getFileUrl())
                .eqIfPresent(ProductBrandEmpowerDO::getFeeScale, reqVO.getFeeScale())
                .eqIfPresent(ProductBrandEmpowerDO::getStatus, reqVO.getStatus())
//                .eqIfPresent(ProductBrandEmpowerDO::getCreateUserId, reqVO.getCreateUserId())
//                .likeIfPresent(ProductBrandEmpowerDO::getCreateUsername, reqVO.getCreateUsername())
//                .betweenIfPresent(ProductBrandEmpowerDO::getCreateTime, reqVO.getBeginCreateTime(), reqVO.getEndCreateTime())
                .orderByDesc(ProductBrandEmpowerDO::getId));
    }

    @ResultType(List.class)
    @Select(
            {
                    "<script>",
                    "select * from (",
                    "select DISTINCT e.id,",
                    "e.product_brand_id,",
                    "e.customer_id,",
                    "e.start_time,",
                    "e.end_time,",
                    "e.file_url,",
                    "e.fee_scale,",
                    "e.status,",
                   "e.create_user_id,",
                    "e.create_username,",
                    "e.creator,",
                    "e.create_time,",
                    "e.updater,",
                    "e.update_time,",
                    "e.deleted,",
                    "c.name as customer_name ,",
                    // "cc.area_code,",
                    // "cc.id as customer_contacts_Id,",
                    //将联系人的所有电话号码组合起来成一个phone
                    "(select GROUP_CONCAT(CONCAT_WS('(@)', CONCAT(s.area_code,s.phone_new), s.name) SEPARATOR '(;)') from ecw_customer_contacts s where s.deleted = 0 and s.customer_id = c.id) AS phone ",
//                    "cc.id as customer_contacts_Id,",
//                    "cc.phone",
                    " from ecw_product_brand_empower e ",
                    "left join ecw_customer c on e.customer_id = c.id ",
                    // "left join ecw_customer_contacts cc on cc.is_default = 1 ",
                    // "and c.id = cc.customer_id and cc.is_default = 1 and cc.deleted = 0 " ,
                    "where e.deleted = 0",
                    // " and cc.is_default = 1",
                    "<when test = 'pageVO.status != null'>",
                    "AND `status` = #{pageVO.status}",
                    "</when>",
                    "<when test = 'pageVO.productBrandId != null'>",
                    "AND `product_brand_id` = #{pageVO.productBrandId}",
                    "</when>",
                    "<when test = 'pageVO.feeScale != null'>",
                    "AND `fee_scale` = #{pageVO.feeScale}",
                    "</when>",

                    " order by e.id desc ",
                    ") tmp where 1 = 1 ",

                    "<when test = 'pageVO.customerKey != null and pageVO.customerKey != \"\"'>",
                    "AND (tmp.customer_name like concat('%',concat(#{pageVO.customerKey},'%')) or tmp.phone like concat('%',concat(#{pageVO.customerKey},'%')))",
                    "</when>",
                    "limit #{pageVO.pageNo}, #{pageVO.pageSize}",
                    "</script>"
            }
    )
    List<ProductBrandEmpowerRespVO> authCustomerList(@Param("pageVO") ProductBrandEmpowerPageReqVO pageVO);


    @ResultType(Long.class)
    @Select(
            {
                    "<script>",
                    "select count(0) from (",
                    "select DISTINCT e.id,",
                    "e.product_brand_id,",
                    "e.customer_id,",
                    "e.start_time,",
                    "e.end_time,",
                    "e.file_url,",
                    "e.fee_scale,",
                    "e.status,",
                    "e.create_user_id,",
                    "e.create_username,",
                    "e.creator,",
                    "e.create_time,",
                    "e.updater,",
                    "e.update_time,",
                    "e.deleted,",
                    "c.name as customer_name ,",
                    // "cc.area_code,",
                    // "cc.id as customer_contacts_Id,",
                    //将联系人的所有电话号码组合起来成一个phone
                    "(select GROUP_CONCAT(CONCAT_WS('(@)', CONCAT(s.area_code,s.phone_new), s.name) SEPARATOR '(;)') from ecw_customer_contacts s where s.deleted = 0 and s.customer_id = c.id) AS phone ",
//                    "cc.id as customer_contacts_Id,",
//                    "cc.phone",
                    " from ecw_product_brand_empower e ",
                    "left join ecw_customer c on e.customer_id = c.id ",
                    // "left join ecw_customer_contacts cc on cc.is_default = 1 ",
                    // "and c.id = cc.customer_id and cc.is_default = 1 and cc.deleted = 0 " ,
                    "where e.deleted = 0",
                    // " and cc.is_default = 1",
                    "<when test = 'pageVO.status != null'>",
                    "AND `status` = #{pageVO.status}",
                    "</when>",
                    "<when test = 'pageVO.productBrandId != null'>",
                    "AND `product_brand_id` = #{pageVO.productBrandId}",
                    "</when>",
                    "<when test = 'pageVO.feeScale != null'>",
                    "AND `fee_scale` = #{pageVO.feeScale}",
                    "</when>",

                    " order by e.id desc ",
                    ") tmp where 1 = 1 ",

                    "<when test = 'pageVO.customerKey != null and pageVO.customerKey != \"\"'>",
                    "AND (tmp.customer_name like concat('%',concat(#{pageVO.customerKey},'%')) or tmp.phone like concat('%',concat(#{pageVO.customerKey},'%')))",
                    "</when>",
                    "</script>"
            }
    )
    Long countAuthCustomerList(@Param("pageVO") ProductBrandEmpowerPageReqVO pageVO);



    @ResultType(List.class)
    @Select(
            {
                    "<script>",
                    "select * from (",

                    "select ",
                    "DISTINCT c.name as customer_name,",
                    "c.id as customer_id,",
                    // "cc.id as customer_contacts_Id,",
                    // "CONCAT(cc.area_code,cc.phone_new) AS phone,",

                    "epb.id as product_brand_id,",
                    "CASE WHEN epb.unauth_charging_model=0 THEN epb.unauth_default_fee_type WHEN epb.unauth_charging_model=1 AND unauth_user.fee_scale IS NOT NULL THEN unauth_user.fee_scale ELSE epb.unauth_default_fee_type END AS fee_scale,",
                    "unauth_user.product_brand_id as unauth_user_product_brand_id,",
                    "epb.unauth_charging_model,",
                    "epb.unauth_default_fee_type, ",


                    "(select GROUP_CONCAT(CONCAT_WS('(@)', CONCAT(s.area_code,s.phone_new), s.name) SEPARATOR '(;)') from ecw_customer_contacts s where s.deleted = 0 and s.customer_id = c.id) AS phone ",

                    " from ecw_customer c  ",
                    // "left join ecw_customer_contacts cc on c.id = cc.customer_id and cc.is_default = 1 ",
                    // "AND cc.deleted = 0 ",
                    "left join ecw_product_brand_unauth_empower unauth_user on c.id = unauth_user.customer_id and unauth_user.product_brand_id = #{pageVO.productBrandId},",
                    "ecw_product_brank epb",
                    "where c.deleted = 0",
                    // "AND cc.deleted = 0 ",
                    // "AND cc.is_default = 1 ",
                    "<when test = 'pageVO.productBrandId != null'>",
                    " and epb.id = #{pageVO.productBrandId}",
                    "</when>",

                    " AND c.id NOT IN (",
                    "SELECT e.customer_id FROM ecw_product_brand_empower e",
                    "LEFT JOIN ecw_customer c ON e.customer_id = c.id",
                    // "LEFT JOIN ecw_customer_contacts cc ON cc.is_default = 1 ",
                    // "AND e.customer_id = cc.customer_id and cc.is_default = 1",
                    // "AND cc.deleted = 0 ",
                    "WHERE e.deleted = 0 ",
                    // "AND cc.deleted = 0 ",
                    "<when test = 'pageVO.productBrandId != null'>",
                    "AND `product_brand_id` = #{pageVO.productBrandId}",
                    "</when>",
                    ")",
                    " order by c.id desc ",


                    ") tmp where 1 = 1 ",


                    "<when test = 'pageVO.customerKey != null and pageVO.customerKey != \"\"'>",
                    "AND (tmp.customer_name like concat('%',concat(#{pageVO.customerKey},'%')) or tmp.phone like concat('%',concat(#{pageVO.customerKey},'%')))",
                    "</when>",
                    "limit #{pageVO.pageNo}, #{pageVO.pageSize}",
                    "</script>"
            }
    )
    List<ProductBrandEmpowerRespVO> unAuthCustomerFeeScaleList(@Param("pageVO") ProductBrandEmpowerPageReqVO pageVO);

    @ResultType(Long.class)
    @Select(
            {
                    "<script>",
                    "select count(0) from (",

                    "select ",
                    "DISTINCT c.name as customer_name,",
                    "c.id as customer_id,",
                    // "cc.id as customer_contacts_Id,",
                    // "CONCAT(cc.area_code,cc.phone_new) AS phone,",

                    "epb.id as product_brand_id,",
                    "CASE WHEN epb.unauth_charging_model=0 THEN epb.unauth_default_fee_type WHEN epb.unauth_charging_model=1 AND unauth_user.fee_scale IS NOT NULL THEN unauth_user.fee_scale ELSE epb.unauth_default_fee_type END AS fee_scale,",
                    "unauth_user.product_brand_id as unauth_user_product_brand_id,",
                    "epb.unauth_charging_model,",
                    "epb.unauth_default_fee_type, ",


                    "(select GROUP_CONCAT(CONCAT_WS('(@)', CONCAT(s.area_code,s.phone_new), s.name) SEPARATOR '(;)') from ecw_customer_contacts s where s.deleted = 0 and s.customer_id = c.id) AS phone ",

                    " from ecw_customer c  ",
                    // "left join ecw_customer_contacts cc on c.id = cc.customer_id and cc.is_default = 1 ",
                    // "AND cc.deleted = 0 ",
                    "left join ecw_product_brand_unauth_empower unauth_user on c.id = unauth_user.customer_id and unauth_user.product_brand_id = #{pageVO.productBrandId},",
                    "ecw_product_brank epb",
                    "where c.deleted = 0",
                    // "AND cc.deleted = 0 ",
                    // "AND cc.is_default = 1 ",
                    "<when test = 'pageVO.productBrandId != null'>",
                    " and epb.id = #{pageVO.productBrandId}",
                    "</when>",

                    " AND c.id NOT IN (",
                    "SELECT e.customer_id FROM ecw_product_brand_empower e",
                    "LEFT JOIN ecw_customer c ON e.customer_id = c.id",
                    // "LEFT JOIN ecw_customer_contacts cc ON cc.is_default = 1 ",
                    // "AND e.customer_id = cc.customer_id and cc.is_default = 1",
                    // "AND cc.deleted = 0 ",
                    "WHERE e.deleted = 0 ",
                    // "AND cc.deleted = 0 ",
                    "<when test = 'pageVO.productBrandId != null'>",
                    "AND `product_brand_id` = #{pageVO.productBrandId}",
                    "</when>",
                    ")",
                    " order by c.id desc ",


                    ") tmp where 1 = 1 ",


                    "<when test = 'pageVO.customerKey != null and pageVO.customerKey != \"\"'>",
                    "AND (tmp.customer_name like concat('%',concat(#{pageVO.customerKey},'%')) or tmp.phone like concat('%',concat(#{pageVO.customerKey},'%')))",
                    "</when>",
                    "</script>"
            }
    )
    Long countUnAuthCustomerList(@Param("pageVO") ProductBrandEmpowerPageReqVO pageVO);


    @ResultType(List.class)
    @Select(
            {
                    "<script>",
                    "select DISTINCT " ,
                    "b.id product_brand_id,",
                    "b.title_zh ,",
                    "b.title_en,",
                    "a.start_time,",
                    "a.end_time,",
                    "a.file_url,",
                    "b.filing,",
                    "b.aorder,",
                    "a.fee_scale,",
                    "a.status,",
                    "a.create_user_id,",
                    "a.create_username,",
                    "a.create_time",
                            " from ecw_product_brand_empower a,ecw_product_brank b" +
                            " where a.deleted =0 and a.customer_id = #{pageVO.customerId} and a.product_brand_id = b.id",
                    " order by b.id desc ",
                    "limit #{pageVO.pageNo}, #{pageVO.pageSize}",
                    "</script>"
            }
    )
    List<ProductBrandMyEmpowerRespVO> getBrankByCustomer(@Param("pageVO") ProductBrankByCustomerPageReqVO pageVO);

    @ResultType(Long.class)
    @Select(
            {
                    "<script>",
                    "select count(0) from ecw_product_brand_empower a,ecw_product_brank b" +
                            " where a.deleted =0 and a.customer_id = #{pageVO.customerId} and a.product_brand_id = b.id",
                    "</script>"
            }
    )
    Long countBrankByCustomer(@Param("pageVO") ProductBrankByCustomerPageReqVO pageVO);



}
