package cn.iocoder.yudao.module.product.dto;

import cn.iocoder.yudao.module.product.dal.dataobject.product.BasePrice;
import lombok.Data;

@Data
public class AirClearancePriceResultDto {

    /**
     * 1-未设置商品清关费, 2-区间未匹配上
     */
    private int productPriceEmptyType = 0;

    /**
     * 1-未设置渠道清关费, 2-区间未匹配上, 3-包装类型未设置
     */
    private int channelPriceEmptyType = 0;

    /**
     * 是否超出空运重量上限
     */
    private Boolean isAirWeightLimit = false;

    /**
     * 匹配上的清关费价格
     */
    private BasePrice clearancePrice;

}
