package cn.iocoder.yudao.module.product.dto;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.math.BigDecimal;

@Data
public class BrankCustomerDto {


    @ApiModelProperty(value = "运输id", required = true)
    private Integer transportId;

    @ApiModelProperty(value = "始发地仓库id", required = true)
    private Long startWarehouseId;

    @ApiModelProperty(value = "始发地仓库仓库名称")
    private String startTitleZh;

    @ApiModelProperty(value = "始发地仓库英文名称")
    private String startTitleEn;

    @ApiModelProperty(value = "目的地仓库id", required = true)
    private Long destWarehouseId;


    @ApiModelProperty(value = "目的地仓库仓库名称")
    private String destTitleZh;

    @ApiModelProperty(value = "目的地仓库英文名称")
    private String destTitleEn;

    @ApiModelProperty(value = "线路id", required = true)
    private Long lineId;

    @ApiModelProperty(value = "渠道id")
    private Long channelId;

    @ApiModelProperty(value = "运费")
    private BigDecimal seaFreight = BigDecimal.ZERO;

    @ApiModelProperty(value = "运费用金额单位ID")
    private Long seaFreightCurrency;

    @ApiModelProperty(value = "运费体积单位")
    private Integer seaFreightVolume;

    @ApiModelProperty(value = "清关费")
    private BigDecimal clearanceFreight = BigDecimal.ZERO;

    @ApiModelProperty(value = "清关费用金额单位ID")
    private Long clearanceFreightCurrency;

    @ApiModelProperty(value = "清关费体积单位")
    private Integer clearanceFreightVolume;

    @ApiModelProperty(value = "预计销售额")
    private BigDecimal estimatedSales = BigDecimal.ZERO;

    @ApiModelProperty(value = "计费方式：0 运费/清关费 1 全包价")
    private Integer charging = 0;
}
