package cn.iocoder.yudao.module.product.dto;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.List;

@Data
@ApiModel(value = "用户可用优惠劵")
public class CouponAvailableGroupDto {

    @ApiModelProperty(value = "商品ID", required = true)
    private Long prodId;

    @ApiModelProperty(value = "商品名称-中文")
    private String prodTitleZh;

    @ApiModelProperty(value = "商品名称-英文")
    private String prodTitleEn;

    @ApiModelProperty(value = "品牌:：1 已备案(有) 2 中性 3 未备案(无)")
    private Integer brandType;

    @ApiModelProperty(value = "1 海运拼柜 2 海运整柜 3 空运专线 4 海空联运")
    private Integer transportId;

    @ApiModelProperty(value = "商品体积")
    private BigDecimal volume;

    @ApiModelProperty(value = "商品重量")
    private BigDecimal weight;

    @ApiModelProperty(value = "商品数量")
    private Integer quantity = 0;

    @ApiModelProperty(value = "商品运费单价(原始单价)")
    private BigDecimal orgFreightPrice;

    @ApiModelProperty(value = "商品运费")
    private BigDecimal freight;

    @ApiModelProperty(value = "运费用金额单位ID")
    private Integer freightCurrency;

    @ApiModelProperty(value = "运费体积单位")
    private Long freightVolume;

    @ApiModelProperty(value = "商品清关费单价(原始)")
    private BigDecimal orgClearanceFeePrice;

    @ApiModelProperty(value = "商品清关费")
    private BigDecimal clearanceFee;

    @ApiModelProperty(value = "清关费用货币单位ID")
    private Integer clearanceFeeCurrency;

    @ApiModelProperty(value = "清关费体积单位")
    private Long clearanceFeeVolume;

    @ApiModelProperty(value = "该产品的可用优惠")
    private List<CouponAvailableDto> couponAvailableDtoList = new ArrayList<>();

    @ApiModelProperty(value = "优惠收费总体积")
    private BigDecimal couponTotalChargeVolume = BigDecimal.ZERO;

    @ApiModelProperty(value = "优惠收费总重量")
    private BigDecimal couponTotalChargeWeight = BigDecimal.ZERO;

    @ApiModelProperty(value = "优惠收费总个数")
    private BigDecimal couponTotalChargeQuantity = BigDecimal.ZERO;

    @ApiModelProperty(value = "优惠总实际体积")
    private BigDecimal couponTotalVolume = BigDecimal.ZERO;

    @ApiModelProperty(value = "优惠总实际重量")
    private BigDecimal couponTotalWeight = BigDecimal.ZERO;

    @ApiModelProperty(value = "优惠总实际个数")
    private BigDecimal couponTotalQuantity = BigDecimal.ZERO;

    @ApiModelProperty(value = "是否有特殊加价")
    private boolean isSpecialMarkup;

}
