package cn.iocoder.yudao.module.product.dto;

import cn.hutool.core.collection.CollectionUtil;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.math.BigDecimal;
import java.util.*;

@Data
@ApiModel(value = "用户可用优惠劵")
public class CouponUserAvailableDto {

    @ApiModelProperty(value = "用户可用优惠劵列表")
    private List<CouponAvailableDto> couponAvailableDtoList;

    @ApiModelProperty(value = "用户商品列表的可用优惠活动列表")
    private List<CouponAvailableGroupDto> couponAvailableGroupDtoList;

    @ApiModelProperty(value = "用户优惠总额分组统计")
    private List<CouponTotalAmount> couponTotalAmountList;


    public void setCouponAvailableDtoList(List<CouponAvailableDto> couponAvailableDtoList) {
        this.couponAvailableDtoList = couponAvailableDtoList;
        if (CollectionUtil.isNotEmpty(couponAvailableDtoList)){
            // 已排序
            CouponAvailableDto availableDto = couponAvailableDtoList.get(0);
            CouponTotalAmount totalAmount = new CouponTotalAmount();
            totalAmount.setTotalAmount(availableDto.getReduceAmount());
            totalAmount.setCurrencyId(availableDto.getReduceCurrencyId());
            if (CollectionUtil.isNotEmpty(this.couponTotalAmountList)){
                boolean flag = true;
                for (CouponTotalAmount couponTotalAmount : this.couponTotalAmountList) {
                    if (Objects.equals(couponTotalAmount.getCurrencyId(), totalAmount.getCurrencyId())){
                        flag = false;
                        couponTotalAmount.setTotalAmount(couponTotalAmount.getTotalAmount().add(totalAmount.getTotalAmount()));
                    }
                }
                if (flag){
                    this.couponTotalAmountList.add(totalAmount);
                }
            }else {
                this.couponTotalAmountList = new ArrayList<>();
                this.couponTotalAmountList.add(totalAmount);
            }
        }
    }

    public void setCouponAvailableGroupDtoList(List<CouponAvailableGroupDto> couponAvailableGroupDtoList) {
        this.couponAvailableGroupDtoList = couponAvailableGroupDtoList;

        if (CollectionUtil.isNotEmpty(couponAvailableGroupDtoList)){
            for (CouponAvailableGroupDto groupDto : couponAvailableGroupDtoList) {
                if (CollectionUtil.isNotEmpty(groupDto.getCouponAvailableDtoList())) {
                    // 已排序
                    CouponAvailableDto availableDto = groupDto.getCouponAvailableDtoList().get(0);
                    CouponTotalAmount totalAmount = new CouponTotalAmount();
                    totalAmount.setTotalAmount(availableDto.getReduceTotalAmount());
                    totalAmount.setCurrencyId(availableDto.getReduceCurrencyId());
                    if (CollectionUtil.isNotEmpty(this.couponTotalAmountList)){
                        boolean flag = true;
                        for (CouponTotalAmount couponTotalAmount : this.couponTotalAmountList) {
                            if (Objects.equals(couponTotalAmount.getCurrencyId(), totalAmount.getCurrencyId())){
                                flag = false;
                                couponTotalAmount.setTotalAmount(couponTotalAmount.getTotalAmount().add(totalAmount.getTotalAmount()));
                            }
                        }
                        if (flag){
                            this.couponTotalAmountList.add(totalAmount);
                        }
                    }else {
                        this.couponTotalAmountList = new ArrayList<>();
                        this.couponTotalAmountList.add(totalAmount);
                    }
                }
            }

        }
    }
}

@Data
@ApiModel(value = "用户优惠总额")
class CouponTotalAmount{

    @ApiModelProperty(value = "优惠总额")
    private BigDecimal totalAmount;

    @ApiModelProperty(value = "货币ID")
    private Integer currencyId;
}