package cn.iocoder.yudao.module.product.dto;

import com.alibaba.excel.annotation.ExcelProperty;
import lombok.Data;


public class ProductPriceExcel {
    //产品ID
    @ExcelProperty(value = "产品id")
    private String productId;

    @ExcelProperty(value = "产品名称")
    private String productName;

    //下面三决定线路
    //运输方式
    @ExcelProperty("运输方式")
    private String transportType;
    //始发仓
    @ExcelProperty("始发地")
    private String startWarehouseName;
    //目的仓
    @ExcelProperty("目的地")
    private String endWarehouseName;

    @ExcelProperty("海运费")
    private String transportPrice;
    @ExcelProperty("海运费币种")
    private String transportPriceUintName;
    @ExcelProperty("海运费单位")
    private String transportVolumeUnitName;

    @ExcelProperty("清关费")
    private String clearancePrice;
    @ExcelProperty("清关费币种")
    private String clearancePriceUintName;
    @ExcelProperty("清关费单位")
    private String clearanceVolumeUnitName;

    @ExcelProperty("是否审核")
    private String auditType;

    @ExcelProperty("是否预付")
    private String needPayType;

    public String getProductName() {
        return productName;
    }

    public void setProductName(String productName) {
        this.productName = productName;
    }

    public String getProductId() {
        return productId;
    }

    public void setProductId(String productId) {
        this.productId = productId;
    }

    public String getTransportType() {
        return transportType;
    }

    public void setTransportType(String transportType) {
        this.transportType = transportType;
    }

    public String getStartWarehouseName() {
        return startWarehouseName;
    }

    public void setStartWarehouseName(String startWarehouseName) {
        this.startWarehouseName = startWarehouseName;
    }

    public String getEndWarehouseName() {
        return endWarehouseName;
    }

    public void setEndWarehouseName(String endWarehouseName) {
        this.endWarehouseName = endWarehouseName;
    }

    public String getTransportPrice() {
        return transportPrice;
    }

    public void setTransportPrice(String transportPrice) {
        this.transportPrice = transportPrice;
    }

    public String getTransportPriceUintName() {
        return transportPriceUintName;
    }

    public void setTransportPriceUintName(String transportPriceUintName) {
        this.transportPriceUintName = transportPriceUintName;
    }

    public String getTransportVolumeUnitName() {
        return transportVolumeUnitName;
    }

    public void setTransportVolumeUnitName(String transportVolumeUnitName) {
        this.transportVolumeUnitName = transportVolumeUnitName;
    }

    public String getClearancePrice() {
        return clearancePrice;
    }

    public void setClearancePrice(String clearancePrice) {
        this.clearancePrice = clearancePrice;
    }

    public String getClearancePriceUintName() {
        return clearancePriceUintName;
    }

    public void setClearancePriceUintName(String clearancePriceUintName) {
        this.clearancePriceUintName = clearancePriceUintName;
    }

    public String getClearanceVolumeUnitName() {
        return clearanceVolumeUnitName;
    }

    public void setClearanceVolumeUnitName(String clearanceVolumeUnitName) {
        this.clearanceVolumeUnitName = clearanceVolumeUnitName;
    }

    public String getAuditType() {
        return auditType;
    }

    public void setAuditType(String auditType) {
        this.auditType = auditType;
    }

    public String getNeedPayType() {
        return needPayType;
    }

    public void setNeedPayType(String needPayType) {
        this.needPayType = needPayType;
    }

    /**
     * 币种单位转化
     * @param priceUintName  币种单位名称
     * @return
     */
    public static Long priceUnitConvert(String priceUintName) {
        if(priceUintName == null) return 1L;
        if(priceUintName.equals("美元")) return 1L;
        if(priceUintName.equals("奈拉")) return 2L;
        if(priceUintName.equals("人民币")) return 3L;
        if(priceUintName.equals("西非法郎")) return 6L;
        return 1L;
    }

    /**
     * 体积单位转化
     * @param unitName  体积单位名称
     * @return
     */
    public static Long volumeUnitConvert(String unitName, String transportType) {
        if(unitName == null) return getUnitByTransportType(transportType);
        if(unitName.equals("小压包")) return 4L;
        if(unitName.equals("千克")) return 6L;
        if(unitName.equals("立方米")) return 7L;
        if(unitName.equals("大压包")) return 8L;
        if(unitName.equals("个")) return 10L;
        return null;
    }

    private static Long getUnitByTransportType(String transportType) {
        if(transportType.equals("1") || transportType.equals("2")) {
            return 7L;  //立方米
        } else if(transportType.equals("3") || transportType.equals("4")) {
            return 6L;  //千克
        }
        return 0L;
    }


    public static Integer auditConvert(String convertType) {
        if(convertType.equals("y")) return 0;
        if(convertType.equals("n")) return 1;
        return null;
    }

    public static Integer needPayConvert(String payType) {
        if(payType.equals("s")) {
            //均可
            return 0;
        } else if(payType.equals("y")) {
            //是
            return 1;
        } else if(payType.equals("n")) {
            return 0;
        }
        return null;
    }

    public static String transportTypeConvert(String transportTypeName) {
        if(transportTypeName.equals("海运拼柜")) return "1";
        if(transportTypeName.equals("海运整柜")) return "2";
        if(transportTypeName.equals("专线空运")) return "3";
        if(transportTypeName.equals("海空联运")) return "4";
        return null;
    }

}
