package cn.iocoder.yudao.module.product.dto;

import cn.iocoder.yudao.module.product.dal.dataobject.product.ProductPriceSpecialDO;
import cn.iocoder.yudao.module.product.dal.dataobject.product.ProductPriceStepDO;
import lombok.Data;

import java.math.BigDecimal;
import java.util.Date;
import java.util.List;

@Data
public class ProductPriceExcelData {

    private Long id;

    private String customsCode;

    private String productCode;

    private String goodType;

    private String goodName;

    private String transportType;

    private String channelName;

    private String routeName;

    private String mrTransportPrice;

    private String mrClearancePrice;

    private String ypTransportPrice;

    private String ypClearancePrice;

    private String zxTransportPrice;

    private String zxClearancePrice;

    private String ytTransportPrice;

    private String ytClearancePrice;

    private String ddTransportPrice;

    private String ddClearancePrice;

    private String statusName;

    private String payType;

    private String lastTime;

    private List<ProductPriceSpecialDO> specialList;

    private List<ProductPriceStepDO> stepList;

    private String expireTime;

    public String getCustomsCode() {
        if(customsCode == null) customsCode = "";
        return customsCode;
    }

    public String getProductCode() {
        if(productCode == null) productCode = "";
        return productCode;
    }

    public String getGoodType() {
        if(goodType == null) goodType = "";
        return goodType;
    }

    public String getGoodName() {
        if(goodName == null) goodName = "";
        return goodName;
    }

    public String getTransportType() {
        if(transportType == null) transportType = "";
        return transportType;
    }

    public String getChannelName() {
        if(channelName == null) channelName = "";
        return channelName;
    }

    public String getRouteName() {
        if(routeName == null) routeName = "";
        return routeName;
    }

    public String getMrTransportPrice() {
        if(mrTransportPrice == null) mrTransportPrice = "";
        return mrTransportPrice;
    }

    public String getMrClearancePrice() {
        if(mrClearancePrice == null) mrClearancePrice = "";
        return mrClearancePrice;
    }

    public String getYpTransportPrice() {
        if(ypTransportPrice == null) ypTransportPrice = "";
        return ypTransportPrice;
    }

    public String getYpClearancePrice() {
        if(ypClearancePrice == null) ypClearancePrice = "";
        return ypClearancePrice;
    }

    public String getZxTransportPrice() {
        if(zxTransportPrice == null) zxTransportPrice = "";
        return zxTransportPrice;
    }

    public String getZxClearancePrice() {
        if(zxClearancePrice == null) zxClearancePrice = "";
        return zxClearancePrice;
    }

    public String getYtTransportPrice() {
        if(ytTransportPrice == null) ytTransportPrice = "";
        return ytTransportPrice;
    }

    public String getYtClearancePrice() {
        if(ytClearancePrice == null) ytClearancePrice = "";
        return ytClearancePrice;
    }

    public String getDdTransportPrice() {
        if(ddTransportPrice == null) ddTransportPrice = "";
        return ddTransportPrice;
    }

    public String getDdClearancePrice() {
        if(ddClearancePrice == null) ddClearancePrice = "";
        return ddClearancePrice;
    }

    public String getStatusName() {
        if(statusName == null) statusName = "";
        return statusName;
    }

    public String getPayType() {
        if(payType == null) payType = "";
        return payType;
    }

    public String getLastTime() {
        if(lastTime == null) lastTime = "";
        return lastTime;
    }

    /**
     * 运费
     */
    private java.math.BigDecimal transportPrice;
    /**
     * 运费金额单位
     */
    private Long transportPriceUnit;
    /**
     * 运费体积单位
     */
    private Long transportVolumeUnit;
    /**
     * 清关费用
     */
    private java.math.BigDecimal clearancePrice;
    /**
     * 清关金额单位
     */
    private Long clearancePriceUnit;
    /**
     * 清关体积单位
     */
    private Long clearanceVolumeUnit;
    /**
     * 全包价金额
     */
    private java.math.BigDecimal allPrice;
    /**
     * 全包价金额单位
     */
    private Long allPriceUnit;
    /**
     * 全包价体积单位
     */
    private Long allVolumeUnit;

    /**
     * 是否需要预约入仓，0-否，1-是
     */
    private Integer needBook;

    /**
     * 是否需要单询，0-否，1-是
     */
    private Integer needOrderInquiry;

    /**
     * 每日入仓上限
     */
    private BigDecimal dayLimit;

    /**
     * 默认货柜位置，字典container_location
     */
    private String containerLocation;

    /**
     * 默认方数
     */
    private BigDecimal square;

    /**
     * 黑名单，0-否，1-是
     */
    private Integer blacklist;

    /**
     * 审核状态，0-已审核，1-未审核
     */
    private Integer auditStatus;

    /**
     * 代收货款，0-不支持，1-支持
     */
    private Integer payDelivery;

    /**
     * 是否需要预付，0-不需要，1-需要
     */
    private Integer needPay;

    /**
     * 是否阶梯定价，0-不是，1-是
     */
    private Integer stepPrice;

    /**
     * 最小计费重量
     */
    private BigDecimal minWeight;

    /**
     * 最小计费重量单位
     */
    private BigDecimal minWeightUnit;


    /**
     * 单价模式，0-运费+清关费，1-全包价
     */
    private Integer priceType;


    /**
     * 是否展示 默认为展示
     */
    private Integer status;


    /**
     * 有效开始时间
     */
    private Date validateStartDate;

    /**
     * 有效结束时间
     */
    private Date validateEndDate;

    private Date updateTime;
}
