package cn.iocoder.yudao.module.product.enums;

import cn.iocoder.yudao.framework.common.exception.ErrorCode;

/**
 * Member 错误码枚举类
 *
 * member 系统，使用 1-004-000-000 段
 */
public interface ErrorCodeConstants {

    ErrorCode ORDER_NOT_EXISTS = new ErrorCode(1004020005, "order.not.exists");

    ErrorCode PRODUCT_BRANK_NOT_EXISTS = new ErrorCode(1005008001, "product.brand.not.exist");
    ErrorCode PRODUCT_BRAND_EMPOWER_NOT_EXISTS = new ErrorCode(1005008002, "product.brand.authorization.does.not.exist");
    ErrorCode PRODUCT_BRAND_EMPOWER_EXISTS = new ErrorCode(1005008005, "product.brand.already.authorized.customer");
    ErrorCode PRODUCT_BRAND_TRADEMARK_REL_NOT_EXISTS = new ErrorCode(1005008003, "product.brand.type.not.exsit");
    ErrorCode PRODUCT_BRAND_TRADEMARK_CATEOGRY_REL_NOT_EXISTS = new ErrorCode(1005008004, "product.brand.type.not.exsit");
    ErrorCode PRODUCT_NOT_EXISTS = new ErrorCode(1005008005, "product.not.exsit");
//    ErrorCode CUSTOMER_NOT_EXISTS = new ErrorCode(1005008006, "客户信息不存在");
    ErrorCode QUANTITY_UNIT_NOT_NULL = new ErrorCode(1005008007, "quantity.unit.not.null");
    ErrorCode NOT_FIND_CURRENCY = new ErrorCode(1005008008, "not.find.currency");

    ErrorCode VOLUME_UNIT_NOT_NULL = new ErrorCode(1004010004, "volume.unit.not.null");
    ErrorCode WEIGHT_UNIT_NOT_NULL = new ErrorCode(1004010005, "weight.unit.not.null");

    ErrorCode UNIT_NOT_LEGAL = new ErrorCode(1004010002, "unit.not.legal");
    ErrorCode THIS_LINE_PROD_ON_BLACK_LIST = new ErrorCode(1004010013, "this.line.prod.on.black.list");

    ErrorCode THIS_LINE_PROD_NOT_SET_LICENSED_PRICE = new ErrorCode(1004010006, "line.prod.not.set.licensed.price");

    ErrorCode COUPON_NOT_EXISTS = new ErrorCode(1004001018, "coupon.not.exists");
    ErrorCode COUPON_CONTENT_NOT_EXISTS = new ErrorCode(1004001019, "coupon.content.not.exists");
    ErrorCode COUPON_LINE_NOT_EXISTS = new ErrorCode(1004001020, "coupon.line.not.exists");
    ErrorCode COUPON_PROD_NOT_EXISTS = new ErrorCode(1004001021, "coupon.prod.not.exists");
    ErrorCode COUPON_CUSTOMER_NOT_EXISTS = new ErrorCode(1004001022, "coupon.customer.not.exists");
    ErrorCode COUPON_USE_RECORD_NOT_EXISTS = new ErrorCode(1004001023, "coupon.use.record.not.exists");
    ErrorCode COUPON_REDUCE_AMOUNT_ERROR = new ErrorCode(1004001024, "coupon.reduce.amount.error");
    ErrorCode COUPON_DISCOUNT_DETAILED_NOT_NULL = new ErrorCode(1004001025, "coupon.discount.amount.not.null");
    ErrorCode COUPON_TYPE_ERROR = new ErrorCode(1004001026, "coupon.type.error");
    ErrorCode COUPON_FULL_REDUCE_NOT_NULL_OR_LT_ZERO = new ErrorCode(1004001027, "coupon.full.reduce.not.null.or.lt.zero");
    ErrorCode COUPON_FULL_REDUCE_CURRENCY_NOT_NULL = new ErrorCode(1004001028, "coupon.full.reduce.currency.not.null");
    ErrorCode COUPON_FULL_FRACTURE_NOT_NULL_OR_LT_ZERO = new ErrorCode(1004001029, "coupon.full.fracture.not.null.or.lt.zero.or.gt.one");
    ErrorCode COUPON_SPECIAL_OFFER_PACKING_NOT_NULL = new ErrorCode(1004001030, "coupon.special.offer.packing.not.null");
    ErrorCode COUPON_PUBLISHED = new ErrorCode(1004001031, "coupon.published");
    ErrorCode NO_USE_EXPIRE_COUPON = new ErrorCode(1004001032, "no.use.expire.coupon");
    ErrorCode COUPON_HAS_BEEN_USE = new ErrorCode(1004001033, "coupon.has.been.use");
    ErrorCode PROD_PARAM_NOT_NULL = new ErrorCode(1004001034, "prod.param.not.null");
    ErrorCode COST_CALCULATION_ERROR = new ErrorCode(1004001035, "cost.calculation.error");
    ErrorCode CUSTOMER_CONTACTS_NOT_NULL = new ErrorCode(1004001036, "customer.contacts.not.null");
    ErrorCode CUSTOMER_NOT_NULL = new ErrorCode(1004001037, "customer.not.null");


    ErrorCode PRODUCT_BRAND_UNAUTH_EMPOWER_NOT_EXISTS = new ErrorCode(1004001038, "product.brand.update.feetype.not.exsit");
    ErrorCode PRODUCT_BRAND_UNAUTH_EMPOWER_UPDATE_ERROR = new ErrorCode(1004001039, "product.brand.update.feetype.error");


    ErrorCode ORDER_TYPE_NOT_NULL = new ErrorCode(1004001040, "order.type.not.null");
    ErrorCode BRAND_TYPE_NOT_NULL = new ErrorCode(1004001041, "brand.type.not.null");
    ErrorCode IS_CARGO_CONTROL_NOT_NULL = new ErrorCode(1004001042, "is.cargo.control.not.null");
    ErrorCode DOCUMENT_DECLARATION_NOT_NULL = new ErrorCode(1004001043, "document.declaration.not.null");
    ErrorCode PROD_ID_NOT_NULL = new ErrorCode(1004001044, "prod.id.not.null");
    ErrorCode NOT_FIND_AVAILABLE_LINES = new ErrorCode(1004001045, "not.find.available.line");
    ErrorCode PLEASE_ENTER_LENGTH_WIDTH_HEIGHT = new ErrorCode(1004001046, "please.enter.length.width.height");
    ErrorCode DEPARTURE_NOT_START_WAREHOUSE = new ErrorCode(1004001047, "departure.not.start.warehouse");
    ErrorCode OBJECTIVE_NOT_DEST_WAREHOUSE = new ErrorCode(1004001048, "objective.not.dest.warehouse");
    ErrorCode SPECIAL_PRICE_ONE_FREIGHT_NOT_NULL = new ErrorCode(1004001049, "特价运费不能为空");
    ErrorCode SPECIAL_PRICE_ONE_CLEARANCE_FEE_NOT_NULL = new ErrorCode(1004001050, "特价清关费不能为空");
    ErrorCode PROD_VOLUME_BEYOND_DAY_UPPER_LIMIT = new ErrorCode(1004001051, "prod.volume.beyond.day.upper.limit");
    ErrorCode COUPON_FULL_REDUCE_VALUE_THAN_PAYMENT_VALUE = new ErrorCode(1004001052, "coupon.full.reduce.value.gt.payment.value");
    ErrorCode THIS_LINE_PROD_OFF_SHELF = new ErrorCode(1004001053, "this.line.prod.off.shelf");
    ErrorCode COUPON_FEE_TYPE_NOT_NULL = new ErrorCode(1004001054, "coupon.fee.type.not.null");

    ErrorCode COUPON_FULL_NET_VALUE_THAN_PAYMENT_VALUE = new ErrorCode(1004001055, "coupon.full.net.value.gt.payment.value");
    ErrorCode COUPON_CURRENCY_OR_UNIT_NOT_NULL = new ErrorCode(1004001056, "coupon.currency.or.unit.not.null");
    ErrorCode COUPON_SPECIAL_OFFER_PROD_NOT_NULL = new ErrorCode(1004001058, "coupon.special.offer.prod.not.null");
    ErrorCode COUPON_IS_EXPIRED = new ErrorCode(1004001059, "coupon.is.expired");
    ErrorCode COUPON_END_TIME_NOT_NULL = new ErrorCode(1004001060, "coupon.end.time.not.null");
    ErrorCode COUPON_EXTENSION_TIME_NOT_LT_ORIGINAL_END_TIME = new ErrorCode(1004001061, "coupon.extension.time.not.lt.original.end.time");
    ErrorCode COUPON_DELAY_TIME_MUST_GT_CURRENT_TIME = new ErrorCode(1004001062, "coupon.delay.time.must.gt.current.time");

    ErrorCode COUPON_ID_NOT_NULL = new ErrorCode(1004001063, "coupon.id.not.null");

    ErrorCode COUPON_END_TIME_NOT_LT_CURRENT_TIME = new ErrorCode(1004001064, "coupon.end.time.not.lt.current.time");

    ErrorCode ORDER_ITEM_PROD_NOT_EXISTS = new ErrorCode(1004001065, "order.item.prod.not.exists");



    ErrorCode PRODUCT_BRANK_CHINESE_NAME_EXISTS = new ErrorCode(1004001066, "product.brand.chinese.name.exist");
    ErrorCode PRODUCT_BRANK_ENGLISH_NAME_EXISTS = new ErrorCode(1004001067, "product.brand.english.name.exist");


    ErrorCode PROD_WEIGHT_BEYOND_DAY_UPPER_LIMIT = new ErrorCode(1004001068, "prod.weight.beyond.day.upper.limit");



}
