package cn.iocoder.yudao.module.product.param;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import javax.validation.constraints.NotEmpty;
import javax.validation.constraints.NotNull;
import java.util.List;

@Data
@ApiModel(value = "条件计费参数")
public class ConditionParam {

    @ApiModelProperty(value = "订单属性： 1 普货  2 重货 3 泡货3")
    private Integer orderType;

    @ApiModelProperty(value = "如果要获取可用优惠卷列表需传此参数 报关方式: 我司全代：1，自单代报：2，混合报关：3")
//    @NotNull(message = "document.declaration.not.null")
    private Integer customsType;

    @ApiModelProperty(value = "如果要获取可用优惠卷列表需传此参数 是否控货： 0 否  1 是")
//    @NotNull(message = "is.cargo.control.not.null")
    private Boolean isCargoControl;

    @ApiModelProperty(value = "用户ID(web端发货人)")
    private Long userId;

    @ApiModelProperty(value = "客户id")
    private Long customerId;

    // 管理端
    @ApiModelProperty(value = "发货人客户ID")
    private Long consignorCustomerId;

    @ApiModelProperty(value = "收货人客户ID")
    private Long consigneeCustomerId;

    @ApiModelProperty(value = "发货客户联系人ID")
    private Long consignorCustomerContactsId;

    @ApiModelProperty(value = "收货客户联系人ID")
    private Long consigneeCustomerContactsId;

    @ApiModelProperty(value = "商品列表信息")
    @NotNull(message = "商品列表信息不能为空")
    @NotEmpty(message = "商品列表信息不能为空")
    private List<ProdConditionParam> prodConditionParamList;

    @ApiModelProperty(value = "运输方式", required = true)
    @NotNull(message = "transport.not.null")
    private Integer transportId;

    @ApiModelProperty(value = "线路ID", required = true)
    @NotNull(message = "line.not.null")
    private Long lineId;

    @ApiModelProperty(value = "渠道ID")
    private Long channelId;
}
