package cn.iocoder.yudao.module.product.param;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import javax.validation.constraints.NotNull;
import java.util.Date;

@Data
@ApiModel(value = "优惠修改过期时间接口调用参数")
public class CouponDelayTimeParam {

    @ApiModelProperty(value = "优惠ID", required = true)
    @NotNull(message = "coupon.id.not.null")
    private Long couponId;

    @ApiModelProperty(value = "新的有效期")
    @DateTimeFormat(pattern = "yyyy-MM-dd")
    @JsonFormat(pattern = "yyyy-MM-dd")
    private Date endTime;

    @ApiModelProperty(value = "是否设置有效期", required = true)
    @NotNull(message = "coupon.set.validity.param.not.null")
    private Boolean isValidity;
}
