package cn.iocoder.yudao.module.product.param;

import com.alibaba.excel.annotation.ExcelProperty;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import java.math.BigDecimal;
import java.util.Date;
import java.util.List;

import static cn.iocoder.yudao.framework.common.util.date.DateUtils.FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND;

/**
* 入仓货物详情 Response VO
* @author yanghao
*/
@Data
public class WarehouseInInfoParam {

    @ApiModelProperty(value = "是否多规格")
    private Boolean isMultiSpecification;

    @ApiModelProperty(value = "入仓次数")
    private Integer totalRecords;

    @ExcelProperty("箱/件数")
    @ApiModelProperty(value = "箱/件数", required = true)
    private Integer cartonsNum;

    @ExcelProperty("类型")
    @ApiModelProperty(value = "类型，多了还是少了，见字典order_item_status", required = true)
    private Integer diffType;

    @ExcelProperty("箱/件数差")
    @ApiModelProperty(value = "箱/件数差", required = true)
    private Integer cartonsNumDiff;

    @ExcelProperty("所有箱内总货物数量")
    @ApiModelProperty(value = "所有箱内总货物数量")
    private Integer quantityAll;

    @ExcelProperty("单位")
    @ApiModelProperty(value = "单位", required = true)
    private String unit;


    @ApiModelProperty(value = "入仓规格类型")
    private Integer specificationType;

    @ApiModelProperty(value = "单位-拼接所有")
    private String units;
    /**
     * 箱规
     */
    @ExcelProperty("箱规")
    @ApiModelProperty(value = "箱规")
    private String boxGauge;

    @ExcelProperty("体积")
    @ApiModelProperty(value = "体积")
    private BigDecimal volume;

    @ExcelProperty("重量")
    @ApiModelProperty(value = "重量")
    private BigDecimal weight;


    @ExcelProperty("快递单号")
    @ApiModelProperty(value = "快递单号")
    private String expressNo;


    @ExcelProperty("备注")
    @ApiModelProperty(value = "备注")
    private String remark;


    @ExcelProperty("最早入仓时间")
    @DateTimeFormat(pattern = FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND)
    @ApiModelProperty(value = "入仓时间")
    private Date firstInTime;

    @ExcelProperty("创建时间")
    @DateTimeFormat(pattern = FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND)
    @ApiModelProperty(value = "创建时间", required = true)
    private Date createTime;

    /**
     * 重货方数
     */
    @ApiModelProperty(value = "入仓货物-重货方数")
    private BigDecimal heavyNumber;


    /**
     * 泡货方数
     */
    @ApiModelProperty(value = "入仓货物-泡货方数")
    private BigDecimal lightNumber;


    @ApiModelProperty(value = "混箱状态, 1-混箱")
    private Integer mixStatus = 0;


    @ApiModelProperty(value = "入仓影像列表")
    private List<String> pictureUrls;

}
