package cn.iocoder.yudao.module.product.service.product;

import cn.iocoder.yudao.framework.mybatis.core.service.IService;
import cn.iocoder.yudao.module.product.dal.dataobject.product.ProductPriceStepClearanceDO;
import cn.iocoder.yudao.module.product.vo.product.ProductPriceStepClearanceBackVO;

import java.math.BigDecimal;
import java.util.List;

/**
 * 产品清关费阶梯价格 Service 接口
 *
 * @author jiuping
 */
public interface ProductPriceStepClearanceService extends IService<ProductPriceStepClearanceDO> {

    /**
     * 根据产品ID获取产品的阶梯定价
     *
     * @param productId
     * @return 阶梯定价列表
     */
    List<ProductPriceStepClearanceBackVO> getProductPriceStepClearanceList(Long productId);

    List<ProductPriceStepClearanceBackVO> getProductPriceStepClearanceList(List<Long> idList);


    /**
     * 根据标定量获取范围内的价格
     *
     * @param productId 线路价格主表id
     * @param num            标定量
     * @return
     */
    ProductPriceStepClearanceDO getProductPriceStepClearance(Long productId, BigDecimal num);



}
