package cn.iocoder.yudao.module.product.service.product;

import cn.iocoder.yudao.framework.mybatis.core.service.IService;
import cn.iocoder.yudao.module.product.dal.dataobject.product.BasePrice;
import cn.iocoder.yudao.module.product.dal.dataobject.product.ProductPriceStepDO;

import java.math.BigDecimal;
import java.util.List;

/**
 * 产品阶梯价格 Service 接口
 *
 * @author jiuping
 */
public interface ProductPriceStepService extends IService<ProductPriceStepDO> {

    /**
     * 根据价格ID获取产品的阶梯定价
     *
     * @param productPriceId productPriceId
     * @return 阶梯定价列表
     */
    List<ProductPriceStepDO> getProductPriceStepList(Long productPriceId);

    List<ProductPriceStepDO> getProductPriceStepList(List<Long> idList);


    /**
     * 根据标定量获取范围内的价格
     *
     * @param productPriceId 线路价格主表id
     * @param num            标定量
     * @return 阶梯价格
     */
    @Deprecated
    ProductPriceStepDO getProductPriceStep(Long productPriceId, BigDecimal num);

    /**
     * 根据标定量获取范围内的价格
     *
     * @param productPriceId 线路价格主表id
     * @param num            标定量
     * @param priceType      价格类型：0-运费，1-全包价, 2-清关费
     * @return 阶梯价格
     */
    BasePrice getProductPriceStep(Long productPriceId, BigDecimal num, Integer priceType);
}
