package cn.iocoder.yudao.module.product.service.product.impl;

import java.util.*;
import javax.annotation.Resource;

import cn.iocoder.yudao.module.product.convert.product.ProductBatchLogConvert;
import cn.iocoder.yudao.module.product.dal.dataobject.product.ProductBatchLogDO;
import cn.iocoder.yudao.module.product.dal.mysql.product.ProductBatchLogMapper;
import cn.iocoder.yudao.module.product.service.product.ProductBatchLogService;
import cn.iocoder.yudao.module.product.vo.product.ProductBatchLogCreateReqVO;
import cn.iocoder.yudao.module.product.vo.product.ProductBatchLogQueryVO;
import cn.iocoder.yudao.module.product.vo.product.ProductBatchLogUpdateReqVO;
import org.springframework.stereotype.Service;
import org.springframework.validation.annotation.Validated;
import cn.iocoder.yudao.framework.mybatis.core.vo.PageVO;
import cn.iocoder.yudao.framework.mybatis.core.service.AbstractService;
import cn.iocoder.yudao.framework.common.pojo.PageResult;

/**
 * 产品批量操作日志 Service 实现类
 *
 * @author wlh
 */
@Service
@Validated
public class ProductBatchLogServiceImpl extends AbstractService<ProductBatchLogMapper, ProductBatchLogDO> implements ProductBatchLogService {

    @Resource
    private ProductBatchLogMapper productBatchLogMapper;

    @Override
    public Long createProductBatchLog(ProductBatchLogCreateReqVO createReqVO) {
        // 插入
        ProductBatchLogDO productBatchLog = ProductBatchLogConvert.INSTANCE.convert(createReqVO);
        productBatchLogMapper.insert(productBatchLog);
        // 返回
        return productBatchLog.getId();
    }

    @Override
    public void updateProductBatchLog(ProductBatchLogUpdateReqVO updateReqVO) {
        // 更新
        ProductBatchLogDO updateObj = ProductBatchLogConvert.INSTANCE.convert(updateReqVO);
        productBatchLogMapper.updateById(updateObj);
    }

    @Override
    public void deleteProductBatchLog(Long id) {
        // 删除
        productBatchLogMapper.deleteById(id);
    }


    @Override
    public ProductBatchLogDO getProductBatchLog(Long id) {
        return productBatchLogMapper.selectById(id);
    }

    @Override
    public List<ProductBatchLogDO> getProductBatchLogList(Collection<Long> ids) {
        return productBatchLogMapper.selectBatchIds(ids);
    }

    @Override
    public PageResult<ProductBatchLogDO> getProductBatchLogPage(ProductBatchLogQueryVO query, PageVO page) {
        return productBatchLogMapper.selectPage(page, query);
    }

    @Override
    public List<ProductBatchLogDO> getProductBatchLogList(ProductBatchLogQueryVO query) {
        return productBatchLogMapper.selectList(query);
    }
}
