package cn.iocoder.yudao.module.product.service.product.impl;

import cn.iocoder.yudao.framework.mybatis.core.query.LambdaQueryWrapperX;
import cn.iocoder.yudao.framework.mybatis.core.service.AbstractService;
import cn.iocoder.yudao.module.product.dal.dataobject.product.ProductPriceSpecialDO;
import cn.iocoder.yudao.module.product.dal.mysql.product.ProductPriceSpecialMapper;
import cn.iocoder.yudao.module.product.service.product.ProductPriceSpecialService;
import org.springframework.stereotype.Service;
import org.springframework.validation.annotation.Validated;

import javax.annotation.Resource;
import java.util.List;

@Service
@Validated
public class ProductPriceSpecialServiceImpl extends AbstractService<ProductPriceSpecialMapper, ProductPriceSpecialDO> implements ProductPriceSpecialService {

    @Resource
    private ProductPriceSpecialMapper productPriceSpecialMapper;


    @Override
    public List<ProductPriceSpecialDO> getProductPriceSpecialList(Long productPriceId) {
        return productPriceSpecialMapper.selectList(new LambdaQueryWrapperX<ProductPriceSpecialDO>()
            .eq(ProductPriceSpecialDO::getProductPriceId, productPriceId)
                .eq(ProductPriceSpecialDO::getDeleted, 0)
        );
    }

    @Override
    public List<ProductPriceSpecialDO> getProductPriceSpecialList(List<Long> idList) {
        return productPriceSpecialMapper.selectList(new LambdaQueryWrapperX<ProductPriceSpecialDO>()
                .in(ProductPriceSpecialDO::getProductPriceId, idList)
                .eq(ProductPriceSpecialDO::getDeleted, 0)
        );
    }
}
