package cn.iocoder.yudao.module.product.service.productBrandTrademarkCateogryRel;

import java.util.*;
import javax.validation.*;
import cn.iocoder.yudao.module.product.vo.productBrandTrademarkCateogryRel.*;
import cn.iocoder.yudao.module.product.dal.dataobject.productBrandTrademarkCateogryRel.ProductBrandTrademarkCateogryRelDO;
import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.framework.mybatis.core.service.IService;
import cn.iocoder.yudao.module.product.vo.productBrandTrademarkCateogryRel.ProductBrandTrademarkCateogryRelCreateReqVO;
import cn.iocoder.yudao.module.product.vo.productBrandTrademarkCateogryRel.ProductBrandTrademarkCateogryRelExportReqVO;
import cn.iocoder.yudao.module.product.vo.productBrandTrademarkCateogryRel.ProductBrandTrademarkCateogryRelPageReqVO;
import cn.iocoder.yudao.module.product.vo.productBrandTrademarkCateogryRel.ProductBrandTrademarkCateogryRelUpdateReqVO;

/**
 * 商标与商品分类关联 Service 接口
 *
 * @author 江楠
 */
public interface ProductBrandTrademarkCateogryRelService extends IService<ProductBrandTrademarkCateogryRelDO> {

    /**
     * 创建商标与商品分类关联
     *
     * @param createReqVO 创建信息
     * @return 编号
     */
    Long createProductBrandTrademarkCateogryRel(@Valid ProductBrandTrademarkCateogryRelCreateReqVO createReqVO);

    /**
     * 更新商标与商品分类关联
     *
     * @param updateReqVO 更新信息
     */
    void updateProductBrandTrademarkCateogryRel(@Valid ProductBrandTrademarkCateogryRelUpdateReqVO updateReqVO);

    /**
     * 删除商标与商品分类关联
     *
     * @param id 编号
     */
    void deleteProductBrandTrademarkCateogryRel(Long id);

    /**
     * 获得商标与商品分类关联
     *
     * @param id 编号
     * @return 商标与商品分类关联
     */
    ProductBrandTrademarkCateogryRelDO getProductBrandTrademarkCateogryRel(Long id);

    /**
     * 获得商标与商品分类关联列表
     *
     * @param ids 编号
     * @return 商标与商品分类关联列表
     */
    List<ProductBrandTrademarkCateogryRelDO> getProductBrandTrademarkCateogryRelList(Collection<Long> ids);

    /**
     * 获得商标与商品分类关联分页
     *
     * @param pageReqVO 分页查询
     * @return 商标与商品分类关联分页
     */
    PageResult<ProductBrandTrademarkCateogryRelDO> getProductBrandTrademarkCateogryRelPage(ProductBrandTrademarkCateogryRelPageReqVO pageReqVO);

    /**
     * 获得商标与商品分类关联列表, 用于 Excel 导出
     *
     * @param exportReqVO 查询条件
     * @return 商标与商品分类关联列表
     */
    List<ProductBrandTrademarkCateogryRelDO> getProductBrandTrademarkCateogryRelList(ProductBrandTrademarkCateogryRelExportReqVO exportReqVO);



}
