package cn.iocoder.yudao.module.product.service.productBrandTrademarkCateogryRel;

import cn.iocoder.yudao.framework.common.exception.util.ServiceExceptionUtil;
import cn.iocoder.yudao.module.product.convert.productBrandTrademarkCateogryRel.ProductBrandTrademarkCateogryRelConvert;
import cn.iocoder.yudao.module.product.dal.mysql.productBrandTrademarkCateogryRel.ProductBrandTrademarkCateogryRelMapper;
import cn.iocoder.yudao.module.product.enums.ErrorCodeConstants;
import cn.iocoder.yudao.module.product.vo.productBrandTrademarkCateogryRel.ProductBrandTrademarkCateogryRelCreateReqVO;
import cn.iocoder.yudao.module.product.vo.productBrandTrademarkCateogryRel.ProductBrandTrademarkCateogryRelExportReqVO;
import cn.iocoder.yudao.module.product.vo.productBrandTrademarkCateogryRel.ProductBrandTrademarkCateogryRelPageReqVO;
import cn.iocoder.yudao.module.product.vo.productBrandTrademarkCateogryRel.ProductBrandTrademarkCateogryRelUpdateReqVO;
import org.springframework.stereotype.Service;
import javax.annotation.Resource;
import org.springframework.validation.annotation.Validated;

import java.util.*;
import cn.iocoder.yudao.framework.mybatis.core.service.AbstractService;
import cn.iocoder.yudao.module.product.vo.productBrandTrademarkCateogryRel.*;
import cn.iocoder.yudao.module.product.dal.dataobject.productBrandTrademarkCateogryRel.ProductBrandTrademarkCateogryRelDO;
import cn.iocoder.yudao.framework.common.pojo.PageResult;

import static cn.iocoder.yudao.framework.common.exception.util.ServiceExceptionUtil.exception;

/**
 * 商标与商品分类关联 Service 实现类
 *
 * @author 江楠
 */
@Service
@Validated
public class ProductBrandTrademarkCateogryRelServiceImpl extends AbstractService<ProductBrandTrademarkCateogryRelMapper, ProductBrandTrademarkCateogryRelDO> implements ProductBrandTrademarkCateogryRelService {

    @Resource
    private ProductBrandTrademarkCateogryRelMapper productBrandTrademarkCateogryRelMapper;

    @Override
    public Long createProductBrandTrademarkCateogryRel(ProductBrandTrademarkCateogryRelCreateReqVO createReqVO) {
        // 插入
        ProductBrandTrademarkCateogryRelDO productBrandTrademarkCateogryRel = ProductBrandTrademarkCateogryRelConvert.INSTANCE.convert(createReqVO);
        productBrandTrademarkCateogryRelMapper.insert(productBrandTrademarkCateogryRel);
        // 返回
        return productBrandTrademarkCateogryRel.getId();
    }

    @Override
    public void updateProductBrandTrademarkCateogryRel(ProductBrandTrademarkCateogryRelUpdateReqVO updateReqVO) {
        // 校验存在
        this.validateProductBrandTrademarkCateogryRelExists(updateReqVO.getId());
        // 更新
        ProductBrandTrademarkCateogryRelDO updateObj = ProductBrandTrademarkCateogryRelConvert.INSTANCE.convert(updateReqVO);
        productBrandTrademarkCateogryRelMapper.updateById(updateObj);
    }

    @Override
    public void deleteProductBrandTrademarkCateogryRel(Long id) {
        // 校验存在
        this.validateProductBrandTrademarkCateogryRelExists(id);
        // 删除
        productBrandTrademarkCateogryRelMapper.deleteById(id);
    }

    private void validateProductBrandTrademarkCateogryRelExists(Long id) {
        if (productBrandTrademarkCateogryRelMapper.selectById(id) == null) {
            throw ServiceExceptionUtil.exception(ErrorCodeConstants.PRODUCT_BRAND_TRADEMARK_CATEOGRY_REL_NOT_EXISTS);
        }
    }

    @Override
    public ProductBrandTrademarkCateogryRelDO getProductBrandTrademarkCateogryRel(Long id) {
        return productBrandTrademarkCateogryRelMapper.selectById(id);
    }

    @Override
    public List<ProductBrandTrademarkCateogryRelDO> getProductBrandTrademarkCateogryRelList(Collection<Long> ids) {
        return productBrandTrademarkCateogryRelMapper.selectBatchIds(ids);
    }

    @Override
    public PageResult<ProductBrandTrademarkCateogryRelDO> getProductBrandTrademarkCateogryRelPage(ProductBrandTrademarkCateogryRelPageReqVO pageReqVO) {
        return productBrandTrademarkCateogryRelMapper.selectPage(pageReqVO);
    }

    @Override
    public List<ProductBrandTrademarkCateogryRelDO> getProductBrandTrademarkCateogryRelList(ProductBrandTrademarkCateogryRelExportReqVO exportReqVO) {
        return productBrandTrademarkCateogryRelMapper.selectList(exportReqVO);
    }

}
