package cn.iocoder.yudao.module.product.service.productBrandTrademarkRel;

import java.util.*;
import javax.validation.*;
import cn.iocoder.yudao.module.product.vo.productBrandTrademarkRel.*;
import cn.iocoder.yudao.module.product.dal.dataobject.productBrandTrademarkRel.ProductBrandTrademarkRelDO;
import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.framework.mybatis.core.service.IService;
import cn.iocoder.yudao.module.product.vo.productBrandTrademarkRel.ProductBrandTrademarkRelCreateReqVO;
import cn.iocoder.yudao.module.product.vo.productBrandTrademarkRel.ProductBrandTrademarkRelExportReqVO;
import cn.iocoder.yudao.module.product.vo.productBrandTrademarkRel.ProductBrandTrademarkRelPageReqVO;
import cn.iocoder.yudao.module.product.vo.productBrandTrademarkRel.ProductBrandTrademarkRelUpdateReqVO;

/**
 * 商品品牌与商标关联 Service 接口
 *
 * @author 江楠
 */
public interface ProductBrandTrademarkRelService extends IService<ProductBrandTrademarkRelDO> {

    /**
     * 创建商品品牌与商标关联
     *
     * @param createReqVO 创建信息
     * @return 编号
     */
    Long createProductBrandTrademarkRel(@Valid ProductBrandTrademarkRelCreateReqVO createReqVO);

    /**
     * 更新商品品牌与商标关联
     *
     * @param updateReqVO 更新信息
     */
    void updateProductBrandTrademarkRel(@Valid ProductBrandTrademarkRelUpdateReqVO updateReqVO);

    /**
     * 删除商品品牌与商标关联
     *
     * @param id 编号
     */
    void deleteProductBrandTrademarkRel(Long id);

    /**
     * 获得商品品牌与商标关联
     *
     * @param id 编号
     * @return 商品品牌与商标关联
     */
    ProductBrandTrademarkRelDO getProductBrandTrademarkRel(Long id);

    /**
     * 获得商品品牌与商标关联列表
     *
     * @param ids 编号
     * @return 商品品牌与商标关联列表
     */
    List<ProductBrandTrademarkRelDO> getProductBrandTrademarkRelList(Collection<Long> ids);

    /**
     * 获得商品品牌与商标关联分页
     *
     * @param pageReqVO 分页查询
     * @return 商品品牌与商标关联分页
     */
    PageResult<ProductBrandTrademarkRelDO> getProductBrandTrademarkRelPage(ProductBrandTrademarkRelPageReqVO pageReqVO);

    /**
     * 获得商品品牌与商标关联列表, 用于 Excel 导出
     *
     * @param exportReqVO 查询条件
     * @return 商品品牌与商标关联列表
     */
    List<ProductBrandTrademarkRelDO> getProductBrandTrademarkRelList(ProductBrandTrademarkRelExportReqVO exportReqVO);

}
