package cn.iocoder.yudao.module.product.service.productBrandUnauthEmpower;

import java.util.*;
import javax.annotation.Resource;

import cn.hutool.core.collection.CollectionUtil;
import cn.iocoder.yudao.framework.common.exception.util.ServiceExceptionUtil;
import cn.iocoder.yudao.framework.security.core.util.SecurityFrameworkUtils;
import cn.iocoder.yudao.module.customer.dal.dataobject.customerContacts.CustomerContactsDO;
import cn.iocoder.yudao.module.customer.dal.mysql.customer.CustomerMapper;
import cn.iocoder.yudao.module.customer.dal.mysql.customerContacts.CustomerContactsMapper;
import cn.iocoder.yudao.module.product.dal.mysql.productbrank.ProductBrankMapper;
import cn.iocoder.yudao.module.product.enums.ErrorCodeConstants;
import cn.iocoder.yudao.module.product.vo.productBrandUnauthEmpower.ProductBrandUnauthEmpowerQueryVO;
import cn.iocoder.yudao.module.product.vo.productBrandUnauthEmpower.ProductBrandUnauthEmpowerUpdateReqVO;
import org.springframework.stereotype.Service;
import org.springframework.validation.annotation.Validated;
import cn.iocoder.yudao.framework.mybatis.core.service.AbstractService;
import cn.iocoder.yudao.module.product.dal.dataobject.productBrandUnauthEmpower.ProductBrandUnauthEmpowerDO;
import cn.iocoder.yudao.module.product.dal.mysql.productBrandUnauthEmpower.ProductBrandUnauthEmpowerMapper;
import static cn.iocoder.yudao.framework.common.exception.util.ServiceExceptionUtil.exception;
import static cn.iocoder.yudao.module.product.enums.ErrorCodeConstants.PRODUCT_BRAND_UNAUTH_EMPOWER_NOT_EXISTS;

/**
 * 商品品牌-未授权客户-指定收费标准 Service 实现类
 *
 * @author 江楠
 */
@Service
@Validated
public class ProductBrandUnauthEmpowerServiceImpl extends AbstractService<ProductBrandUnauthEmpowerMapper, ProductBrandUnauthEmpowerDO> implements ProductBrandUnauthEmpowerService {

    @Resource
    private ProductBrandUnauthEmpowerMapper productBrandUnauthEmpowerMapper;

    @Resource
    CustomerContactsMapper customerContactsMapper;
    @Resource
    CustomerMapper customerMapper;
    @Resource
    ProductBrankMapper productBrankMapper;
    @Override
    public boolean updateProductBrandUnauthEmpower(ProductBrandUnauthEmpowerUpdateReqVO updateReqVO) {
//        // 校验存在
        if(productBrankMapper.selectById(updateReqVO.getProductBrandId())==null){
            throw ServiceExceptionUtil.exception(ErrorCodeConstants.PRODUCT_BRANK_NOT_EXISTS);
        }
        if(customerMapper.selectById(updateReqVO.getCustomerId())==null){
            throw ServiceExceptionUtil.exception(ErrorCodeConstants.CUSTOMER_CONTACTS_NOT_NULL);
        }
//        this.validateProductBrandUnauthEmpowerExists(updateReqVO.getId());
        ProductBrandUnauthEmpowerDO param=new ProductBrandUnauthEmpowerDO();
        param.setProductBrandId(updateReqVO.getProductBrandId());
        param.setCustomerId(updateReqVO.getCustomerId());

        List<ProductBrandUnauthEmpowerDO> list=productBrandUnauthEmpowerMapper.selectList( param);
        CustomerContactsDO customerContactsDO=new CustomerContactsDO();
        customerContactsDO.setCustomerId(updateReqVO.getCustomerId());
        customerContactsDO.setIsDefault(1);
        customerContactsDO.setDeleted(false);
        // List<CustomerContactsDO> customerContactsDOList=customerContactsMapper.selectList(customerContactsDO);
        // long customerContactsId=0;
        // if(CollectionUtil.isNotEmpty(customerContactsDOList)) {
        //     CustomerContactsDO customerContactsDO1 = customerContactsDOList.get(0);
        //     customerContactsId = customerContactsDO1.getId();
        // }

        if (list == null||list.size()==0) {
            //授权信息不存在,新建一个
            ProductBrandUnauthEmpowerDO productBrandUnauthEmpower = new ProductBrandUnauthEmpowerDO();
            productBrandUnauthEmpower.setCustomerId(customerContactsDO.getCustomerId());
            // productBrandUnauthEmpower.setCustomerContactsId(customerContactsId);
            productBrandUnauthEmpower.setProductBrandId(updateReqVO.getProductBrandId());
            productBrandUnauthEmpower.setCreateUserId(SecurityFrameworkUtils.getLoginUser().getId());
            productBrandUnauthEmpower.setCreateTime(new Date());
            productBrandUnauthEmpower.setCreateUsername(SecurityFrameworkUtils.getLoginUser().getUsername());
            productBrandUnauthEmpower.setFeeScale(updateReqVO.getFeeScale());
            int row = productBrandUnauthEmpowerMapper.insert(productBrandUnauthEmpower);
            if(row>0){
                return true;
            }else{
                return false;
            }
        }
        ProductBrandUnauthEmpowerDO productBrandUnauthEmpowerDO = list.get(0);
        ProductBrandUnauthEmpowerDO productBrandUnauthEmpower = new ProductBrandUnauthEmpowerDO();
        productBrandUnauthEmpower.setCustomerId(customerContactsDO.getCustomerId());
        // productBrandUnauthEmpower.setCustomerContactsId(customerContactsId);
        productBrandUnauthEmpower.setProductBrandId(updateReqVO.getProductBrandId());
        productBrandUnauthEmpower.setCreateUserId(SecurityFrameworkUtils.getLoginUser().getId());
        productBrandUnauthEmpower.setCreateTime(new Date());
        productBrandUnauthEmpower.setCreateUsername(SecurityFrameworkUtils.getLoginUser().getUsername());
        productBrandUnauthEmpower.setFeeScale(updateReqVO.getFeeScale());
        productBrandUnauthEmpower.setId(productBrandUnauthEmpowerDO.getId());
        int row=productBrandUnauthEmpowerMapper.updateById(productBrandUnauthEmpower);
        if(row>0){
            return true;
        }
        return false;
        // 更新
//        ProductBrandUnauthEmpowerDO updateObj = ProductBrandUnauthEmpowerConvert.INSTANCE.convert(updateReqVO);
//        productBrandUnauthEmpowerMapper.updateById(updateObj);
    }


    private void validateProductBrandUnauthEmpowerExists(Long id) {
        if (productBrandUnauthEmpowerMapper.selectById(id) == null) {
            throw exception(PRODUCT_BRAND_UNAUTH_EMPOWER_NOT_EXISTS);
        }
    }

    @Override
    public List<ProductBrandUnauthEmpowerDO> getProductBrandUnauthEmpowerList(ProductBrandUnauthEmpowerQueryVO query) {
        return productBrandUnauthEmpowerMapper.selectList(query);
    }
}
