package cn.iocoder.yudao.module.product.service.productPriceSnapshot;

import java.util.*;
import javax.validation.*;
import cn.iocoder.yudao.framework.mybatis.core.vo.PageVO;
import cn.iocoder.yudao.framework.mybatis.core.service.IService;
import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.module.product.dal.dataobject.productPriceSnapshot.ProductPriceSnapshotDO;
import cn.iocoder.yudao.module.product.vo.productPriceSnapshot.ProductPriceSnapshotCreateReqVO;
import cn.iocoder.yudao.module.product.vo.productPriceSnapshot.ProductPriceSnapshotQueryVO;
import cn.iocoder.yudao.module.product.vo.productPriceSnapshot.ProductPriceSnapshotUpdateReqVO;

/**
 * 路线价格修改历史 Service 接口
 *
 * @author wlh
 */
public interface ProductPriceSnapshotService extends IService<ProductPriceSnapshotDO> {

    List<ProductPriceSnapshotDO> getByPriceId(Long priceId);

    /**
     * 创建路线价格修改历史
     * @param createReqVO 创建信息
     * @return 编号
     */
    Long createProductPriceSnapshot(@Valid ProductPriceSnapshotCreateReqVO createReqVO);

    /**
     * 更新路线价格修改历史
     * @param updateReqVO 更新信息
     */
    void updateProductPriceSnapshot(@Valid ProductPriceSnapshotUpdateReqVO updateReqVO);

    /**
     * 删除路线价格修改历史
     * @param id 编号
     */
    void deleteProductPriceSnapshot(Long id);

    /**
     * 获得路线价格修改历史
     * @param id 编号
     * @return 路线价格修改历史
     */
    ProductPriceSnapshotDO getProductPriceSnapshot(Long id);

    /**
     * 获得路线价格修改历史列表
     * @param ids 编号
     * @return 路线价格修改历史列表
     */
    List<ProductPriceSnapshotDO> getProductPriceSnapshotList(Collection<Long> ids);

    /**
     * 获得路线价格修改历史分页
     * @param page 分页查询
     * @param query 查询
     * @return 路线价格修改历史分页
     */
    PageResult<ProductPriceSnapshotDO> getProductPriceSnapshotPage(ProductPriceSnapshotQueryVO query, PageVO page);

    /**
     * 获得路线价格修改历史列表, 用于 Excel 导出
     * @param query 查询
     * @return 路线价格修改历史列表
     */
    List<ProductPriceSnapshotDO> getProductPriceSnapshotList(ProductPriceSnapshotQueryVO query);
}
