package cn.iocoder.yudao.module.product.task;

import cn.iocoder.yudao.framework.quartz.core.handler.JobHandler;
import cn.iocoder.yudao.framework.tenant.core.job.TenantJob;
import cn.iocoder.yudao.module.product.service.coupon.CouponService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Component;

import javax.annotation.Resource;

@Component
@TenantJob
@Slf4j
public class CouponTimeoutJob implements JobHandler {

    @Resource
    private CouponService couponService;

    @Override
    public String execute(String param) throws Exception {
        log.info("开始过期优惠劵和优惠活动...");
        long count = couponService.couponExpire();
        log.info("过期优惠劵和优惠活动...{}个", count);
        return String.valueOf(count);
    }

}
