package cn.iocoder.yudao.module.product.vo.coupon;

import lombok.*;

import java.math.BigDecimal;
import java.util.*;

import com.alibaba.excel.annotation.ExcelProperty;

/**
 * 优惠券信息 Excel VO
 *
 * @author 系统管理员
 */
@Data
public class CouponExcelVO {

    @ExcelProperty("优惠券ID")
    private Long couponId;

    @ExcelProperty("标题-中文")
    private String titleZh;

    @ExcelProperty("标题-英文")
    private String titleEn;

    @ExcelProperty("类型 1:优惠卷 2:金额-满减 3:方数-满减 4 折扣 5优惠 6 特价 7区间价")
    private Integer type;

    @ExcelProperty("使用条件(优惠卷专用)")
    private BigDecimal cashCondition;

    @ExcelProperty("减免金额(优惠卷专用)")
    private BigDecimal reduceAmount;

    @ExcelProperty("条件货币ID")
    private Integer conditionCurrencyId;

    @ExcelProperty("开始时间")
    private Date startTime;

    @ExcelProperty("减免货币ID")
    private Integer reduceCurrencyId;

    @ExcelProperty("结束时间")
    private Date endTime;

    @ExcelProperty("领券后X天起生效")
    private Integer afterReceiveDays;

    @ExcelProperty("有效天数")
    private Integer validDays;

    @ExcelProperty("费用类型：1 运输费 2 清关费 3 总费用(优惠卷专用)")
    private Integer costType;

    @ExcelProperty("优惠清单")
    private String discountDetailed;

    @ExcelProperty("同类优惠劵是否可以叠加 0否  1是")
    private Boolean isSimilarSuperposition;

    @ExcelProperty("可叠加优惠劵列表")
    private String couponIds;

    @ExcelProperty("适用用户类型 0全部用户 1部分用户 2指定用户不参与 3 注册即送")
    private Integer suitableUserType;

    @ExcelProperty("适用线路类型 0全部线路参与 1指定线路参与 2指定线路不参与")
    private Integer suitableLineType;

    @ExcelProperty("适用产品类型 0全部产品参与 1指定产品参与 2指定产品不参与")
    private Integer suitableProdType;

    @ExcelProperty("每个用户领券上限，如不填则默认为1")
    private Integer limitNum;

    @ExcelProperty("优惠券过期状态 0:过期 1:未过期")
    private Boolean overdueStatus;

    @ExcelProperty("优惠券投放状态(-1:取消投放 0:等待投放 1:投放 2:违规下架 3:等待审核)")
    private Integer putonStatus;

    @ExcelProperty("获取方式 0=客户领取 1=平台发放")
    private Integer getWay;

    @ExcelProperty("订单属性(可多选) 1 普货 2重货 3泡货")
    private String orderAttr;

    @ExcelProperty("是否发送站内信 0否  1是")
    private Boolean isSiteContent;

    @ExcelProperty(value = "品牌(可多选): 0 无牌价 1 有牌价 2 中性价")
    private String brand;

    @ExcelProperty("是否控货(可多选) 0否 1是")
    private String isCargoControl;

    @ExcelProperty("单证报关(可多选) 1 我司全代 2自单代报 3混合报关")
    private String documentDeclaration;

    @ExcelProperty("优惠券状态(0:草稿 1:发布)")
    private Integer status;

    @ExcelProperty("创建时间")
    private Date createTime;

}
