package cn.iocoder.yudao.module.product.vo.coupon;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.math.BigDecimal;

/**
 * 使用的优惠明细详情
 */
@ApiModel("优惠明细详情")
@Data
public class CouponInfoVO {

    @ApiModelProperty(value = "优惠券ID", required = true)
    private Long couponId;

    @ApiModelProperty(value = "标题-中文")
    private String titleZh;

    @ApiModelProperty(value = "标题-英文")
    private String titleEn;

    @ApiModelProperty(value = "类型 1:优惠卷 2:金额-满减 3:方数-满减 4 折扣 5优惠 6 特价 7区间价")
    private Integer type;

    @ApiModelProperty(value = "运费减免金额")
    private BigDecimal freightReduceAmount = BigDecimal.ZERO;

    @ApiModelProperty(value = "运费减免货币ID")
    private Integer freightReduceCurrencyId;

    @ApiModelProperty(value = "清关费减免金额")
    private BigDecimal clearanceReduceAmount = BigDecimal.ZERO;

    @ApiModelProperty(value = "清关费减免货币ID")
    private Integer clearanceReduceCurrencyId;

    @ApiModelProperty(value = "运费优惠详情")
    private DiscountDetailedVO freightDetailed;

    @ApiModelProperty(value = "清关费优惠详情")
    private DiscountDetailedVO clearanceDetailed;
}
