package cn.iocoder.yudao.module.product.vo.coupon;

import cn.iocoder.yudao.module.product.dal.dataobject.coupon.CouponLineDO;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.ToString;

import java.util.Date;
import java.util.List;

@ApiModel("管理后台 - 新增商品可用优惠信息 Response VO")
@Data
@EqualsAndHashCode(callSuper = true)
@ToString(callSuper = true)
public class CouponProdRespVO extends CouponBaseVO{

    @ApiModelProperty(value = "优惠券ID", required = true)
    private Long couponId;

    @ApiModelProperty(value = "创建时间", required = true)
    private Date createTime;

    @ApiModelProperty(value = "更新时间", required = true)
    private Date updateTime;

    @ApiModelProperty(value = "优惠清单")
    private List<DiscountDetailedVO> discountDetailedVOs;

    @ApiModelProperty(value = "用户ID列表")
    private List<Long> customerIds;

    @ApiModelProperty(value = "产品ID列表")
    private List<Long> prodIds;

    @ApiModelProperty(value = "线路列表")
    private List<CouponLineDO> lineIds;

    @ApiModelProperty(value = "创建者，目前使用 SysUser 的 id 编号")
    private String creator;

    @ApiModelProperty(value = "创建者名称")
    private String creatorName;

    @ApiModelProperty(value = "更新者，目前使用 SysUser 的 id 编号")
    private String updater;

    @ApiModelProperty(value = "更新者名称")
    private String updaterName;


    @ApiModelProperty(value = "是否必选(一般优惠活动的商品类型为全部时必选)", required = true)
    private Boolean mandatory;

    @ApiModelProperty(value = "是否默认(默认可用此优惠信息)", required = true)
    private Boolean isDefault;

}
