package cn.iocoder.yudao.module.product.vo.coupon;

import cn.iocoder.yudao.module.product.dal.dataobject.coupon.CouponLineDO;
import lombok.*;
import java.util.*;
import io.swagger.annotations.*;

@ApiModel("管理后台 - 优惠券信息 Response VO")
@Data
@EqualsAndHashCode(callSuper = true)
@ToString(callSuper = true)
public class CouponRespVO extends CouponBaseVO {

    @ApiModelProperty(value = "优惠券ID", required = true)
    private Long couponId;

    @ApiModelProperty(value = "创建时间", required = true)
    private Date createTime;

    @ApiModelProperty(value = "更新时间", required = true)
    private Date updateTime;

    @ApiModelProperty(value = "优惠清单")
    private List<DiscountDetailedVO>  discountDetailedVOs;

    @ApiModelProperty(value = "用户ID列表")
    private List<Long> customerIds;

    @ApiModelProperty(value = "产品ID列表")
    private List<Long> prodIds;

    @ApiModelProperty(value = "线路列表")
    private List<CouponLineDO> lineIds;

    @ApiModelProperty(value = "内容-中文")
    private String contentZh;

    @ApiModelProperty(value = "内容-英文")
    private String contentEn;

    @ApiModelProperty(value = "创建者，目前使用 SysUser 的 id 编号")
    private String creator;

    @ApiModelProperty(value = "创建者名称")
    private String creatorName;

    @ApiModelProperty(value = "更新者，目前使用 SysUser 的 id 编号")
    private String updater;

    @ApiModelProperty(value = "更新者名称")
    private String updaterName;

}
