package cn.iocoder.yudao.module.product.vo.coupon;

import cn.iocoder.yudao.module.product.vo.coupon.line.CouponLineUpdateReqVO;
import lombok.*;
import java.util.*;
import io.swagger.annotations.*;
import javax.validation.constraints.*;

@ApiModel("管理后台 - 优惠券信息更新 Request VO")
@Data
@EqualsAndHashCode(callSuper = true)
@ToString(callSuper = true)
public class CouponUpdateReqVO extends CouponBaseVO {

    @ApiModelProperty(value = "优惠券ID", required = true)
    @NotNull(message = "coupon.id.not.null")
    private Long couponId;

    @ApiModelProperty(value = "优惠清单")
    private List<DiscountDetailedVO>  discountDetailedVOs;

    @ApiModelProperty(value = "用户ID列表")
    private List<Long> customerIds;

    @ApiModelProperty(value = "产品ID列表")
    private List<Long> prodIds;

    @ApiModelProperty(value = "线路ID列表")
    private List<CouponLineUpdateReqVO> lineIds;

    @ApiModelProperty(value = "内容-中文")
    private String contentZh;

    @ApiModelProperty(value = "内容-英文")
    private String contentEn;

}
