package cn.iocoder.yudao.module.product.vo.coupon;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.math.BigDecimal;
import java.math.RoundingMode;
import java.util.Objects;

@ApiModel("优惠券 - 优惠清单")
@Data
public class DiscountDetailedVO {

    @ApiModelProperty(value = "1 运费 2 清关费")
    private Integer type;

    @ApiModelProperty(value = "起(区间价)")
    private BigDecimal startAmount = BigDecimal.ZERO;

    @ApiModelProperty(value = "始(区间价)")
    private BigDecimal endAmount = BigDecimal.ZERO;

    @ApiModelProperty(value = "货币(起-始)")
    private Integer startAndEndCurrencyId;

    @ApiModelProperty(value = "满(金额/立方)")
    private BigDecimal fullAmount = BigDecimal.ZERO;

    @ApiModelProperty(value = "货币ID(满)")
    private Integer fullCurrencyId;

    @ApiModelProperty(value = "减/折扣/收")
    private BigDecimal reduceAmount = BigDecimal.ZERO;

    @ApiModelProperty(value = "货币(减/折扣/收)")
    private Integer reduceCurrencyId;

    @ApiModelProperty(value = "计量单位")
    private Long prodUnit;

    @ApiModelProperty(value = "实收金额(优惠应收/区间价应收)")
    private BigDecimal netReceiptsAmount = BigDecimal.ZERO;

    @ApiModelProperty(value = "货币(实收金额ID)")
    private Integer netReceiptsCurrencyId;


    public void setStartAmount(BigDecimal startAmount) {
        this.startAmount = Objects.isNull(startAmount)? null: startAmount.setScale(2, RoundingMode.HALF_UP);
    }

    public void setEndAmount(BigDecimal endAmount) {
        this.endAmount = Objects.isNull(endAmount)? null: endAmount.setScale(2, RoundingMode.HALF_UP);
    }



    public void setFullAmount(BigDecimal fullAmount) {
        this.fullAmount = Objects.isNull(fullAmount)? null: fullAmount.setScale(2, RoundingMode.HALF_UP);
    }



    public void setReduceAmount(BigDecimal reduceAmount) {
        this.reduceAmount = Objects.isNull(reduceAmount)? null: reduceAmount.setScale(2, RoundingMode.HALF_UP);
    }

    public void setNetReceiptsAmount(BigDecimal netReceiptsAmount) {
        this.netReceiptsAmount = Objects.isNull(netReceiptsAmount)? null: netReceiptsAmount.setScale(2, RoundingMode.HALF_UP);
    }

}
