package cn.iocoder.yudao.module.product.vo.coupon.customer;

import cn.iocoder.yudao.module.product.dal.dataobject.coupon.CouponLineDO;
import cn.iocoder.yudao.module.product.dal.dataobject.coupon.CouponProdDO;
import cn.iocoder.yudao.module.product.vo.coupon.CouponBaseVO;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.ToString;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.Date;
import java.util.List;

import static cn.iocoder.yudao.framework.common.util.date.DateUtils.FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND;

@ApiModel("管理后台 - 优惠券客户关联信息创建 Request VO")
@Data
@EqualsAndHashCode(callSuper = true)
@ToString(callSuper = true)
public class CouponCustomerInfoVO extends CouponBaseVO {


    @ApiModelProperty(value = "优惠券ID")
    private Long couponId;

    @ApiModelProperty(value = "web端用户ID")
    private Long userId;

    @ApiModelProperty(value = "客户ID")
    private Long customerId;

    @ApiModelProperty(value = "领券时间")
    @DateTimeFormat(pattern = FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND)
    private Date receiveTime;

    @ApiModelProperty(value = "优惠券状态 0:失效 1:有效 2:使用过")
    private Integer status;

    @ApiModelProperty(value = "开始时间")
    @DateTimeFormat(pattern = FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND)
    private Date userStartTime;

    @ApiModelProperty(value = "结束时间")
    @DateTimeFormat(pattern = FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND)
    private Date userEndTime;

    @ApiModelProperty(value = "优惠券是否被删除")
    private Boolean isDelete;

    @ApiModelProperty(value = "限定商品列表")
    private List<CouponProdDO> couponProdList;

    @ApiModelProperty(value = "限定商品列表")
    private List<CouponLineDO> couponLineList;
}
