package cn.iocoder.yudao.module.product.vo.coupon.record;

import lombok.*;

import java.math.BigDecimal;
import java.util.*;
import io.swagger.annotations.*;
import org.springframework.format.annotation.DateTimeFormat;

import static cn.iocoder.yudao.framework.common.util.date.DateUtils.FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND;

@ApiModel(value = "管理后台 - 优惠券使用记录 Excel 导出 Request VO", description = "参数和 CouponUseRecordPageReqVO 是一致的")
@Data
public class CouponUseRecordExportReqVO {

    @ApiModelProperty(value = "客户优惠券id")
    private Long couponCustomerId;

    @ApiModelProperty(value = "web端用户ID")
    private Long userId;

    @ApiModelProperty(value = "客户id")
    private Long customerId;

    @ApiModelProperty(value = "订单流水号")
    private String orderNumber;

    @ApiModelProperty(value = "金额")
    private BigDecimal amount;

    @DateTimeFormat(pattern = FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND)
    @ApiModelProperty(value = "开始使用时间")
    private Date beginUseTime;

    @DateTimeFormat(pattern = FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND)
    @ApiModelProperty(value = "结束使用时间")
    private Date endUseTime;

    @ApiModelProperty(value = "使用状态(1:冻结 2:已使用)")
    private Integer status;

}
