package cn.iocoder.yudao.module.product.vo.coupon.record;

import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.*;
import io.swagger.annotations.*;

import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotNull;
import java.math.BigDecimal;
import java.util.Date;

@ApiModel("管理后台 - 优惠券使用记录 Response VO")
@Data
@EqualsAndHashCode(callSuper = true)
@ToString(callSuper = true)
public class CouponUseRecordRespVO extends CouponUseRecordBaseVO {

    @ApiModelProperty(value = "优惠券使用记录id", required = true)
    private Long couponUseRecordId;

    @ApiModelProperty(value = "标题-中文")
    private String titleZh;

    @ApiModelProperty(value = "标题-英文")
    private String titleEn;

    @ApiModelProperty(value = "类型 1:优惠卷 2:金额-满减 3:方数-满减 4 折扣 5优惠 6 特价 7区间价")
    private Integer type;

    @ApiModelProperty(value = "使用条件(优惠卷专用)")
    private BigDecimal cashCondition;

    @ApiModelProperty(value = "减免金额(优惠卷专用)")
    private BigDecimal reduceAmount;

    @ApiModelProperty(value = "条件货币ID")
    private Integer conditionCurrencyId;

    @ApiModelProperty(value = "开始时间")
    @JsonFormat(pattern = "yyyy-MM-dd")
    private Date startTime;

    @ApiModelProperty(value = "减免货币ID")
    private Integer reduceCurrencyId;

    @ApiModelProperty(value = "结束时间")
    @JsonFormat(pattern = "yyyy-MM-dd")
    private Date endTime;

    @ApiModelProperty(value = "领券后X天起生效")
    private Integer afterReceiveDays;

    @ApiModelProperty(value = "有效天数")
    private Integer validDays;

    @ApiModelProperty(value = "费用类型：1 运输费 2 清关费 3 总费用(优惠卷专用)")
    private Integer costType;

    @ApiModelProperty(value = "优惠清单")
    private String discountDetailed;

}
