package cn.iocoder.yudao.module.product.vo.product;

import cn.iocoder.yudao.module.product.dal.dataobject.product.ProductPriceStepClearanceDO;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.ToString;
import org.apache.commons.lang3.StringUtils;

import java.math.BigDecimal;
import java.util.List;

@ApiModel("管理后台 - 批量商品更新 Request VO")
@Data
@ToString(callSuper = true)
public class ProductBatchUpdateReqVO {
    @ApiModelProperty(value = "默认货柜位置，字典container_location")
    private String containerLocation;

    @ApiModelProperty(value = "出运要求,1表示下单该类货物需要提供特定证书")
    private Integer requirements;

    @ApiModelProperty(value = "方数")
    private BigDecimal square;

    @ApiModelProperty(value = "空运重量上限")
    private BigDecimal airWeightLimit;

    @ApiModelProperty(value = "包装（字典packaging_type）")
    private String packaging;

    @ApiModelProperty(value = "是否需要预约入仓，0-否，1-是")
    private Integer needBook;

    @ApiModelProperty(value = "每日入仓上限")
    private BigDecimal dayLimit;

    @ApiModelProperty(value = "商品特性ID,多个以逗号分隔")
    private String attrId;

    @ApiModelProperty(value = "商品材质")
    private String materialType;

    private List<Long> idList;

    @ApiModelProperty(value = "为1，则是选择所有商品,不需要传idList，否则按照idList来传商品id列表")
    private Integer isAllProduct;

    @ApiModelProperty(value = "产品清关费阶梯价格列表")
    private List<ProductPriceStepClearanceDO> priceStepClearanceList;



    @ApiModelProperty(value = "是否复制模板线路价格, 与productTemplateId组合使用")
    private Boolean isCopyProductPriceTemplate = false;

    @ApiModelProperty(value = "产品线路价格模板id")
    private Long productTemplateId;

    public String getContainerLocation() {
        if(StringUtils.isEmpty(containerLocation)) containerLocation = null;
        return containerLocation;
    }

    public String getPackaging() {
        if(StringUtils.isEmpty(packaging)) packaging = null;
        return packaging;
    }

    public String getAttrId() {
        if(StringUtils.isEmpty(attrId)) attrId = null;
        return attrId;
    }

    public String getMaterialType() {
        if(StringUtils.isEmpty(materialType)) materialType = null;
        return materialType;
    }
}
