package cn.iocoder.yudao.module.product.vo.productBrandUnauthEmpower;

import lombok.*;
import java.util.*;
import io.swagger.annotations.*;
import com.alibaba.excel.annotation.ExcelProperty;
import cn.iocoder.yudao.framework.excel.annotations.DictFormat;
import cn.iocoder.yudao.framework.excel.convert.DictConvert;
import org.springframework.format.annotation.DateTimeFormat;

import static cn.iocoder.yudao.framework.common.util.date.DateUtils.FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND;

/**
* 商品品牌-未授权客户-指定收费标准 Response VO
* @author 江楠
*/
@Data
@ApiModel("管理后台 - 商品品牌-未授权客户-指定收费标准 Response VO")
public class ProductBrandUnauthEmpowerBackVO {

    @ExcelProperty("主键")
    @ApiModelProperty(value = "主键", required = true)
    private Long id;

    @ExcelProperty("商品品牌id")
    @ApiModelProperty(value = "商品品牌id", required = true)
    private Long productBrandId;

    @ExcelProperty("客户id")
    @ApiModelProperty(value = "客户id", required = true)
    private Long customerId;

    @ExcelProperty("客户联系人id")
    @ApiModelProperty(value = "客户联系人id", required = true)
    private Long customerContactsId;

    @ExcelProperty(value = "收费标准 0为无牌收费 1为有牌收费", converter = DictConvert.class)
    @DictFormat("customer_charging_model") // TODO 代码优化：建议设置到对应的 XXXDictTypeConstants 枚举类中
    @ApiModelProperty(value = "收费标准 0为无牌收费 1为有牌收费", required = true)
    private Integer feeScale;

    @ExcelProperty("创建人id")
    @ApiModelProperty(value = "创建人id", required = true)
    private Long createUserId;

    @ExcelProperty("创建人用户名")
    @ApiModelProperty(value = "创建人用户名", required = true)
    private String createUsername;

    @ExcelProperty("创建时间")
    @DateTimeFormat(pattern = FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND)
    @ApiModelProperty(value = "创建时间", required = true)
    private Date createTime;

}
