package cn.iocoder.yudao.module.product.vo.productPrice;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import javax.validation.constraints.NotNull;
import java.math.BigDecimal;
import java.util.Date;

/**
 * 路线产品 Base VO，提供给添加、修改、详细的子 VO 使用
 * 如果子 VO 存在差异的字段，请不要添加到这里，影响 Swagger 文档生成
 */
@Data
public class ProductPriceAirBaseVO extends ProductPriceReqBaseVO {

    @ApiModelProperty(value = "商品ID", required = true)
    @NotNull(message = "商品ID不能为空")
    private Long productId;

    @ApiModelProperty(value = "是否需要预约入仓，0-否，1-是")
    private Integer needBook;

    @ApiModelProperty(value = "是否单询，0-否，1-是")
    private Integer needOrderInquiry;


    @ApiModelProperty(value = "是否需要预付，0-不需要，1-需要")
    private Integer needPay;

    @ApiModelProperty(value = "单价模式，0-运费+清关费，1-全包价")
    private Integer priceType;

    @ApiModelProperty(value = "最小计费重量")
    private BigDecimal minWeight;

    @ApiModelProperty(value = "最小计费重量单位")
    private Long minWeightUnit;

    @ApiModelProperty(value = "有效开始时间")
    private Date validateStartDate;

    @ApiModelProperty(value = "有效结束时间")
    private Date validateEndDate;

    @ApiModelProperty(value = "重量上限")
    private BigDecimal weightLimit;

}
