package cn.iocoder.yudao.module.product.vo.productPrice;

import cn.iocoder.yudao.module.product.dal.dataobject.product.ProductPricePackagingDO;
import cn.iocoder.yudao.module.product.dal.dataobject.product.ProductPriceSpecialDO;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.ToString;

import java.math.BigDecimal;
import java.util.List;

@ApiModel("管理后台 - 海运批量加价")
@Data
@ToString(callSuper = true)
public class ProductPriceBatchAddPriceReqVo extends ProductPriceReqBaseVO {

    @ApiModelProperty(value = "运费")
    private BigDecimal transportPrice;

    @ApiModelProperty(value = "运费金额单位")
    private Long transportPriceUnit;

    @ApiModelProperty(value = "运费体积单位")
    private Long transportVolumeUnit;

    @ApiModelProperty(value = "清关费用")
    private BigDecimal clearancePrice;

    @ApiModelProperty(value = "清关金额单位")
    private Long clearancePriceUnit;

    @ApiModelProperty(value = "清关体积单位")
    private Long clearanceVolumeUnit;

    @ApiModelProperty(value = "全包价金额")
    private BigDecimal allPrice;

    @ApiModelProperty(value = "全包价金额单位")
    private Long allPriceUnit;

    @ApiModelProperty(value = "全包价体积单位")
    private Long allVolumeUnit;

    @ApiModelProperty(value = "特殊需求列表")
    private List<ProductPriceSpecialDO> specialList;

    @ApiModelProperty(value = "运费包装价格列表")
    private List<ProductPricePackagingDO> freightPricePackagingList;

    @ApiModelProperty(value = "清关费包装价格列表")
    private List<ProductPricePackagingDO> clearancePricePackagingList;

    @ApiModelProperty(value = "全包价包装价格列表")
    private List<ProductPricePackagingDO> fullPricePackagingList;

    @ApiModelProperty(value = "是否阶梯定价，0-不是，1-是")
    private Integer stepPrice;

    @ApiModelProperty(value = "单价模式，0-运费+清关费，1-全包价")
    private Integer priceType;

}
