package cn.iocoder.yudao.module.product.vo.productPrice;

import lombok.*;

import java.math.BigDecimal;
import java.util.*;
import io.swagger.annotations.*;
import org.springframework.format.annotation.DateTimeFormat;

import static cn.iocoder.yudao.framework.common.util.date.DateUtils.FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND;

@ApiModel(value = "管理后台 - 路线产品 Excel 导出 Request VO", description = "参数和 ProductPricePageReqVO 是一致的")
@Data
public class ProductPriceExportReqVO {

    @ApiModelProperty(value = "商品ID")
    private Long productId;

    @ApiModelProperty(value = "线路ID")
    private Long warehouseLineId;

    @ApiModelProperty(value = "出货渠道ID,空运才有，海运可以为空")
    private Long shippingChannelId;

    @ApiModelProperty(value = "运费")
    private BigDecimal transportPrice;

    @ApiModelProperty(value = "运费金额单位")
    private Long transportPriceUnit;

    @ApiModelProperty(value = "运费体积单位")
    private Long transportVolumeUnit;

    @ApiModelProperty(value = "清关费用")
    private BigDecimal clearancePrice;

    @ApiModelProperty(value = "清关金额单位")
    private Long clearancePriceUnit;

    @ApiModelProperty(value = "清关体积单位")
    private Long clearanceVolumeUnit;

    @ApiModelProperty(value = "是否预付")
    private Integer advanceStatus;

    @ApiModelProperty(value = "是否需要预约入仓，0-否，1-是")
    private Integer needBook;

    @ApiModelProperty(value = "是否单询，0-否，1-是")
    private Integer needOrderInquiry;

    @ApiModelProperty(value = "每日入仓上限")
    private BigDecimal dayLimit;

    @ApiModelProperty(value = "默认货柜位置，字典container_location")
    private String containerLocation;

    @ApiModelProperty(value = "默认方数")
    private BigDecimal square;

    @ApiModelProperty(value = "黑名单，0-否，1-是")
    private Integer blacklist;

    @ApiModelProperty(value = "审核状态，0-已审核，1-未审核")
    private Integer auditStatus;

    @ApiModelProperty(value = "代收货款，0-不支持，1-支持")
    private Integer payDelivery;

    @ApiModelProperty(value = "是否展示 默认为展示")
    private Integer status;

    @DateTimeFormat(pattern = FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND)
    @ApiModelProperty(value = "开始创建时间")
    private Date beginCreateTime;

    @DateTimeFormat(pattern = FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND)
    @ApiModelProperty(value = "结束创建时间")
    private Date endCreateTime;

}
