package cn.iocoder.yudao.module.product.vo.productPrice;

import cn.iocoder.yudao.module.product.dal.dataobject.product.ProductPricePackagingDO;
import cn.iocoder.yudao.module.product.dal.dataobject.product.ProductPriceSpecialDO;
import cn.iocoder.yudao.module.product.dal.dataobject.product.ProductPriceStepDO;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import javax.validation.constraints.Size;
import java.util.List;

@Data
public class ProductPriceReqBaseVO {

    @ApiModelProperty(value = "线路渠道列表", required = true)
    @Size(min = 1)
    private List<LineChannelVo> lineChannelList;

    @ApiModelProperty(value = "为1，则是选择所有商品，否则按照idList来传商品id列表", required = true)
    private Integer isAllProduct;

    public Integer getIsAllProduct() {
        if (isAllProduct == null) isAllProduct = 0;
        return isAllProduct;
    }

    @ApiModelProperty(value = "商品id列表")
    private List<Long> productIdList;

    @ApiModelProperty(value = "阶梯运费价格列表")
    private List<ProductPriceStepDO> freightPriceStepList;

    @ApiModelProperty(value = "阶梯清关费价格列表")
    private List<ProductPriceStepDO> clearancePriceStepList;

    @ApiModelProperty(value = "阶梯全包价格列表")
    private List<ProductPriceStepDO> fullPriceStepList;

    private boolean checkStepPrice = true;

    private boolean batch = false;
}
