package cn.iocoder.yudao.module.product.vo.productPrice;

import cn.iocoder.yudao.module.depository.dal.dataobject.warehouse.WarehouseLineDO;
import cn.iocoder.yudao.module.product.dal.dataobject.product.ProductDO;
import cn.iocoder.yudao.module.product.dal.dataobject.product.ProductPriceStepDO;
import lombok.*;
import java.util.*;
import io.swagger.annotations.*;

@ApiModel("管理后台 - 海运线路详情")
@Data
@EqualsAndHashCode(callSuper = true)
@ToString(callSuper = true)
public class ProductPriceRespVO extends ProductPriceBaseVO {
    @ApiModelProperty(value = "", required = true)
    private Long id;

    @ApiModelProperty(value = "创建时间", required = true)
    private Date createTime;

    @ApiModelProperty(value = "更新时间")
    private Date updateTime;

    private String creator;

    private String updater;

    @ApiModelProperty(value = "创建人")
    private String creatorName;

    @ApiModelProperty(value = "更新人")
    private String updaterName;

    /**
     * 查询时设置路线详情
     */
    private WarehouseLineDO warehouseLineDO;
    /**
     * 查询商品详情
     */
    private ProductDO productDO;

}
