package cn.iocoder.yudao.module.product.vo.productPriceSnapshot;

import lombok.*;
import java.util.*;
import io.swagger.annotations.*;
import com.alibaba.excel.annotation.ExcelProperty;
import org.springframework.format.annotation.DateTimeFormat;

import static cn.iocoder.yudao.framework.common.util.date.DateUtils.FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND;

/**
* 路线价格修改历史 Response VO
* @author wlh
*/
@Data
@ApiModel("管理后台 - 路线价格修改历史 Response VO")
public class ProductPriceSnapshotBackVO {

    @ExcelProperty("")
    @ApiModelProperty(value = "", required = true)
    private Long id;

    private Long priceId;

    @ExcelProperty("产品ID")
    @ApiModelProperty(value = "产品ID", required = true)
    private Long productId;

    @ExcelProperty("线路ID")
    @ApiModelProperty(value = "线路ID", required = true)
    private Long warehouseLineId;

    @ExcelProperty("出货渠道ID")
    @ApiModelProperty(value = "出货渠道ID")
    private Long shippingChannelId;

    @ExcelProperty("")
    @ApiModelProperty(value = "")
    private String content;

    @ExcelProperty("创建时间")
    @DateTimeFormat(pattern = FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND)
    @ApiModelProperty(value = "创建时间", required = true)
    private Date createTime;

    private String creatorName;

}
