package cn.iocoder.yudao.module.product.vo.productPriceSnapshot;

import lombok.*;
import java.util.*;
import io.swagger.annotations.*;
import cn.iocoder.yudao.framework.common.pojo.PageParam;
import org.springframework.format.annotation.DateTimeFormat;

import static cn.iocoder.yudao.framework.common.util.date.DateUtils.FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND;

@Data
@ApiModel("管理后台 - 路线价格修改历史查询 VO")
public class ProductPriceSnapshotQueryVO {

    @ApiModelProperty(value = "产品ID")
    private Long productId;

    @ApiModelProperty(value = "线路ID")
    private Long warehouseLineId;

    @ApiModelProperty(value = "出货渠道ID")
    private Long shippingChannelId;

    @ApiModelProperty(value = "")
    private String content;

    @DateTimeFormat(pattern = FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND)
    @ApiModelProperty(value = "开始创建时间")
    private Date beginCreateTime;

    @DateTimeFormat(pattern = FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND)
    @ApiModelProperty(value = "结束创建时间")
    private Date endCreateTime;

}
