package cn.iocoder.yudao.module.product.vo.productbrandempower;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.ToString;

import javax.validation.constraints.NotNull;

@ApiModel("管理后台 - 根据客户、商品查询指定商品备案模式，以及收费模式 Request VO。1.无备案：按无牌价N计算。" +
        "\n2.有备案有授权：品牌在系统内有备案，客户有授权,按无牌价N计算" +
        "\n3.有备案无授权：根据预先设置的授权模式，返回中性价格M或有牌价Y")
@Data
@EqualsAndHashCode()
@ToString(callSuper = true)
public class GetFeeTypeProductBrandEmpowerReqVO {

    @ApiModelProperty(value = "商品id,比如手机、手机壳等商品id", required = true,example = "1")
    @NotNull(message = "商品id不能为空")
    private Long productId;

    @ApiModelProperty(value = "品牌id,比如苹果，小米,为空或未0就是无备案",example = "2")
    private Long brandId;

    @ApiModelProperty(value = "非控货订单付款人客户id，控货订单控货人客户id")
//    @NotNull(message = "客户id不能为空")
    private Long customerId;


}
