package cn.iocoder.yudao.module.product.vo.productbrandempower;

import lombok.*;
import java.util.*;
import io.swagger.annotations.*;
import javax.validation.constraints.*;

/**
* 商品品牌授权 Base VO，提供给添加、修改、详细的子 VO 使用
* 如果子 VO 存在差异的字段，请不要添加到这里，影响 Swagger 文档生成
*/
@Data
public class ProductBrandEmpowerBaseVO {

    @ApiModelProperty(value = "商品品牌id", required = true)
    @NotNull(message = "商品品牌id不能为空")
    private Long productBrandId;

    @ApiModelProperty(value = "客户id", required = true)
    @NotNull(message = "客户id不能为空")
    private Long customerId;

    // @ApiModelProperty(value = "客户联系人id", required = true)
    // @NotNull(message = "客户联系人id不能为空")
    // private Long customerContactsId;

    @ApiModelProperty(value = "授权开始时间")
    private Date startTime;

    @ApiModelProperty(value = "授权结束时间")
    private Date endTime;

    @ApiModelProperty(value = "授权文件URL", required = true)
    @NotNull(message = "授权文件URL不能为空")
    private String fileUrl;

    @ApiModelProperty(value = "收费标准 0为无牌收费 1为有牌收费 2为中性收费", required = true)
    @NotNull(message = "收费标准不能为空")
    private Integer feeScale;

    @ApiModelProperty(value = "授权状态 1为未授权 0为已授权", required = true)
    @NotNull(message = "授权状态不能为空")
    private Integer status;

    @ApiModelProperty(value = "创建人id", required = true)
    @NotNull(message = "创建人id不能为空")
    private Long createUserId;

    @ApiModelProperty(value = "创建人用户名", required = true)
    @NotNull(message = "创建人用户名不能为空")
    private String createUsername;




}
