package cn.iocoder.yudao.module.product.vo.productbrandempower;

import lombok.*;
import java.util.*;
import io.swagger.annotations.*;
import javax.validation.constraints.*;

@ApiModel("管理后台 - 品牌创建授权客户 Request VO")
@Data
@EqualsAndHashCode()
@ToString(callSuper = true)
public class ProductBrandEmpowerCreateReqVO  {
    @ApiModelProperty(value = "商品品牌id", required = true)
    @NotNull(message = "商品品牌id不能为空")
    private Long productBrandId;

    @ApiModelProperty(value = "客户id", required = true)
    @NotNull(message = "客户id不能为空")
    private Long customerId;

    // @ApiModelProperty(value = "客户联系人id")
    // private Long customerContactsId;

    @ApiModelProperty(value = "授权开始时间")
    private Date startTime;

    @ApiModelProperty(value = "授权结束时间")
    private Date endTime;

    @ApiModelProperty(value = "授权文件URL", required = true)
    @NotNull(message = "授权文件URL不能为空")
    private String fileUrl;

    @ApiModelProperty(value = "收费标准 0为无牌收费 1为有牌收费", required = true)
    @NotNull(message = "收费标准 0为无牌收费 1为有牌收费不能为空")
    private Integer feeScale;

    @ApiModelProperty(value = "授权状态 1为未授权 0为已授权", required = true)
    @NotNull(message = "授权状态 1为未授权 0为已授权不能为空")
    private Integer status;

    @ApiModelProperty(value = "授权类型 0为长期 1为短期", required = true)
    private Integer authType;

}
