package cn.iocoder.yudao.module.product.vo.productbrandempower;

import lombok.*;
import java.util.*;

import com.alibaba.excel.annotation.ExcelProperty;
import cn.iocoder.yudao.framework.excel.annotations.DictFormat;
import cn.iocoder.yudao.framework.excel.convert.DictConvert;


/**
 * 商品品牌授权 Excel VO
 *
 * @author 江楠
 */
@Data
public class ProductBrandEmpowerExcelVO {

    @ExcelProperty("主键")
    private Long id;

    @ExcelProperty("商品品牌id")
    private Long productBrandId;

    @ExcelProperty("客户id")
    private Long customerId;

    @ExcelProperty("客户联系人id")
    private Long customerContactsId;

    @ExcelProperty("授权开始时间")
    private Date startTime;

    @ExcelProperty("授权结束时间")
    private Date endTime;

    @ExcelProperty("授权文件URL")
    private String fileUrl;

    @ExcelProperty(value = "收费标准 0为无牌收费 1为有牌收费", converter = DictConvert.class)
    @DictFormat("customer_charging_model") // TODO 代码优化：建议设置到对应的 XXXDictTypeConstants 枚举类中
    private Integer feeScale;

    @ExcelProperty(value = "授权状态 1为未授权 0为已授权", converter = DictConvert.class)
    @DictFormat("common_status") // TODO 代码优化：建议设置到对应的 XXXDictTypeConstants 枚举类中
    private Integer status;

    @ExcelProperty("创建人id")
    private Long createUserId;

    @ExcelProperty("创建人用户名")
    private String createUsername;

    @ExcelProperty("创建时间")
    private Date createTime;

}
