package cn.iocoder.yudao.module.product.vo.productbrank;

import cn.iocoder.yudao.module.product.vo.productbrandempower.ProductBrandEmpowerBaseVO;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.ToString;
import org.springframework.format.annotation.DateTimeFormat;

import javax.validation.constraints.NotNull;
import java.util.Date;

import static cn.iocoder.yudao.framework.common.util.date.DateUtils.FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND;

@ApiModel("管理后台 - 客户的品牌授权列表 ProductBrandMyEmpowerRespVO")
@Data
@EqualsAndHashCode()
@ToString(callSuper = true)
public class ProductBrandMyEmpowerRespVO{

    @ApiModelProperty(value = "商品品牌id", required = true)
    @NotNull(message = "商品品牌id不能为空")
    private Long productBrandId;


    @ApiModelProperty(value = "授权开始时间")
    private Date startTime;

    @ApiModelProperty(value = "授权结束时间")
    private Date endTime;

    @ApiModelProperty(value = "授权文件URL", required = true)
    @NotNull(message = "授权文件URL不能为空")
    private String fileUrl;

    @ApiModelProperty(value = "品牌中文标题")
    private String titleZh;

    @ApiModelProperty(value = "品牌英文标题")
    private String titleEn;

    @ApiModelProperty(value = "排序")
    private Integer aorder;

    @ApiModelProperty(value = "是否备案，字典")
    private String filing;

    @ApiModelProperty(value = "收费标准 0为无牌收费 1为有牌收费 2为中性收费", required = true)
    @NotNull(message = "收费标准不能为空")
    private Integer feeScale;

    @ApiModelProperty(value = "授权状态 1为未授权 0为已授权", required = true)
    @NotNull(message = "授权状态不能为空")
    private Integer status;

    @ApiModelProperty(value = "创建人id", required = true)
    @NotNull(message = "创建人id不能为空")
    private Long createUserId;

    @ApiModelProperty(value = "创建人用户名", required = true)
    @NotNull(message = "创建人用户名不能为空")
    private String createUsername;


    @ApiModelProperty(value = "创建时间")
    @DateTimeFormat(pattern = FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND)
    private Date createTime;
}
