package cn.iocoder.yudao.module.product.vo.productbrank;

import cn.iocoder.yudao.framework.common.pojo.PageParam;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.ToString;
import org.springframework.format.annotation.DateTimeFormat;

import static cn.iocoder.yudao.framework.common.util.date.DateUtils.FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND;

@ApiModel("管理后台 - 查询客户授权的品牌分页 Request VO")
@Data
@EqualsAndHashCode(callSuper = true)
@ToString(callSuper = true)
public class ProductBrankByCustomerPageReqVO extends PageParam {

    @ApiModelProperty(value = "品牌中文标题")
    private String titleZh;

    @ApiModelProperty(value = "品牌英文标题")
    private String titleEn;

    @ApiModelProperty(value = "排序")
    private Integer aorder;

    @ApiModelProperty(value = "是否备案，字典")
    private String filing;

    @ApiModelProperty(value = "后台客户id")
    private Long customerId;

//    @ApiModelProperty(value = "后台客户联系人id")
//    private Long customerContactId;


    @DateTimeFormat(pattern = FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND)
    @ApiModelProperty(value = "开始创建时间")
    private java.util.Date beginCreateTime;
    @DateTimeFormat(pattern = FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND)
    @ApiModelProperty(value = "结束创建时间")
    private java.util.Date endCreateTime;

}
