package cn.iocoder.yudao.module.product.vo.productbrank;

import lombok.*;

import com.alibaba.excel.annotation.ExcelProperty;
import cn.iocoder.yudao.framework.excel.annotations.DictFormat;
import cn.iocoder.yudao.framework.excel.convert.DictConvert;


/**
 * 品牌 Excel VO
 *
 * @author 江楠
 */
@Data
public class ProductBrankExcelVO {

    @ExcelProperty("主键ID")
    private Long id;

    @ExcelProperty("品牌中文标题")
    private String titleZh;

    @ExcelProperty("品牌英文标题")
    private String titleEn;

    @ExcelProperty("排序")
    private Integer aorder;

    @ExcelProperty(value = "是否备案，字典", converter = DictConvert.class)
    @DictFormat("brand_registry_type") // TODO 代码优化：建议设置到对应的 XXXDictTypeConstants 枚举类中
    private String filing;

    @ExcelProperty("创建时间")
    private java.util.Date createTime;

}
