//package cn.iocoder.yudao.module.product.controller.admin.coupon;
//
//import cn.iocoder.yudao.module.product.vo.coupon.content.*;
//import org.springframework.web.bind.annotation.*;
//import javax.annotation.Resource;
//import org.springframework.validation.annotation.Validated;
//import org.springframework.security.access.prepost.PreAuthorize;
//import io.swagger.annotations.*;
//
//import javax.validation.*;
//import javax.servlet.http.*;
//import java.util.*;
//import java.io.IOException;
//
//import cn.iocoder.yudao.framework.common.pojo.PageResult;
//import cn.iocoder.yudao.framework.common.pojo.CommonResult;
//import static cn.iocoder.yudao.framework.common.pojo.CommonResult.success;
//
//import cn.iocoder.yudao.framework.excel.util.ExcelUtils;
//
//import cn.iocoder.yudao.framework.operatelog.core.annotations.OperateLog;
//import static cn.iocoder.yudao.framework.operatelog.core.enums.OperateTypeEnum.*;
//
//import cn.iocoder.yudao.module.product.dal.dataobject.coupon.CouponContentDO;
//import cn.iocoder.yudao.module.product.convert.coupon.CouponContentConvert;
//import cn.iocoder.yudao.module.product.service.coupon.CouponContentService;
//
//@Api(tags = "管理后台 - 优惠券站内信息关联信息")
//@RestController
//@RequestMapping("/product/coupon-content")
//@Validated
//public class CouponContentController {
//
//    @Resource
//    private CouponContentService couponContentService;
//
//    @PostMapping("/create")
//    @ApiOperation("创建优惠券站内信息关联信息")
//    @PreAuthorize("@ss.hasPermission('product:coupon-content:create')")
//    public CommonResult<Long> createCouponContent(@Valid @RequestBody CouponContentCreateReqVO createReqVO) {
//        return success(couponContentService.createCouponContent(createReqVO));
//    }
//
//    @PutMapping("/update")
//    @ApiOperation("更新优惠券站内信息关联信息")
//    @PreAuthorize("@ss.hasPermission('product:coupon-content:update')")
//    public CommonResult<Boolean> updateCouponContent(@Valid @RequestBody CouponContentUpdateReqVO updateReqVO) {
//        couponContentService.updateCouponContent(updateReqVO);
//        return success(true);
//    }
//
//    @DeleteMapping("/delete")
//    @ApiOperation("删除优惠券站内信息关联信息")
//    @ApiImplicitParam(name = "id", value = "编号", required = true, example = "1024", dataTypeClass = Long.class)
//    @PreAuthorize("@ss.hasPermission('product:coupon-content:delete')")
//    public CommonResult<Boolean> deleteCouponContent(@RequestParam("id") Long id) {
//        couponContentService.deleteCouponContent(id);
//        return success(true);
//    }
//
//    @GetMapping("/get")
//    @ApiOperation("获得优惠券站内信息关联信息")
//    @ApiImplicitParam(name = "id", value = "编号", required = true, example = "1024", dataTypeClass = Long.class)
//    @PreAuthorize("@ss.hasPermission('product:coupon-content:query')")
//    public CommonResult<CouponContentRespVO> getCouponContent(@RequestParam("id") Long id) {
//        CouponContentDO couponContent = couponContentService.getCouponContent(id);
//        return success(CouponContentConvert.INSTANCE.convert(couponContent));
//    }
//
//    @GetMapping("/list")
//    @ApiOperation("获得优惠券站内信息关联信息列表")
//    @ApiImplicitParam(name = "ids", value = "编号列表", required = true, example = "1024,2048", dataTypeClass = List.class)
//    @PreAuthorize("@ss.hasPermission('product:coupon-content:query')")
//    public CommonResult<List<CouponContentRespVO>> getCouponContentList(@RequestParam("ids") Collection<Long> ids) {
//        List<CouponContentDO> list = couponContentService.getCouponContentList(ids);
//        return success(CouponContentConvert.INSTANCE.convertList(list));
//    }
//
//    @GetMapping("/page")
//    @ApiOperation("获得优惠券站内信息关联信息分页")
//    @PreAuthorize("@ss.hasPermission('product:coupon-content:query')")
//    public CommonResult<PageResult<CouponContentRespVO>> getCouponContentPage(@Valid CouponContentPageReqVO pageVO) {
//        PageResult<CouponContentDO> pageResult = couponContentService.getCouponContentPage(pageVO);
//        return success(CouponContentConvert.INSTANCE.convertPage(pageResult));
//    }
//
//    @GetMapping("/export-excel")
//    @ApiOperation("导出优惠券站内信息关联信息 Excel")
//    @PreAuthorize("@ss.hasPermission('product:coupon-content:export')")
//    @OperateLog(type = EXPORT)
//    public void exportCouponContentExcel(@Valid CouponContentExportReqVO exportReqVO,
//              HttpServletResponse response) throws IOException {
//        List<CouponContentDO> list = couponContentService.getCouponContentList(exportReqVO);
//        // 导出 Excel
//        List<CouponContentExcelVO> datas = CouponContentConvert.INSTANCE.convertList02(list);
//        ExcelUtils.write(response, "优惠券站内信息关联信息.xls", "数据", CouponContentExcelVO.class, datas);
//    }
//
//}
