//package cn.iocoder.yudao.module.product.controller.admin.coupon;
//
//import cn.iocoder.yudao.module.product.vo.coupon.customer.*;
//import org.springframework.web.bind.annotation.*;
//import javax.annotation.Resource;
//import org.springframework.validation.annotation.Validated;
//import org.springframework.security.access.prepost.PreAuthorize;
//import io.swagger.annotations.*;
//
//import javax.validation.constraints.*;
//import javax.validation.*;
//import javax.servlet.http.*;
//import java.util.*;
//import java.io.IOException;
//
//import cn.iocoder.yudao.framework.common.pojo.PageResult;
//import cn.iocoder.yudao.framework.common.pojo.CommonResult;
//import static cn.iocoder.yudao.framework.common.pojo.CommonResult.success;
//
//import cn.iocoder.yudao.framework.excel.util.ExcelUtils;
//
//import cn.iocoder.yudao.framework.operatelog.core.annotations.OperateLog;
//import static cn.iocoder.yudao.framework.operatelog.core.enums.OperateTypeEnum.*;
//
//import cn.iocoder.yudao.module.product.dal.dataobject.coupon.CouponCustomerDO;
//import cn.iocoder.yudao.module.product.convert.coupon.CouponCustomerConvert;
//import cn.iocoder.yudao.module.product.service.coupon.CouponCustomerService;
//
//@Api(tags = "管理后台 - 优惠券客户关联信息")
//@RestController
//@RequestMapping("/product/coupon-customer")
//@Validated
//public class CouponCustomerController {
//
//    @Resource
//    private CouponCustomerService couponCustomerService;
//
//    @PostMapping("/create")
//    @ApiOperation("创建优惠券客户关联信息")
//    @PreAuthorize("@ss.hasPermission('product:coupon-customer:create')")
//    public CommonResult<Long> createCouponCustomer(@Valid @RequestBody CouponCustomerCreateReqVO createReqVO) {
//        return success(couponCustomerService.createCouponCustomer(createReqVO));
//    }
//
//    @PutMapping("/update")
//    @ApiOperation("更新优惠券客户关联信息")
//    @PreAuthorize("@ss.hasPermission('product:coupon-customer:update')")
//    public CommonResult<Boolean> updateCouponCustomer(@Valid @RequestBody CouponCustomerUpdateReqVO updateReqVO) {
//        couponCustomerService.updateCouponCustomer(updateReqVO);
//        return success(true);
//    }
//
//    @DeleteMapping("/delete")
//    @ApiOperation("删除优惠券客户关联信息")
//    @ApiImplicitParam(name = "id", value = "编号", required = true, example = "1024", dataTypeClass = Long.class)
//    @PreAuthorize("@ss.hasPermission('product:coupon-customer:delete')")
//    public CommonResult<Boolean> deleteCouponCustomer(@RequestParam("id") Long id) {
//        couponCustomerService.deleteCouponCustomer(id);
//        return success(true);
//    }
//
//    @GetMapping("/get")
//    @ApiOperation("获得优惠券客户关联信息")
//    @ApiImplicitParam(name = "id", value = "编号", required = true, example = "1024", dataTypeClass = Long.class)
//    @PreAuthorize("@ss.hasPermission('product:coupon-customer:query')")
//    public CommonResult<CouponCustomerRespVO> getCouponCustomer(@RequestParam("id") Long id) {
//        CouponCustomerDO couponCustomer = couponCustomerService.getCouponCustomer(id);
//        return success(CouponCustomerConvert.INSTANCE.convert(couponCustomer));
//    }
//
//    @GetMapping("/list")
//    @ApiOperation("获得优惠券客户关联信息列表")
//    @ApiImplicitParam(name = "ids", value = "编号列表", required = true, example = "1024,2048", dataTypeClass = List.class)
//    @PreAuthorize("@ss.hasPermission('product:coupon-customer:query')")
//    public CommonResult<List<CouponCustomerRespVO>> getCouponCustomerList(@RequestParam("ids") Collection<Long> ids) {
//        List<CouponCustomerDO> list = couponCustomerService.getCouponCustomerList(ids);
//        return success(CouponCustomerConvert.INSTANCE.convertList(list));
//    }
//
//    @GetMapping("/page")
//    @ApiOperation("获得优惠券客户关联信息分页")
//    @PreAuthorize("@ss.hasPermission('product:coupon-customer:query')")
//    public CommonResult<PageResult<CouponCustomerRespVO>> getCouponCustomerPage(@Valid CouponCustomerPageReqVO pageVO) {
//        PageResult<CouponCustomerDO> pageResult = couponCustomerService.getCouponCustomerPage(pageVO);
//        return success(CouponCustomerConvert.INSTANCE.convertPage(pageResult));
//    }
//
//    @GetMapping("/export-excel")
//    @ApiOperation("导出优惠券客户关联信息 Excel")
//    @PreAuthorize("@ss.hasPermission('product:coupon-customer:export')")
//    @OperateLog(type = EXPORT)
//    public void exportCouponCustomerExcel(@Valid CouponCustomerExportReqVO exportReqVO,
//              HttpServletResponse response) throws IOException {
//        List<CouponCustomerDO> list = couponCustomerService.getCouponCustomerList(exportReqVO);
//        // 导出 Excel
//        List<CouponCustomerExcelVO> datas = CouponCustomerConvert.INSTANCE.convertList02(list);
//        ExcelUtils.write(response, "优惠券客户关联信息.xls", "数据", CouponCustomerExcelVO.class, datas);
//    }
//
//}
