//package cn.iocoder.yudao.module.product.controller.admin.coupon;
//
//import cn.iocoder.yudao.module.product.vo.coupon.line.*;
//import org.springframework.web.bind.annotation.*;
//import javax.annotation.Resource;
//import org.springframework.validation.annotation.Validated;
//import org.springframework.security.access.prepost.PreAuthorize;
//import io.swagger.annotations.*;
//
//import javax.validation.*;
//import javax.servlet.http.*;
//import java.util.*;
//import java.io.IOException;
//
//import cn.iocoder.yudao.framework.common.pojo.PageResult;
//import cn.iocoder.yudao.framework.common.pojo.CommonResult;
//import static cn.iocoder.yudao.framework.common.pojo.CommonResult.success;
//
//import cn.iocoder.yudao.framework.excel.util.ExcelUtils;
//
//import cn.iocoder.yudao.framework.operatelog.core.annotations.OperateLog;
//import static cn.iocoder.yudao.framework.operatelog.core.enums.OperateTypeEnum.*;
//
//import cn.iocoder.yudao.module.product.dal.dataobject.coupon.CouponLineDO;
//import cn.iocoder.yudao.module.product.convert.coupon.CouponLineConvert;
//import cn.iocoder.yudao.module.product.service.coupon.CouponLineService;
//
//@Api(tags = "管理后台 - 优惠券线路关联信息")
//@RestController
//@RequestMapping("/product/coupon-line")
//@Validated
//public class CouponLineController {
//
//    @Resource
//    private CouponLineService couponLineService;
//
//    @PostMapping("/create")
//    @ApiOperation("创建优惠券线路关联信息")
//    @PreAuthorize("@ss.hasPermission('product:coupon-line:create')")
//    public CommonResult<Long> createCouponLine(@Valid @RequestBody CouponLineCreateReqVO createReqVO) {
//        return success(couponLineService.createCouponLine(createReqVO));
//    }
//
//    @PutMapping("/update")
//    @ApiOperation("更新优惠券线路关联信息")
//    @PreAuthorize("@ss.hasPermission('product:coupon-line:update')")
//    public CommonResult<Boolean> updateCouponLine(@Valid @RequestBody CouponLineUpdateReqVO updateReqVO) {
//        couponLineService.updateCouponLine(updateReqVO);
//        return success(true);
//    }
//
//    @DeleteMapping("/delete")
//    @ApiOperation("删除优惠券线路关联信息")
//    @ApiImplicitParam(name = "id", value = "编号", required = true, example = "1024", dataTypeClass = Long.class)
//    @PreAuthorize("@ss.hasPermission('product:coupon-line:delete')")
//    public CommonResult<Boolean> deleteCouponLine(@RequestParam("id") Long id) {
//        couponLineService.deleteCouponLine(id);
//        return success(true);
//    }
//
//    @GetMapping("/get")
//    @ApiOperation("获得优惠券线路关联信息")
//    @ApiImplicitParam(name = "id", value = "编号", required = true, example = "1024", dataTypeClass = Long.class)
//    @PreAuthorize("@ss.hasPermission('product:coupon-line:query')")
//    public CommonResult<CouponLineRespVO> getCouponLine(@RequestParam("id") Long id) {
//        CouponLineDO couponLine = couponLineService.getCouponLine(id);
//        return success(CouponLineConvert.INSTANCE.convert(couponLine));
//    }
//
//    @GetMapping("/list")
//    @ApiOperation("获得优惠券线路关联信息列表")
//    @ApiImplicitParam(name = "ids", value = "编号列表", required = true, example = "1024,2048", dataTypeClass = List.class)
//    @PreAuthorize("@ss.hasPermission('product:coupon-line:query')")
//    public CommonResult<List<CouponLineRespVO>> getCouponLineList(@RequestParam("ids") Collection<Long> ids) {
//        List<CouponLineDO> list = couponLineService.getCouponLineList(ids);
//        return success(CouponLineConvert.INSTANCE.convertList(list));
//    }
//
//    @GetMapping("/page")
//    @ApiOperation("获得优惠券线路关联信息分页")
//    @PreAuthorize("@ss.hasPermission('product:coupon-line:query')")
//    public CommonResult<PageResult<CouponLineRespVO>> getCouponLinePage(@Valid CouponLinePageReqVO pageVO) {
//        PageResult<CouponLineDO> pageResult = couponLineService.getCouponLinePage(pageVO);
//        return success(CouponLineConvert.INSTANCE.convertPage(pageResult));
//    }
//
//    @GetMapping("/export-excel")
//    @ApiOperation("导出优惠券线路关联信息 Excel")
//    @PreAuthorize("@ss.hasPermission('product:coupon-line:export')")
//    @OperateLog(type = EXPORT)
//    public void exportCouponLineExcel(@Valid CouponLineExportReqVO exportReqVO,
//              HttpServletResponse response) throws IOException {
//        List<CouponLineDO> list = couponLineService.getCouponLineList(exportReqVO);
//        // 导出 Excel
//        List<CouponLineExcelVO> datas = CouponLineConvert.INSTANCE.convertList02(list);
//        ExcelUtils.write(response, "优惠券线路关联信息.xls", "数据", CouponLineExcelVO.class, datas);
//    }
//
//}
