//package cn.iocoder.yudao.module.product.controller.admin.coupon;
//
//import cn.iocoder.yudao.module.product.vo.coupon.prod.*;
//import org.springframework.web.bind.annotation.*;
//import javax.annotation.Resource;
//import org.springframework.validation.annotation.Validated;
//import org.springframework.security.access.prepost.PreAuthorize;
//import io.swagger.annotations.*;
//
//import javax.validation.*;
//import javax.servlet.http.*;
//import java.util.*;
//import java.io.IOException;
//
//import cn.iocoder.yudao.framework.common.pojo.PageResult;
//import cn.iocoder.yudao.framework.common.pojo.CommonResult;
//import static cn.iocoder.yudao.framework.common.pojo.CommonResult.success;
//
//import cn.iocoder.yudao.framework.excel.util.ExcelUtils;
//
//import cn.iocoder.yudao.framework.operatelog.core.annotations.OperateLog;
//import static cn.iocoder.yudao.framework.operatelog.core.enums.OperateTypeEnum.*;
//
//import cn.iocoder.yudao.module.product.dal.dataobject.coupon.CouponProdDO;
//import cn.iocoder.yudao.module.product.convert.coupon.CouponProdConvert;
//import cn.iocoder.yudao.module.product.service.coupon.CouponProdService;
//
//@Api(tags = "管理后台 - 优惠券商品关联信息")
//@RestController
//@RequestMapping("/product/coupon-prod")
//@Validated
//public class CouponProdController {
//
//    @Resource
//    private CouponProdService couponProdService;
//
//    @PostMapping("/create")
//    @ApiOperation("创建优惠券商品关联信息")
//    @PreAuthorize("@ss.hasPermission('product:coupon-prod:create')")
//    public CommonResult<Long> createCouponProd(@Valid @RequestBody CouponProdCreateReqVO createReqVO) {
//        return success(couponProdService.createCouponProd(createReqVO));
//    }
//
//    @PutMapping("/update")
//    @ApiOperation("更新优惠券商品关联信息")
//    @PreAuthorize("@ss.hasPermission('product:coupon-prod:update')")
//    public CommonResult<Boolean> updateCouponProd(@Valid @RequestBody CouponProdUpdateReqVO updateReqVO) {
//        couponProdService.updateCouponProd(updateReqVO);
//        return success(true);
//    }
//
//    @DeleteMapping("/delete")
//    @ApiOperation("删除优惠券商品关联信息")
//    @ApiImplicitParam(name = "id", value = "编号", required = true, example = "1024", dataTypeClass = Long.class)
//    @PreAuthorize("@ss.hasPermission('product:coupon-prod:delete')")
//    public CommonResult<Boolean> deleteCouponProd(@RequestParam("id") Long id) {
//        couponProdService.deleteCouponProd(id);
//        return success(true);
//    }
//
//    @GetMapping("/get")
//    @ApiOperation("获得优惠券商品关联信息")
//    @ApiImplicitParam(name = "id", value = "编号", required = true, example = "1024", dataTypeClass = Long.class)
//    @PreAuthorize("@ss.hasPermission('product:coupon-prod:query')")
//    public CommonResult<CouponProdRespVO> getCouponProd(@RequestParam("id") Long id) {
//        CouponProdDO couponProd = couponProdService.getCouponProd(id);
//        return success(CouponProdConvert.INSTANCE.convert(couponProd));
//    }
//
//    @GetMapping("/list")
//    @ApiOperation("获得优惠券商品关联信息列表")
//    @ApiImplicitParam(name = "ids", value = "编号列表", required = true, example = "1024,2048", dataTypeClass = List.class)
//    @PreAuthorize("@ss.hasPermission('product:coupon-prod:query')")
//    public CommonResult<List<CouponProdRespVO>> getCouponProdList(@RequestParam("ids") Collection<Long> ids) {
//        List<CouponProdDO> list = couponProdService.getCouponProdList(ids);
//        return success(CouponProdConvert.INSTANCE.convertList(list));
//    }
//
//    @GetMapping("/page")
//    @ApiOperation("获得优惠券商品关联信息分页")
//    @PreAuthorize("@ss.hasPermission('product:coupon-prod:query')")
//    public CommonResult<PageResult<CouponProdRespVO>> getCouponProdPage(@Valid CouponProdPageReqVO pageVO) {
//        PageResult<CouponProdDO> pageResult = couponProdService.getCouponProdPage(pageVO);
//        return success(CouponProdConvert.INSTANCE.convertPage(pageResult));
//    }
//
//    @GetMapping("/export-excel")
//    @ApiOperation("导出优惠券商品关联信息 Excel")
//    @PreAuthorize("@ss.hasPermission('product:coupon-prod:export')")
//    @OperateLog(type = EXPORT)
//    public void exportCouponProdExcel(@Valid CouponProdExportReqVO exportReqVO,
//              HttpServletResponse response) throws IOException {
//        List<CouponProdDO> list = couponProdService.getCouponProdList(exportReqVO);
//        // 导出 Excel
//        List<CouponProdExcelVO> datas = CouponProdConvert.INSTANCE.convertList02(list);
//        ExcelUtils.write(response, "优惠券商品关联信息.xls", "数据", CouponProdExcelVO.class, datas);
//    }
//
//}
