package cn.iocoder.yudao.module.product.controller.app.coupon;

import cn.iocoder.yudao.framework.i18n.core.I18nMessage;
import cn.iocoder.yudao.framework.mybatis.core.vo.PageVO;
import cn.iocoder.yudao.framework.security.core.annotations.PreAuthenticated;
import cn.iocoder.yudao.framework.security.core.util.SecurityFrameworkUtils;
import cn.iocoder.yudao.module.product.vo.coupon.customer.*;
import cn.iocoder.yudao.module.product.vo.coupon.record.CouponUseRecordPageReqVO;
import cn.iocoder.yudao.module.product.vo.coupon.record.CouponUseRecordRespVO;
import org.springframework.web.bind.annotation.*;
import javax.annotation.Resource;
import org.springframework.validation.annotation.Validated;
import org.springframework.security.access.prepost.PreAuthorize;
import io.swagger.annotations.*;

import javax.validation.*;
import javax.servlet.http.*;
import java.util.*;
import java.io.IOException;

import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.framework.common.pojo.CommonResult;
import static cn.iocoder.yudao.framework.common.pojo.CommonResult.success;

import cn.iocoder.yudao.framework.excel.util.ExcelUtils;

import cn.iocoder.yudao.framework.operatelog.core.annotations.OperateLog;
import static cn.iocoder.yudao.framework.operatelog.core.enums.OperateTypeEnum.*;

import cn.iocoder.yudao.module.product.dal.dataobject.coupon.CouponCustomerDO;
import cn.iocoder.yudao.module.product.convert.coupon.CouponCustomerConvert;
import cn.iocoder.yudao.module.product.service.coupon.CouponCustomerService;

@Api(tags = "app-web-优惠券使用记录")
@RestController
@RequestMapping("/product/coupon-customer")
@Validated
public class AppCouponCustomerController {

    @Resource
    private CouponCustomerService couponCustomerService;
//
//    @PostMapping("/create")
//    @ApiOperation("领取优惠劵")
//    @PreAuthorize("@ss.hasPermission('product:coupon-customer:create')")
//    public CommonResult<Long> createCouponCustomer(@Valid @RequestBody CouponCustomerCreateReqVO createReqVO) {
//        return success(couponCustomerService.createCouponCustomer(createReqVO));
//    }


    @GetMapping("/page")
    @ApiOperation("用户优惠劵分页列表")
    @PreAuthenticated
    public CommonResult<PageResult<CouponCustomerRespVO>> getCouponCustomerPage(PageVO page, @RequestParam(value = "status", required = false) Integer status) {
        CouponCustomerPageReqVO reqVO = new CouponCustomerPageReqVO();
        if (status != null){
            reqVO.setStatus(status);
        }
        reqVO.setLang(I18nMessage.getLang());
        reqVO.setUserId(SecurityFrameworkUtils.getLoginUserId());
//        PageResult<CouponCustomerRespVO> pageResult = couponCustomerService.userCouponPage(page, reqVO);
//        return success(pageResult);
        // TODO 展示屏蔽优惠劵列表数据
        return success(new PageResult<>());
    }


}
